<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */
// No direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.controllerform');

/**
 * Part controller class.
 */
class NgeControllerPart extends JControllerForm
{

    function __construct() {
        $this->view_list = 'parts';
        parent::__construct();
    }

    // Check for request forgeries.
    // 		JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
    
    public function render(){
	//result is html
    	echo $this->_render('render');
    	exit();	
    }
    public function preview(){
	//result is html
    	echo $this->_render('preview');
    	exit();
    }	
    public function generate(){
	//result is json object
    	echo json_encode($this->_render('generate'));
    	exit();    	    	
    }
    public function help(){
	//result is html
    	echo $this->_render('help');
    	exit();
    }	
    
    protected function _render($renderingMode){
    	$jinput = JFactory::getApplication()->input;
    	$mode =					$jinput->get('mode', '', 'string');
    	$plname = 				$jinput->get('plname', '','string'); //Part library id
    	$pk = 					$jinput->get('pk', '', 'int'); //Existing part id
    	$includeLibraries =			$jinput->get('include_libraries', '1', 'int'); //Existing part id
    	$model = $this->getModel();

    	if ($plname != ''){ //Creation mode, part library id
    		$name = $plname;
    	}else if ($pk != '') //Modification mode, part id
    		$name = '['.$pk.']';
    
    	//If mode == edit, create, duplicate, we are in the config screen, in live preview, live params are in the url
    	//Otherwise, no url params, normal rendering => only database params
    	if (($mode == 'edit') || ($mode == 'create') || ($mode == 'duplicate'))
    		$urlparams = json_encode($_REQUEST);
    	else
    		$urlparams = '';
    
    	//Normal rendering for an existing part, all params in database
    	switch ($renderingMode){	    
		case 'preview': //In config screen
			require_once NGEPATH_HELPERS . '/ngecontenthelper.php';	
			$result = $model->render($name, $renderingMode, $urlparams);
                                            //Load common scripts and stylesheets for the current part		
			//TOTO, scripts are always included, because of content.prepare call in the part model.
			if ($includeLibraries == '1'){ //Include libraries when first preview
			    $result = NgeContenthelper::renderScripts() . $result;
			    $result = NgeContenthelper::renderStyleSheets() . $result;
			}
                                            return $result;
                                            break;
		case 'render': //Normal rendering. Scripts are added together in the content plugin
    			return $model->render($name, $renderingMode, $urlparams);
    			break;
    		case 'generate':
    			return $model->generate($name, $urlparams);
                                            break;
		case 'help':
    			return $model->help($name, $urlparams);
                                            break;
    	}
    }
    
    public function save($key = NULL, $urlVar = NULL)
    {
    	//Warning. See also back controller : administrator/components/com_nge/controllers/part.php
    	$app = JFactory::getApplication();
    	
     	// Check for request forgeries.
        // 04/11/14 BT : token is in nge_params var, must extract it in a $_REQUEST['token'] var
        if (isset($_REQUEST['ngeinternal'])){ 
    	
    		parse_str( $_REQUEST['ngeinternal'],$data_ngeinternal);
         	$token = JSession::getFormToken();
         	if(isset($data_ngeinternal[$token])) {
  	$_POST[$token] = $data_ngeinternal[$token];
	//TODO this line is necessary on some websites. Why?
                $app->input->post->set($token, 1);
 			}
        }	
        
        $result = array();
       	if (!JSession::checkToken() ){
      		$result["result"] = "0";  // Saving result is not OK : session problem
       		$result["message"] = JText::_('SESSION_EXPIRED');
       		echo json_encode($result);
       		exit();    		
       	}
    	$jinput = JFactory::getApplication()->input;
    	$medium = $jinput->get('medium', '', 'string');    	 
    	$medium_id = $jinput->get('medium_id', '', 'int');
    	
    	$model = $this->getModel();
    	$return = $model->save($_REQUEST);
    	if ($return) {
    		//If caller is an editor, we return the part id
	   
            $caller = $jinput->get('caller', '');
	    $callerArray = explode('.', $caller); //Caller can be jce, jck, layout.page, layout.article...
	    //Here we nedd only first part (jce, or layout)
	    //$caller = $callerArray[0];
            $editors = array('tinymce','jce','jck','ckeditor');
		//Caller is Joomla! editor. "part" tag is sent back
    		if (in_array($caller,$editors) ){
    			$result["result"] = "1"; //Saving result is OK
			$result["idpart"] = $model->idpart;
			//$result["htmlpart"] = '<part data-class="'.str_replace('.','-',$model->part_category).'" data-part="'.$model->idpart.'">&nbsp;</part>';
			$result["htmlpart"] = '<part data-class="'.$model->part_category.'" data-part="'.$model->idpart.'">&nbsp;</part>';                
			print(json_encode($result));
			exit(); 
    		}
    		else
		//Caller is inline editing (front or layout). Preview is sent back
    		if (in_array($callerArray[0], array('front','layout')) || $caller=='ckeditor.inline'){
    			require_once NGEPATH_HELPERS . '/ngecontenthelper.php';
    			require_once NGEPATH_HELPERS . '/ngeparthelper.php';
    			$result["pk"] = $model->idpart;
    			$result["result"] = "1"; //Saving result is OK
    			//Sending back all html to be replaced in the parent sreen
				//Full part html
				//Rendering always in edit mode
				$params = array();
				$params['rendering_mode'] = 'edit';
				$result["html"] = NgePartHelper::render('['.$model->idpart.']', $params);
				//Scripts and styles, only if creation
				if (!(isset($_REQUEST['pk']) && $_REQUEST['pk'] != '')){
				    $result["html"] = NgeContenthelper::renderScripts() . $result["html"];
				    $result["html"] = NgeContenthelper::renderStyleSheets() . $result["html"];
				}
				
				// create nge_module if in creation and part dropped in postion
				if($callerArray[1]=='position' && ( !(isset($_REQUEST['pk']) && $_REQUEST['pk'] != '') )) {
					$module_create = $this->create_nge_module($result["pk"], $jinput->get('position',0), $jinput->get('plname'), $jinput->get('m_before_id',0) );
					if($module_create['result'] == true)
						$result['m_id'] = $module_create['m_id'];
						$result['html'] = $module_create['html'];
						$result['title'] = $module_create['title'];
						$result['module'] = $module_create['module'];
						$result['position'] = $module_create['position'];
				}			

    			echo json_encode($result);
    			exit();
    		}
    		else
    		if ($callerArray[0] == 'ngepart') {
    			$result["pk"] = $model->idpart;
    			$result["result"] = "1"; //Saving result is OK
				$result["plname"] = $jinput->get('plname');
    			echo json_encode($result);
    			exit();
								
				
			}
//     		else
//     		{ //Caller is screen
//     			if($_GET['mode']=='create'){
// 					$app = JFactory::getApplication();
// 					$app->redirect(JRoute::_('index.php?option=com_nge&view='.$medium.'&id='.$medium_id.'&Itemid='.$_GET['Itemid']));
//     			}
//     			else {		
//     				$result["result"] = "1"; //Saving result is OK
//     				print(json_encode($result));
//     				exit();    				
//     			}
//     		}	
    	}
    	else {
    		$result["result"] = "0"; //Saving result is OK, or session problem
    		$result["message"] = 'Error while saving Part';
    		print(json_encode($result));
    		exit();    		
    	}    	
    }
    
    public function updateParams() {
    	require_once NGEPATH_HELPERS . '/ngeparthelper.php';
    	
    	$result = array();
    	$result["success"] = 0;
    	
    	$pk 	= $_POST['pk'];
    	$params = $_POST['params'];
    	
    	$part = NgePartHelper::getPart($pk);
    	$part->mergeParams($params);

    	if ($part->save()){
    		$result["success"] = 1;
    		$result["message"] = "Saved";
    	}else{
    		$result["success"] = 0;
    		$result["message"] = "Error to saved";
    	}
    	
    	print(json_encode($result));
    	exit();
    }
    
    /**
     * NgeControllerPart::update()
     * 
     * @return void
     */
    public function update() {

        $part_model = JModelAdmin::getInstance('part','NgeModel');
        $jinput = JFactory::getApplication()->input;
        $pk = 	$jinput->get('pk');
        
        $result = array();
    
    	// id part non trouvés dans l'url, erreur et interruption du script
    	if(!$pk) {
    		$result["result"] = "0";  // Saving result is not OK : session problem
    		$result["message"] = "No part id in key";
    		print(json_encode($result));
    		exit();
    	}

        
        // put nge content query in array
        $query = urldecode($jinput->get("ngecontent",'post','raw'));
        $query_content_properties=array();
        parse_str($query,$query_content_properties);
        
        if(count($query_content_properties)) {
            $params = $part_model->load_part_content($pk);

            if(!$params) {
        		$result["result"] = "0";  // Saving result is not OK : session problem
        		$result["message"] = "error - No content params found";
        		print(json_encode($result));
                
                exit();
            }
            $obj_params = json_decode($params,true);
            
            $new_obj_params = array_merge($obj_params,$query_content_properties);
            
            $params = json_encode($new_obj_params);
    
            //$part_model->savepart_params($part_id,$params);
            $part_model->savepart_content($pk,$params);
        }
        
        // put nge params query in array
        $query = urldecode($jinput->get("ngeparams",'post','raw'));
        $query_params_properties=array();
        parse_str($query,$query_params_properties);

        if(count($query_params_properties)) {
            $params = $part_model->load_part_params($pk);
            
            if(!$params) {
        		$result["result"] = "0";  // Saving result is not OK : session problem
        		$result["message"] = "error - No params params found";
        		print(json_encode($result));
                exit();
            }
            $obj_params = json_decode($params,true);
            
            $new_obj_params = array_merge($obj_params,$query_params_properties);
            
            $params = json_encode($new_obj_params);
    
            //$part_model->savepart_params($part_id,$params);
            $part_model->savepart_params($pk,$params);
                        
        }        

        $result["result"] = "1";  // Saving result is not OK : session problem
   		print(json_encode($result));
        exit();
    }

        /**
     * NgeControllerPart::addcontent()
     * 
     * @return void
     */
    public function addcontent() {
        
       $part_model = $this->getModel();
        $jinput = JFactory::getApplication()->input;
        $pk = 	$jinput->get('pk');
	$return = false;
        
        $result = array();
    
    	// id part non trouvés dans l'url, erreur et interruption du script
    	if(!$pk) {
    		$result["result"] = "0";  // Saving result is not OK : session problem
    		$result["message"] = "No part id in key";
    		print(json_encode($result));
    		exit();
    	}

        
        // put nge content query in array
        $query = urldecode($jinput->get("ngecontent",'post','raw'));
        $query_content_properties=array();
        parse_str($query,$query_content_properties);

        if(count($query_content_properties)) {
            $contentParams = $part_model->load_part_content($pk);
	
            if(!$contentParams) {
        		$result["result"] = "0";  // Saving result is not OK : session problem
        		$result["message"] = "error - No content params found";
        		print(json_encode($result));
                
                exit();
            }
            $paramsArray = json_decode($contentParams,true);

	//Searching count value
	$count = $paramsArray['count'];
	    $count++;
	    $paramsArray['count'] = $count;
	    foreach($query_content_properties as $key=>$value){
		$paramsArray[$key.'s'][$count] = $value;
	    }
            //$new_obj_params = array_merge($obj_params,$query_content_properties);
            
            $contentParams = json_encode($paramsArray);
    
            //$part_model->savepart_params($part_id,$params);
            $return = $part_model->savepart_content($pk,$contentParams);
        }        

        if ($return) {
    		//If caller is an editor, we return the part id
	   
            $caller = $jinput->get('caller', '');
	    $callerArray = explode('.', $caller); //Caller can be jce, jck, layout.page, layout.article...
	    //Here we nedd only first part (jce, or layout)
	    $caller = $callerArray[0];
            $editors = array('tinymce','jce','jck');
		//Caller is inline editing (front or layout). Preview is sent back
    		if (in_array($caller, array('front','layout'))){
    			require_once NGEPATH_HELPERS . '/ngecontenthelper.php';
    			require_once NGEPATH_HELPERS . '/ngeparthelper.php';
    			$result["pk"] = $pk;
    			$result["result"] = "1"; //Saving result is OK
    			//Sending back all html to be replaced in the parent sreen
				//Full part html
     			$result["html"] = NgePartHelper::render('['.$pk.']');
				//Scripts and styles, only if creation
				if (!(isset($_REQUEST['pk']) && $_REQUEST['pk'] != '')){
				    $result["html"] = NgeContenthelper::renderScripts() . $result["html"];
				    $result["html"] = NgeContenthelper::renderStyleSheets() . $result["html"];
				}
				
    			echo json_encode($result);
    			exit();
    		}
    	}
    	else {
    		$result["result"] = "0"; //Saving result is OK, or session problem
    		$result["message"] = 'Error while saving Part';
    		print(json_encode($result));
    		exit();
    		
    	}    	
    }

    
    public function duplicate($key = NULL, $urlVar = NULL)
    {
        require_once(JPATH_COMPONENT.'/helpers/ngeparthelper.php');
    	$parthelper = new NgePartHelper();
    	
    	$jinput = JFactory::getApplication()->input;

    	$medium = 			$jinput->get('medium', '', 'string');
    	$medium_id = 		$jinput->get('medium_id', '', 'int'); //New destination. If not : default one = last one
    	//$publication_id = 	$jinput->get('publication_id', '', 'int');
    	$part_id = 			$jinput->get('pk', '', 'int');
    	$return = 			$jinput->get('return', '', 'string');

    	$model = $this->getModel();
    	$idPart = $parthelper->duplicate($part_id, $medium, $medium_id, $return);
    
    	if ($idPart){
    		if ($return == 'preview'){
//    			echo $result;
//    			JFactory::getApplication()->close();
    			require_once NGEPATH_HELPERS . '/ngecontenthelper.php';
    			require_once NGEPATH_HELPERS . '/ngeparthelper.php';
    			$result = array();
    			$result["pk"] = $idPart;
    			$result["result"] = "1"; //Saving result is OK
    			//Sending back all html to be replaced in the parent sreen
    			$result["html"] = NgePartHelper::render('['.$idPart.']');
	   		print(json_encode($result));
    			exit();
    		}else if ($return == 'wireframe'){
    			require_once NGEPATH_HELPERS . '/ngecontenthelper.php';
    			require_once NGEPATH_HELPERS . '/parts/renderer/wireframe.php';
    			$document	= JFactory::getDocument();
    			$renderer 	= new JDocumentRendererWireframe($document);
    			
    			$result = array();
			    $result["pk"] = $idPart;
			    $result["result"] = "1";
			 $result["html"] = $renderer->render('['.$idPart.']');
			 print(json_encode($result));
		        exit();
    		}else{	
    			if  ($idPart){
    				echo "1";
    				JFactory::getApplication()->close();
    			}
    		}
    	}
    	 
    	$app = JFactory::getApplication();
    //	if ($medium == 'workshop')
	  //  	$app->redirect(JRoute::_('index.php?option=com_nge&view=workshop&id='.$medium_id.'&Itemid='.$_GET['Itemid']));
    	 
       
    }
    
     /**
     * NgeControllerPart::storeproperty()
     * store a string into a part property, can by "content" type ("content" field in the database) or "params" type ("params" field in the database)
     * @return success/failure
     */
    public function storeproperty() {

	$partModel = JModelAdmin::getInstance('part', 'NgeModel');
	$result = array();
	//TODO TOKEN fonctione pas
// 	if (!JSession::checkToken()) {
// 	    $result["result"] = "0";  // Saving result is not OK : session problem
// 	    $result["message"] = JText::_('SESSION_EXPIRED');
// 	    print(json_encode($result));
// 	    exit();
// 	}
	$jinput = JFactory::getApplication()->input;

	$pk =		intval($_POST['pk']);
	$type =		$_POST['type'] == 'content' ? 'content' : 'params';
	$property =	(string) $_POST['property'];
	//$value =		urldecode($_POST['value']);
	$value =		(string) $_POST['value'];
	$callback =	$jinput->get('callback', '', 'string');

	// part id not found
	if (!$pk) {
	    $result["result"] = "0";  // Saving result is not OK : session problem
	    $result["message"] = "No part id in key";
	    print(json_encode($result));
	    exit();
	}
	$result['result'] = $partModel->storeProperty($pk, $type, $property, $value);

	//For preview return while inlineediting
	switch ($callback) {
	    case 'html' :
		$result['callback'] = $data->content->html;
		break;
	    case 'article' :
		require_once (JPATH_ROOT . '/components/com_nge/helpers/data/joomla/articledriver.php');
		$article = ArticleDriver::load($value);
		$result['callback'] = $article->introtext;
		break;
	    case 'module' :
		require_once (JPATH_ROOT . '/components/com_nge/helpers/data/joomla/moduledriver.php');
		$result['callback'] = ModuleDriver::load($value);
		break;
	    case 'url' :
		require_once (JPATH_ROOT . '/components/com_nge/helpers/data/url/urldriver.php');
		$result['callback'] = UrlDriver::getContents($value);
		break;
	}
// if string data-part found, there is part in part, reload the page
// else return the value
//    	$has_parts = strpos($value, 'data-part');
//     	if(!$has_parts)
//     		$result['success'] = 'ok';
//     	else
//     		$result['success'] = 'reload';

	print(json_encode($result));
	exit();
    }
     
    /**
     * NgeControllerPart::getFormFieldContent()
     * Update field into a form in ajax
     * @return success/failure
     */
    public function updateFormFieldContent() {
    	
    	$result 	= array();
    	$partModel 	= JModelAdmin::getInstance('part','NgeModel');
    	$nameForm = (isset($_POST['nameForm'])) ? $_POST['nameForm'] : "";
    	$pathForm = (isset($_POST['pathForm'])) ? $_POST['pathForm'] : "";
    	$nameField 	= (isset($_POST['nameField'])) ? $_POST['nameField'] : "";
    	$newValue 	= (isset($_POST['newValue'])) ? $_POST['newValue'] : "";

    	$result['result'] = $partModel->getFieldContent($nameForm, $pathForm, $nameField, $newValue);
    
    	print(json_encode($result));
    	exit();
    }
    
    /**
     * NgeControllerPart::updateItem()
     * Update items for part multiple
     * @return object
     */
    public function updateItem() {
    	//TODO voir si on créer plutot un controller part multiple et une class ngePartMultiple extend to ngePart  
    	switch ($_REQUEST['part_type']) {
    		case "navigation.list":
    			require_once (JPATH_ROOT . '/components/com_nge/classes/frontediting/ngenavigationlist.php');
    			$part_navigation_list = new NgeNavigationList($_REQUEST['pk']); 
    			$status = $part_navigation_list->updateItem($_REQUEST);
    		break;
    		case "navigation.menu":
    			require_once (JPATH_ROOT . '/components/com_nge/classes/frontediting/ngenavigationmenu.php');
    			$part_navigation_menu = new NgeNavigationList($_REQUEST['pk']); 
    			$status = $part_navigation_menu->updateItem($_REQUEST);
    		break;
    		case "panels.tabs":
    			require_once (JPATH_ROOT . '/components/com_nge/classes/frontediting/ngepanelstabs.php');
    			$part_panels_tabs = new NgePanelsTabs($_REQUEST['pk']);
    			$status = $part_panels_tabs->updateItem($_REQUEST);
    		break;
    	}
    	
    	print(json_encode($status));
    	exit();
    }
    
    /**
     * NgeControllerPart::saveToPosition()
     * 
     * @return void
     */
    public function savetoposition() {
        $model = $this->getModel();
        $jinput = JFactory::getApplication()->input;
        
        $pk = $jinput->get('pk','','int');
       	// id part non trouvés, erreur et interruption du script
    	if(!$pk) {
    		$result["result"] = "0";  // Saving result is not OK : session problem
    		$result["message"] = "No part id in key";
    		print(json_encode($result));
    		exit();
    	}
        $part = $model->getPart($pk);

		// create nge_module
        $result['pk'] = $pk;
        $result['position'] = $jinput->get('end_position','');
		$module_create = $this->create_nge_module($part->id, $jinput->get('end_position',''), $part->name, $jinput->get('m_before_id',0) );
		if($module_create['result'] == true) {
		    $result['m_id'] = $module_create['m_id'];
		    $result['result'] = 1;
			$result['html'] = $module_create['html'];
            $result['title'] = $module_create['title'];
            $result['module'] = $module_create['module'];
            $result['position'] = $module_create['position'];
        }
        else
        {
		    $result['result'] = 0;
			$result['html'] = '';
            
        }
        
    	print(json_encode($result));
    	exit();
    }
    
    
    /**
     * NgeControllerPart::create_nge_module()
     * Create a module when part drop in a position
     * @param mixed $part_id
     * @param mixed $position
     * @return
     */
    public function create_nge_module($part_id, $position, $plname,$module_before=0) {
    	
    	$model = $this->getModel('module','NgeModel');
    	$model->setState('extension.element','mod_nge');
		$mod = $model->getItem();
		
		// module title = NGE_partname_part_id
		$plname_explode = explode('.',$plname);
		$module_title = 'NGE_'.$plname_explode[count($plname_explode)-1].'_'.$part_id;
		
		
		
		// complete module values
		$mod->title = $module_title;
        $mod->ordering = 1; // default ordering = first
		// get module ordering
		if($module_before!=0) {
			$prev_module = $model->getItem($module_before);
			
			if($prev_module) {
				$mod->ordering = $prev_module->ordering;
			}
		}
        $mod->position = $position;
        $mod->published = 1;
        $mod->showtitle = 0;
        $mod->params['id'] = $part_id;
        $mod->params['module_tag'] = 'div';
        $mod->params['bootstrap_size'] = '0';
        $mod->params['header_tag'] = 'h3';
        $mod->params['style'] = '0';
        
        // convert jobject to jregistry
        $jreg_module = new JRegistry();
        $jreg_module->loadObject($mod);
        
        // save module
        if($model->save($jreg_module->toArray())) {
			$return['result'] = true;
			// rendering module
			$document = JFactory::getDocument();
			$renderer = $document->loadRenderer('module');
			$mod_to_render = JModuleHelper::getModule($mod->module, $mod->title);

			// If the module without the mod_ isn't found, try it with mod_.
			// This allows people to enter it either way in the content
			if (!isset($mod_to_render)) {
			    $name = 'mod_' . $module;
			    $mod_to_render = JModuleHelper::getModule($name, $title);
			}

			//$params = new JRegistry();
			//$params->loadString($mod_to_render->params); //array('style' => 'none');
            $attribs['style'] = 'xhtml';
			$return["m_id"] = $mod_to_render->id;

			$j = new JRegistry();
			$j->loadString($mod_to_render->params);
			$j->set('prepare_content',0);
			
			$mod_to_render->params = $j->toString();
			$content = JModuleHelper::renderModule( $mod_to_render, $attribs );
	        $params = new JObject();
	        $params->set('medium','modulepreview');
	        $return["html"] = JHtml::_('content.prepare',$content,$params);
			
            $return['title'] = $mod->title;
            $return['module'] = $mod->module;
            $return['position'] = $mod->position;
		}
        else
            $return['result'] =  false;
		
		
		return $return;
	}
    
}