<?php

/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */
// No direct access.
defined('_JEXEC') or die;

jimport('joomla.application.component.modeladmin');

/**
 * Nge model.
 */
class NgeModelPart extends JModelAdmin {

    /**
     * @var		string	The prefix to use with controller messages.
     * @since	1.6
     */
    protected $text_prefix = 'COM_NGE';
    public $idpart = 0;
    public $part_category = '';

    public function render($name, $renderingmode = 'render', $urlparams = '') {
	//Loading part params
	require_once NGEPATH_HELPERS . '/ngepartshelper.php';
	$jinput = JFactory::getApplication()->input;
	
	//If $urlparams empty : reading from database
	//If not empty, params transmitted by the config screen.
	//No database reading. Only Memory.
	//Calling getPart constructor without part id => default part object created
	$part = NgePartsHelper::getPart($name);
	
	/*In config view this code is required to create only one ID when preview is launch*/
/*	$partId = json_decode($urlparams)->pk;
	if($part->id == 0 && $partId != "")
		$part->id = $partId;
*/
	$part->rendering = new stdClass();
	$part->rendering->mode = $renderingmode; //in preview mode, some stuff need to be desactivated (for example clic event on button preview)
	$part->rendering->libraries = $jinput->get('include_libraries', 1); //Include or not external javascript libraries (for example
	//The part parameters are overriden by the values passed in the url
	//content and params properties are mixed : no problem, they will be binded
	//print_r($urlparams);
	if ($urlparams != '')
	    $part->params = $urlparams;

	//Renderering part
	require_once NGEPATH_HELPERS . '/parts/renderer/default.php';
	//		$attribs = array('style' => 'view');
	ob_start();
	//Loading part content
	//$previewContent = NgePartHelper::render($part);
	$previewContent = NgePartRendererDefault::render($part);
	//Applying content plugins, for recursive others parts included, and for other content plugins
	
	$params = new stdClass();
	$params->medium = 'config';
	$previewContent = JHtml::_('content.prepare', $previewContent, $params);
	echo $previewContent;
	$result = ob_get_clean();

	return $result;
    }

    public function generate($name, $urlparams = '') {
	//Loading part params
	require_once NGEPATH_HELPERS . '/ngepartshelper.php';
	$document = JFactory::getDocument();

	//If $urlparams empty : reading from database
	//If not empty, params transmitted by the config screen.
	//No database reading. Only Memory.
	//Calling getPart constructor without part id => default part object created
	$part = NgePartsHelper::getPart($name);

	//The part parameters are overriden by the values passed in the url
	//content and params properties are mixed : no problem, they will be binded
	//print_r($urlparams);
	if ($urlparams != '')
	    $part->content = $urlparams;
	$generate = new StdClass();
	$generate->html = 'YYYYYYYYYYYYY';
	$generate->result = '1';
	$generate->message = 'Génération OK';
	//Renderering part
	require_once NGEPATH_HELPERS . '/parts/renderer/generate.php';
	$renderer = new JDocumentRendererGenerate($document);
	//		$attribs = array('style' => 'view');
	//Launching Generate
	//ob_start();
	//$renderer->generate($part);
	//$result = ob_get_clean();
	$generationObject = $renderer->generate($part);
	return $generationObject;
    }

		
    /**
     * Saving part
     *
     */
    public function save($data) {

	JPluginHelper::importPlugin('nge');
	$dispatcher = JEventDispatcher::getInstance();
	$result = $dispatcher->trigger( 'onPartBeforeSave', array( &$data) );
	if (in_array(false, $result, true))
	    return false;
	//$data['content_values']= htmlentities($data['content_values'],UTF-8);
	//
		//print_r($_GET);
	//$pk = $data['pk'];
	if (isset($data['pk']))
	    $pk = $data['pk'];
	else
	    $pk = '';
	if (isset($data['plname']))
	    $plname = $data['plname'];
	else
	    $plname = '';
	if (isset($data['medium']))
	    $medium = $data['medium'];
	else
	    $medium = '';
	if (isset($data['medium_id']))
	    $medium_id = $data['medium_id'];
	else
	    $medium_id = '';
	if (isset($data['mode']))
	    $mode = $data['mode'];
	else
	    $mode = '';

	// decoding params values
	if (isset($data['ngecontent']))
	    parse_str($data['ngecontent'], $data_ngecontent);
	else
	    $data_ngecontent = '';
	if (isset($data['ngeparams']))
	    parse_str($data['ngeparams'], $data_ngeparams);
	else
	    $data_ngeparams = '';
	if (isset($data['ngedisplay']))
	    parse_str($data['ngedisplay'], $data_ngedisplay);
	else
	    $data_ngedisplay = '';
	if (isset($data['ngeinternal']))
	    parse_str($data['ngeinternal'], $data_ngeinternal);
	else
	    $data_ngeinternal = '';

	if (isset($data_ngecontent['title']))
	    $title = $data_ngecontent['title'];
	else
	    $title = '';
	unset($data_ngecontent['title']);
       
	if (isset($data_ngecontent['alias']))
	    $alias = $data_ngecontent['alias'];
	else
	    $alias = JApplication::stringURLSafe($title);

	//if (isset($data['access']['display']))	$access = 	$data['access']['display'];		else	$access = 1;
	if (isset($data['publish']['published']))
	    $published = $data['publish']['published'];
	else
	    $published = 1;

	$alias = JApplication::stringURLSafe($alias);
	$this->idpart = $pk;

	//data will be saved as params field
	//These are not params properties
	unset($data['title']);
	unset($data['params']);
	unset($data['option']);
	unset($data['task']);
	unset($data['Itemid']);
	unset($data['pk']);
	unset($data['plname']);
	unset($data['medium']);
	unset($data['medium_id']);

	//TODO, le contrôle ne doit pas être ici, mais dans le part config avant l'appel de l'url
	//controle du contenu de la table si exist

	if (isset($data_ngecontent['content_input_values'])) {

	    //print($data['content_values']);
	    //exit();
	    //  $content = json_decode($data_ngecontent['content_input_values']);
	    //$data_ngecontent['content_input_values'] =  htmlspecialchars($data_ngecontent['content_input_values']);
	    //print_r(json_encode($content));    
	    /*   $content_nettoye = array();
	      foreach($content as $row) {
	      $isok = true;

	      if($row[0]==null)
	      $row[0] = '';

	      //TODO Pb accents, cf handsontable ?
	      $row[0]= htmlentities($row[0]);

	      if($row[1]==null)
	      $isok = false;

	      if ($isok)
	      $content_nettoye[] = $row;

	      } */
	    //$data_ngecontent['content_input_values'] =  json_encode($content_nettoye);
	    $data_ngecontent['content_input_values'] = json_decode($data_ngecontent['content_input_values']);
	    //    echo('<br />'.json_last_error());
	    //  print($data['content_values']);
	    //exit();  
	    $data['rows'] = count($data_ngecontent['content_input_values']);
	}
	//print_r($data);
	// content field
	$registry = new JRegistry;
	$registry->loadArray($data_ngecontent);

	$content = (string) $registry;


	// params field
	//options and display inputs of the config screen are saved in the params field
	$registry = new JRegistry;
	$registry->loadArray($data_ngeparams);
	$registry->loadArray($data_ngedisplay);

	if(isset($data_ngeinternal['ngeversion'])){
		$registry->set('ngeversion', $data_ngeinternal['ngeversion']);
	}
	
	$params = (string) $registry;

	// bt 04-11-14 - add user_id in table
	$user = JFactory::getUser();

	$save_result = false;

	//Existing part, updating params and resetting cache fields
	if (($pk != '') && ($mode != 'duplicate')) {
	    $sql = "UPDATE #__nge_parts SET title = '" . addslashes($title) . "', alias = '" . $alias . "', published = " . $published . ",content = '" . addslashes($content) . "', params = '" . addslashes($params) . "', html='', css='', js='', modified=NOW(), modified_by='" . $user->id . "' WHERE id=" . $pk;	    
	    $db = JFactory::getDBO();
	    $db->setQuery($sql);
	    $save_result = $db->execute();
		
		//Remove cache
		/*
		if ($part->cachable == true){
				$cache = JFactory::getCache('com_nge', '');
				$cacheId = 'part-'.$part->id.'-view'; 
				$cache->remove($part->content, $cacheId);
				$cacheId = 'part-'.$part->id.'-edit'; 
				$cache->remove($part->content, $cacheId);
		}*/
		
		
	} else
	if (($plname != '') || ($mode == 'duplicate') || ($mode == 'create')) {//Creating a new part
	    //Loading part library
	    $db = JFactory::getDBO();
	    $query = $db->getQuery(true);
	    if ($mode == 'duplicate') {
		$query->select(array('part'));
		$query->from('#__nge_parts');
		$query->where('id=' . $pk);
	    } else {
		$query->select(array('part'));
		$query->from('#__nge_parts_library');
		$query->where('part="' . $plname . '"');
		$query->where('state=1');
	    }
	    $db->setQuery($query);
	    $result = $db->loadObject();
	    $partname = $result->part;


	    //Creating part
	    $query = $db->getQuery(true);
	    $columns = array('part', 'title', 'alias', 'content', 'params', 'language', 'published', 'created', 'created_by');
	    $values = array("'" . $partname . "', '" . addslashes($title) . "', '" . $alias . "', '" . addslashes($content) . "', '" . addslashes($params) . "', '*'", $published, 'NOW()', $user->id);
	    $query->insert($db->quoteName('#__nge_parts'))
		    ->columns($db->quoteName($columns))
		    ->values(implode(',', $values));
	    $db->setQuery($query);
	    $result = $db->query();
	    $this->idpart = $db->insertid();

	    //If medium exists, the new part must be created in the medium 
	    //Searching the new part id
	    if ($medium != '') {
		$query = $db->getQuery(true);
		$query
			->select('id')
			->from('`#__nge_parts`')
			->order('ID Desc')
			->limit('0,1');
		$db->setQuery($query);
		$row = $db->loadObject();
		$this->idpart = $row->id;



		//Assigning the new part to the medium
		if (($medium == 'workshop') && ($medium_id != '')) {
		    $query = $db->getQuery(true);
		    $columns = array('id_parution', 'id_part', 'actif');
		    $values = array($medium_id, $this->idpart, 1);
		    $query
			    ->insert($db->quoteName('#__nge_parution_parts'))
			    ->columns($db->quoteName($columns))
			    ->values(implode(',', $values));

		    // Set the query using our newly populated query object and execute it.
		    $db->setQuery($query);
		    $result = $db->query();
		}
	    }
	    $save_result = $result;
	    

	$dispatcher->trigger( 'onPartAfterSave', array( $this->idpart) );	
	    
	} else
	    $save_result = false;

	    // complete property $part_category
	if($save_result) {
		$sql = "SELECT part FROM #__nge_parts WHERE id=$this->idpart";
		$db->setQuery($sql);
		$this->part_category = $db->loadResult();
		
	}
	//print($$db->getQuery());
	//exit();
	// table assets pour les droits d'accès
//         if($save_result!=false) {
//             $asset = new JTableAsset($this->_db);
//             $asset->loadByName('com_nge.part.'.$pk);
//             $asset_parent = new JTableAsset($this->_db);
//             $asset_parent->loadByName('com_nge');
//             if(!$asset->id) {
//                 $asset->setLocation($asset_parent->id,'last-child');
//                 $asset->name = 'com_nge.part.'.$pk;
//                 $asset->parent_id = $asset_parent->id;
//                 $asset->title = $asset->name;
//                 $asset->level = 1;
//             }
//             $asset->rules = '{"core.edit.content":{"'.$data['access']['content'].'":1},"core.edit.option":{"'.$data['access']['options'].'":1}}';
//             if(!$asset->check())
//                 print('error');
//             $asset->store();
//         }
	
	
	return $save_result;
    }

    /**
     * Method to remove one part 
     *
     * @return	boolean	Success
     */
    public function remove($idPart) {
	
	JPluginHelper::importPlugin('nge');
	$dispatcher = JEventDispatcher::getInstance();
	$result = $dispatcher->trigger( 'onPartBeforeDelete', array( $idPart ) );	
	if (in_array(false, $result, true))
		return false;
	
	if ($idPart == null)
	    return false;

	//Read content to search parts and delete.

	$db = JFactory::getDbo();
	$query = $db->getQuery(true);

	$query->delete($db->quoteName('#__nge_parts'))
		->where('id=' . $idPart);
	$db->setQuery($query);
	$result = $db->query();

	if ($result)
	    $dispatcher->trigger( 'onPartAfterDelete', array( $idPart) );	
	return $result;
    }

    /**
     * Abstract method for getting the form from the model.
     *
     * @param   array    $data      Data for the form.
     * @param   boolean  $loadData  True if the form is to load its own data (default case), false if not.
     *
     * @return  mixed  A JForm object on success, false on failure
     *
     * @since   12.2
     */
    public function getForm($data = array(), $loadData = true) {
	
    }

    /**
     * NgeModelpart::load_part_content()
     * Load params field
     * @param mixed $part_id
     * @return
     */
    public function load_part_content($part_id) {
	$db = JFactory::getDBO();
	$sql = "SELECT content FROM #__nge_parts WHERE id=$part_id";
	$db->setQuery($sql);

	$result = $db->loadResult();

	return $result;
    }

    /**
     * NgeModelpart::load_part_params()
     * Load params field 
     * @param mixed $part_id
     * @return
     */
    public function load_part_params($part_id) {
	$db = JFactory::getDBO();
	$sql = "SELECT params FROM #__nge_parts WHERE id=$part_id";
	$db->setQuery($sql);

	$result = $db->loadResult();

	return $result;
    }

    /**
     * NgeModelpart::savepart_content()
     * save params field
     * @param mixed $part_id
     * @param mixed $params
     * @return
     */
    public function savepart_content($part_id, $content) {
        $user = JFactory::getUser();
        $user_id = $user->id;
	$db = JFactory::getDBO();
	$sql = "update  #__nge_parts SET content ='" . addslashes($content) . "', modified=NOW(), modified_by=$user_id WHERE id=$part_id";
	$db->setQuery($sql);
	$result = $db->Query();

	return $result;
    }

    /**
     * 
     * @param integer $partId : id of the part where to modify property
     * @param string $propertyType : type of param : "content" or "params"
     * @param string $propertyPath : path of the property. use "." between object properties
     * @param string $value : value of the property
     * @return boolean
     */
    public function getProperty($partId, $propertyType, $propertyPath) {

	//Property key contains the property path separated by - Example : content.header.label
	$keys = explode('.', $propertyPath);

	// If no key, error and stopping script
	if (count($keys) == 0) {
	    print('error - No property key defined');
	    exit();
	}
	
	// loading corresponding params
	$db = JFactory::getDBO();
	if ($propertyType == 'content') {
	    $sql = "SELECT content FROM #__nge_parts WHERE id=" . $partId;

	    $db->setQuery($sql);
	    $currentContent = $db->loadResult();

	    if (!$currentContent) {
		print('error - No content found');
		exit();
	    }

	    $content = json_decode($currentContent, true);

	    //$content is an array of arrays.
	    //searching the corresponding pointer (notice & reference)
	    $propertyPointer = & $content;

	    for ($i = 0; $i < count($keys); $i++) {
		$propertyPointer = & $propertyPointer[$keys[$i]];
	    }
	    $result = $propertyPointer;
	} else
	if ($propertyType == 'params') {
	    $sql = "SELECT params FROM #__nge_parts WHERE id=" . $partId;
	    $db->setQuery($sql);
	    $currentParams = $db->loadResult();

	    if (!$currentParams) {
		print('error - No params found');
		exit();
	    }

	    $params = json_decode($currentParams, true);
	    //$content is an array of arrays.
	    //searching the corresponding pointer (notice & reference)
	    $propertyPointer = & $params;
	    for ($i = 0; $i < count($keys); $i++) {
		$propertyPointer = & $propertyPointer[$keys[$i]];
	    }
	    $result = $propertyPointer;
	} else
	    return false;

	return $result;
    }

    /**
     * 
     * @param integer $partId : id of the part where to modify property
     * @param string $propertyType : type of param : "content" or "params"
     * @param string $propertyPath : path of the property. use "." between object properties
     * @param string $value : value of the property
     * @return boolean
     */
    public function storeProperty($partId, $propertyType, $propertyPath, $value) {
        $user = JFactory::getUser();
        $user_id = $user->id;
	$db = JFactory::getDBO();

	//Property key contains the property path separated by - Example : content.header.label
	$keys = explode('.', $propertyPath);

	// If no key, error and stopping script
	if (count($keys) == 0) {
	    print('error - No property key defined');
	    exit();
	}

	// loading corresponding params
	if ($propertyType == 'content') {
	    $sql = "SELECT content FROM #__nge_parts WHERE id=" . $partId;
	    $db->setQuery($sql);
	    $currentContent = $db->loadResult();

	    if (!$currentContent) {
		print('error - No content found');
		exit();
	    }

	    $content = json_decode($currentContent, true);
	    //$content is an array of arrays.
	    //searching the corresponding pointer (notice & reference)
	    $propertyPointer = & $content;

	    for ($i = 0; $i < count($keys); $i++) {
		$propertyPointer = & $propertyPointer[$keys[$i]];
	    }

	    $propertyPointer = $value;
	    $newContent = json_encode($content);

	    //saving
	    $sql = "update  #__nge_parts SET content ='" . addslashes($newContent) . "', modified=NOW(), modified_by=$user_id WHERE id=$partId";
	    $db->setQuery($sql);
	    $result = $db->Query();
	} else
	if ($propertyType == 'params') {
	    $sql = "SELECT params FROM #__nge_parts WHERE id=" . $partId;
	    $db->setQuery($sql);
	    $currentParams = $db->loadResult();

	    if (!$currentParams) {
		print('error - No params found');
		exit();
	    }

	    $params = json_decode($currentParams, true);
	    //$content is an array of arrays.
	    //searching the corresponding pointer (notice & reference)
	    $propertyPointer = & $params;
	    for ($i = 0; $i < count($keys); $i++) {
		$propertyPointer = & $propertyPointer[$keys[$i]];
	    }
	    $propertyPointer = $value;
	    $newParams = json_encode($params);

	    //saving
	    $sql = "update  #__nge_parts SET params ='" . addslashes($newParams) . "', modified=NOW(), modified_by=$user_id WHERE id=$partId";
	    $db->setQuery($sql);
	    $result = $db->Query();
	} else
	    return false;

	return $result;
    }
    
    
    
    /**
     * NgeModelpart::savepart_params()
     * save params field
     * @param mixed $part_id
     * @param mixed $params
     * @return
     */
    public function savepart_params($part_id, $params) {
        $user = JFactory::getUser();
        $user_id = $user->id;

	$db = JFactory::getDBO();
	$sql = "update  #__nge_parts SET params ='" . addslashes($params) . "', modified=NOW(), modified_by=$user_id WHERE id=$part_id";
	$db->setQuery($sql);

	$result = $db->Query();

	return $result;
    }

    /**
     * NgeModelpart::getFieldContent()
     * @return new field content
     */
    public function getFieldContent($nameForm, $pathForm, $nameField, $newValue) {
	require_once NGEPATH_HELPERS . '/ngeparthelper.php'; //Used in each config file to load the part form

	$field_content = "";

	$jform = NgePartHelper::loadFormAjax($nameForm, $pathForm, $nameField, $newValue);

	$field_content = $jform->getInput((string) $nameField);

	return $field_content;
    }

    /**
     * NgeModelpart::getPart()
     * 
     * @param mixed $pk
     * @return
     */
    public function getPart($pk) {
	$db = JFactory::getDBO();

	$db->setQuery('SELECT * FROM #__nge_parts WHERE id=' . $pk);

	return $db->loadObject();
    }

}
