<?php
/**
 * @version     1.0.0
 * @package     com_nge
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com 
 */
defined('_JEXEC') or die;
?>
<form id="optionsform" class="form-horizontal ngeoptionsform">
    <div class="headconfigtitle"><?php echo NGE::translate('COM_NGE_OPTIONS'); ?>    
    <?php
    if (NGE::features('config.patterns')) {
	echo NGEFields::radio('options.source', 'COM_NGE_STYLE', 'COM_NGE_DESCRIPTION_OPTIONSSOURCE', 'custom', array(
	    array('custom', 'COM_NGE_CUSTOM', 'data-target="#customoptions"'),
	    array('pattern', 'COM_NGE_PATTERN', 'data-target="#field_options_pattern"')
	));	
    }
    ?>
	</div>
	<?php if (NGE::features('config.patterns')){ ?>
	    <div id="patternoptions">
		<div class="headconfigbar"></div>
		<?php echo NGEFields::pattern('options.pattern', 'COM_NGE_PATTERN', 'COM_NGE_DESCRIPTION_PATTERN', 'part', 'images.image'); ?>
	    </div>
	<?php } ?>	        			
    <div id="customoptions">
	<?php
	if (NGE::features('config.patterns')) {
	    echo NGEFields::formtopattern('#customoptions', 'part', 'images.image');
	}
	?>
	<ul class="nav nav-tabs headconfigbar" data-tabs="tabs">
	    <li class="active"><a href="#tabimage" data-toggle="tab"><?php echo NGE::translate('COM_NGE_CONTENT_IMAGE') ?></a></li>			
	    <li><a href="#tabcaption" data-toggle="tab"><?php echo NGE::translate('COM_NGE_CONTENT_CAPTION') ?></a></li>				
	    <li><a href="#tabheader" data-toggle="tab"><?php echo NGE::translate('COM_NGE_TITLE'); ?></a></li>				
	    <?php
	    if (NGE::features('nge.essential'))
		echo '<li><a href="#tablegend" data-toggle="tab">' . NGE::translate('COM_NGE_CONTENT_LEGEND') . '</a></li>';
	    ?>
	    <li><a href="#tabmainpanel" data-toggle="tab"><?php echo NGE::translate('COM_NGE_MAIN_PANEL') ?></a></li>				
	</ul>
	<div class="tab-content">
	    <div class="tab-pane active" id="tabimage">
		<?php		
		if (NGE::features('nge.essential'))
		    echo NgeFields::formlayout('parts.core.image', 'imageOptions', '');
		
		if (NGE::features('nge.premium'))
		    echo NgeFields::formlayout('parts.core.effects', 'imageEffects', 'body.effects');
		?>
	    </div>			
	    <div class="tab-pane" id="tabcaption">	    
		<?php if (NGE::features('nge.essential')) { ?>
    		<div class="tabbable tabs-left">
    		    <ul id="tabs" class="nav nav-tabs" data-tabs="tabs">
    			<li class="active"><a href="#tabcaptiondisplay" data-toggle="tab"><?php echo NGE::translate('COM_NGE_DISPLAY') ?></a></li>	
    			<li><a href="#tabcaptionfont" data-toggle="tab"><?php echo NGE::translate('COM_NGE_FONT') ?></a></li>
    			<li><a href="#tabcaptionborder" data-toggle="tab"><?php echo NGE::translate('COM_NGE_BORDER') ?></a></li>
    			<li><a href="#tabcaptionbackground" data-toggle="tab"><?php echo NGE::translate('COM_NGE_BACKGROUND') ?></a></li>
			<?php if (NGE::features('nge.premium')){  ?>	
    			<li><a href="#tabcaptioneffects" data-toggle="tab"><?php echo NGE::translate('COM_NGE_EFFECTS') ?></a></li>
			<?php }  ?>
    		    </ul>
    		    <div class="tab-content">
    			<div class="tab-pane active" id="tabcaptiondisplay">       
				<?php echo NgeFields::formLayout('parts.core.image', 'captionDisplay', 'caption'); ?>
    			</div>
    			<div class="tab-pane" id="tabcaptionfont">
				<?php echo NgeFields::formLayout('parts.core.image', 'captionFont', 'caption'); ?>
    			</div>
    			<div class="tab-pane" id="tabcaptionborder">
				<?php echo NgeFields::formLayout('parts.core.base', 'border', 'caption.border'); ?>
    			</div>
    			<div class="tab-pane" id="tabcaptionbackground">
				<?php echo NgeFields::formLayout('parts.core.base', 'background', 'caption.background'); ?>
    			</div>
			<?php if (NGE::features('nge.premium')) { ?>
    			<div class="tab-pane" id="tabcaptioneffects">
				<?php echo NgeFields::formLayout('parts.core.effects', 'captionEffects', 'caption.effects'); ?>
    			</div>
			<?php }  ?>
    		    </div>
    		</div>
		<?php
		} else {
		    //Free default settings (white text on black background)
		    //Defined here to stay used if further upgrade in essential formula or mode
		    echo NgeFields::hidden('caption.font.style', 'custom');
		    echo NgeFields::hidden('caption.font.color', '#ffffff');
		    echo NgeFields::hidden('caption.background.style', 'solid');
		    echo NgeFields::hidden('caption.background.color', '#000000');
		    echo NgeFields::hidden('caption.background.opacity', '50');
		    
		    echo NgeFields::formLayout('parts.core.image', 'captionDisplay', 'caption');
		}
		?>	    
	    </div>
	    <?php if (NGE::features('nge.essential')) { ?>	
    	    <div class="tab-pane" id="tablegend">
		    <?php echo NgeFields::formLayout('parts.core.config_legend', 'config_legend', ''); ?>	
    	    </div>
	    <?php } ?>
	    <div class="tab-pane" id="tabheader">
		<?php echo NgeFields::formLayout('parts.core.config_header', 'config_header', ''); ?>	
	    </div>		
	    <div class="tab-pane" id="tabmainpanel">
		<div class="tabbable tabs-left">
		    <ul id="tabs" class="nav nav-tabs" data-tabs="tabs">
			<li class="active"><a href="#tabpanelborder" data-toggle="tab"><?php echo NGE::translate('COM_NGE_BORDER'); ?></a></li>
			<li><a href="#tabpanelbackground" data-toggle="tab"><?php echo NGE::translate('COM_NGE_BACKGROUND'); ?></a></li>
			<li><a href="#tabpanelshadow" data-toggle="tab"><?php echo NGE::translate('COM_NGE_SHADOW'); ?></a></li>							
		    </ul>
		    <div class="tab-content">							
			<div class="tab-pane active" id="tabpanelborder">
			    <?php echo NgeFields::formLayout('parts.core.base', 'border', 'border'); ?>		
			</div>
			<div class="tab-pane" id="tabpanelbackground">
			    <?php echo NgeFields::formLayout('parts.core.base', 'background', 'background'); ?>			
			</div>
			<div class="tab-pane" id="tabpanelshadow">
			    <?php echo NgeFields::formLayout('parts.core.base', 'shadow', 'shadow'); ?>				
			</div>
		    </div>
		</div>
	    </div>
	</div>
    </div>
</form>