<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */
// no direct access
defined('_JEXEC') or die;

// elfinder php file required
require_once NGEPATH_MEDIA . '/elfinder/php/autoload.php';

//Directories
//autorized directory list for elfinder
$directories_authorized = array("images");

// directory ask in get or post from field ngefilemanager, by default : images
$ask_directory = JFactory::getApplication()->input->get('current_directory','images');	

// directory control if ask directory start with one of the autorized directories
$dirlist = explode('/', $ask_directory);
$directory = (in_array($dirlist[0], $directories_authorized)) ? $ask_directory : "images";

// Url and path relative to access to the current folder
$current_path_relatif = JPATH_SITE . '/' . $directory . '/';
$current_url_relatif = JURI::root().$directory;

// Url and path relative to load thumb cache
if(!is_dir(JPATH_SITE . "/cache/nge")){
        mkdir(JPATH_SITE . "/cache/nge", 0755);
}
if(!is_dir(JPATH_SITE . "/cache/nge/elfinder")){
        mkdir(JPATH_SITE . "/cache/nge/elfinder", 0755);
}

$thumb_path_relatif = JPATH_SITE . "/cache/nge/elfinder";
$thumb_url_relatif = NGEURL_ROOT . "cache/nge/elfinder";


//Mime types	
//$filesType = JFactory::getApplication()->input->get('current_type', '');
//switch ($filesType) {
//    case 'video':
//        $mimeType = ["video"]; // display all images
//        break;
//    case 'image':
//        $mimeType = ["image"]; // display all videos
//        break;
//    case 'audio':
//        $mimeType = ["image"]; // display all videos
//        break;
//    case 'flash':
//        $mimeType = ["application/x-shockwave-flash"];
//        break;	    
//    case 'pdf':
//        $mimeType = ["application/pdf"];
//        break;	    
//    default	:
//        $mimeType = '';
//        break;
//}

//$uploadAllow = "";
//switch ($directory) {
//    case "documents":
//        /* text, application */
//        $uploadAllow = array('application, text');
//    break;
//
//    default: /* Image¨*/
//        $uploadAllow = array('image');
//    break;
//}
//
// Documentation for connector options:
// https://github.com/Studio-42/elFinder/wiki/Connector-configuration-options
$opts = array(
    'roots' => array(
        array(
            'driver'        => 'LocalFileSystem',   // driver for accessing file system (REQUIRED)
            'path'          => $current_path_relatif,         // path to files (REQUIRED)
            'URL'           => $current_url_relatif, // URL to files (REQUIRED)
            'uploadTempPath' => $thumb_path_relatif, //Path relative because we are outside the current server. LOcked access to this folder if inside the current path folder
            'commonTempPath ' => $thumb_path_relatif, //Path relative because we are outside the current server. LOcked access to this folder if inside the current path folder
            'tmbPath' => $thumb_path_relatif, //Path relative because we are outside the current server. LOcked access to this folder if inside the current path folder
            'tmbURL'  => $thumb_url_relatif, //Url relative because we are outside the current server.
	'tmbSize'  => 192, 
            'uploadDeny'    => array('all'),                // All Mimetypes not allowed to upload
            'uploadAllow'   => array('image',
		'video',
		'application/pdf pdf',
		'application/x-shockwave-flash swf',
		'application/msword doc dot',
		'application/vnd.ms-excel xls xlm xla xlc xlt xlw'
		),              // Mimetype `image` allowed to upload
            'uploadOrder'   => array('deny', 'allow'),      // allowed Mimetype `image` only
            'accessControl' => 'access'                     // disable and hide dot starting files (OPTIONAL)
        )
    )
);

//print_r($opts);
// run elFinder
$connector = new elFinderConnector(new elFinder($opts));
$connector->run();