<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */

defined('_JEXEC') or die;

require_once(NGEPATH_CONTENTS . '/source/contentsource.php');
$com_path = JPATH_SITE.'/components/com_content/';
require_once $com_path.'helpers/route.php';

class NgeImagesContent extends NgeContentSource
{
    
    
    	/**
	 * Get data and format it to be rendered in a "thumbnails" like widget
	 * @param type $params
	 * @return \NgeContentStructureThumbnails
	 */
	static function getThumbnailsData($params){
	    
	    require_once (NGEPATH_CONTENTS . '/structure/thumbnails.php');
	    $items = array();
	    
	    for ($i = 0; $i < count($params->content->images->items); $i++) {
		$item = new stdClass();
		
		$item->source = 'image';				
		$item->header->label = $params->content->images->items[$i]->header->label;
		$item->header->glyph->name = $params->content->images->items[$i]->header->glyph->name; 
		$item->legend = $params->content->images->items[$i]->legend;

		//Content
		switch ($params->content->images->items[$i]->source){
		case 'video' :
		    $dataVideo = $params->content->images->items[$i]->video;
		    $dataVideo->rendering = $params->rendering;		    
		    $thumbnailsHaveVideoContent = true;
		    $item->body = NGE::layout('nge.parts.media.html.video_html', $dataVideo);
		    break;
		default: //Image		
		    $dataImages = $params->thumbnails->images;
		    $class_img = NGE::layout('nge.parts.images.css.image_class', $dataImages);

		    $item->body = '	<div class="content_img">';
		    $item->body .= '	      <div>';
		    if (isset($params->content->images->items[$i]->caption) && $params->content->images->items[$i]->caption != '') {
			$item->caption = $params->content->images->items[$i]->caption;
			$item->body .= ' 	<div class="image_caption">';
			if ($params->rendering->mode == 'edit')
				$item->body .= '			<div id="' . $part->data->id . '-caption" class="caption_value ngecontenteditableinline"  data-type="ngeeditor" data-property="caption.html">' . $params->content->images->items[$i]->caption->html . '</div>';
			else
				$item->body .= '			<div class="caption_value" >' . $params->content->images->items[$i]->caption->html . '</div>';
			$item->body .= ' 	</div>';
		    }
		    if ($params->rendering->mode == 'edit') {
			$xeditable_class = ' ngecontenteditable';
			$attributes = ' title="Image" data-type="image" data-property="image"';
		    } else {
			$xeditable_class = '';
			$attributes = '';
		    }
		    $attributes .= ' style="width:100%;"'; 

		    $item->body .= '	          <img class="url_image' . $xeditable_class . $class_img . '"' . $attributes . ' src="' . NGE::url('root') . $params->content->images->items[$i]->image . '"/>';
		    $item->body .= '	      </div>';
		    $item->body .= '	</div>';
		    break;
		}
		
		//Hover panel
		$item->caption = '';
		
		//Link
		if (isset($params->content->images->items[$i]->link->type)) {
		    switch ($params->content->images->items[$i]->link->type) {
			    case 'url' :
				    $item->link = $params->content->images->items[$i]->link->url;
				    break;
			    case 'document' :
				    $item->link = NGE::url('root') .$params->content->images->items[$i]->link->document;
				    break;
			    case 'image' :
				    $item->link = NGE::url('root') .$params->content->images->items[$i]->link->image;
				    break;
			    case 'article' :
				    $item->link = NGE::url('root') . 'index.php?option=com_content&view=article&id=' . $params->content->images->items[$i]->link->article;
				    break;
			    case 'menu' :
				    require_once (NGEPATH_HELPERS . '/data/joomla/menudriver.php');
				    $menu = NgeJoomlaMenuDriver::loadItem($params->content->images->items[$i]->link->menu);
				    if (isset($menu)){
					$link = $menu->route;
					$item->link = NGE::url('root').'index.php/' . $menu->route;
				    }
				    else{
					$item->link = NGE::url('root').'index.php';        
					JError::raiseWarning( 100, 'Warning : part '.$params->id.' menu item unknown' );
				    }	
				    break;
			    case 'javascript' :
				    $item->link = $params->content->images->items[$i]->link->javascript;
				    break;
			    case 'submit' :
				    $item->link = 'jQuery( "form:first" ).submit();'; //TODO pouvoir indiquer un nom de formulaire
				    break;
			    default :
				    $item->link = "";
		    }

		}
		
		$items[] = $item;
		
	}
		    	    
	    return $items;		
	}

        
    
	static function loadBody($value, $params=array())
	{
	    $class_img = '';
		return '<img class="' . $class_img . '" src="' . NGE::url('root') . $value . '" />';		
	}
	
	/**
	 * Get Available fields. Will be used in layout display for example
	 */
	static function getFields(){
	    
	    $fields = array();
	    return $fields;
	}
	
	static function loadList($params)
	{		
		$ordering = (isset($params->content->ordering) && ($params->content->ordering != '')) ? 	$params->content->ordering: 'ordering';
		$count =		isset($params->content->count) ? 	$params->content->count: 0;
		$category =	isset($params->content->category) ? 	$params->content->category: '';		
		$author =		isset($params->content->author) ? 	$params->content->author: '';		
		$featured =	isset($params->content->featured) ? 	$params->content->featured: '';		
		$tags =		isset($params->content->tags) ?	$params->content->tags: '';		
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select("a.id, a.title, a.alias, a.catid, a.created_by as author, a.introtext, date(a.created) as created, time(a.created) as created_time, a.hits");
		$query->select('ua.name AS author')
			->join('LEFT', '#__users AS ua ON ua.id = a.created_by');
		$query->select('c.title AS category, c.alias AS category_alias')
			->join('LEFT', '#__categories AS c ON c.id = a.catid');
		$query->from("#__content AS a");
		$query->where("state !=-2");

		if ($category != ''){
			if (is_array($category))
				$query->where('a.catid in ('.implode($category, ',').')');
			else
				$query->where('a.catid ='.$category);
		}
		if ($author != ''){
			if (is_array($author))
				$query->where('a.created_by in ('.implode($author, ',').')');
			else
				$query->where('a.created_by ='.$author);
		}
		if ($tags != ''){
			if (is_array($tags))
				$query->where('a.created_by in ('.implode($tags, ',').')');
			else
				$query->where('a.created_by ='.$tags);
		}
		if ($featured != ''){
				$query->where('a.featured ='.$featured);
		}
		switch ($ordering){
			case 'popular':
				$ordering = 'hits DESC';
				break;
			case 'latest':
				$ordering = 'created DESC';
				break;
		}
				
		$query->order($ordering);
		if ($count != 0)
			$query->setLimit($count); 
		//if ($category != '')
		//	$query->where('a.catid = '.$category);

		$db->setQuery($query);
		$items = $db->loadObjectList();

		foreach ($items as &$item){
			$item->slug = $item->id.':'.$item->alias;
			if (isset($item->category_alias))
				$item->catslug = $item->catid ? $item->catid .':'.$item->category_alias : $item->catid;
			else
				$item->catslug = $item->catid;
				
		//	if ($access || in_array($item->access, $authorised))
		//	{
				// We know that user has the privilege to view the article
				$item->link = JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catslug));
		//	}
		}
		
		// get article active in page?
		$current_article = 0;
		$jinput = JFactory::getApplication()->input;
		$option = $jinput->get('option','');
		$view = $jinput->get('view','');
		$idarticle = $jinput->get('id','');
		if($option=='com_content' && $view=='article') {
			  $current_article = $idarticle;
		}
		// Prepare data for display using display options
		foreach ($items as &$item){
			if (isset($item->images))
				$item->images  = json_decode($item->images);
            
			// is item active ?
			$item->active = false;
			if($item->id==$current_article)
				$item->active = true;
		}
		
		return $items;	
	}
	
}