<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */

defined('_JEXEC') or die;

require_once(NGEPATH_CONTENTS . '/source/contentsource.php');

class NgeInputContent extends NgeContentSource
{
    
	static function getLabel($data, $params){

	    switch ($params->layout->mode) {
		case 'fields' :
		    //Default label: first field
		    return current($data);
		    break;
		case 'template' :
		    require_once (NGEPATH_HELPERS . '/renderer/smarty/smartyrenderer.php');
			$item = new stdClass();
			$item->editable = false;
			return SmartyRenderer::renderString($data, $params->layout->template->label);
		    break;
	    };		
	}

	static function getBody($data, $params)
	{
	    //$data is a row record
	    $item = new stdClass();
	    $item->editable = false;
	    
	    switch ($params->layout->mode) {
		case 'fields' :
		    $htmlRow = '<table class="table">';
		    $firstField = true;
		    foreach ($data as $key=>$value) {
			if ($firstField == true){
			    $item->label = $value;
			    $firstField = false;
			}
			$htmlRow .= '<tr><td>'.$key.'</td><td>'.$value.'</td></tr>' ;
		    }
		    $htmlRow .= '</table>';
		    return $htmlRow;
		    break;
		case 'template' :
		    require_once (NGEPATH_HELPERS . '/renderer/smarty/smartyrenderer.php');
			$item = new stdClass();
			$item->editable = false;
			return SmartyRenderer::renderString($data, $params->layout->template->body);
		    break;
	    };		
	}
	
	/**
	 * Get Available fields. Will be used in layout display for example
	 */
	static function getFields(){
	    
	    $fields = array();
	    $fields[] = array('name'=>'title', 'label'=>'Title', 'type'=>'text');
	    $fields[] = array('name'=>'author', 'label'=>'Author', 'type'=>'text');
	    $fields[] = array('name'=>'created', 'label'=>'Created date', 'type'=>'text');
	    $fields[] = array('name'=>'modified', 'label'=>'Modified date', 'type'=>'text');
	    $fields[] = array('name'=>'published', 'label'=>'Published date', 'type'=>'text');
	    $fields[] = array('name'=>'images.image_intro', 'label'=>'Intro image', 'type'=>'image');
	    $fields[] = array('name'=>'category', 'label'=>'Category', 'type'=>'text');
	    $fields[] = array('name'=>'introtext', 'label'=>'Intro text', 'type'=>'editor');
	    $fields[] = array('name'=>'fulltext', 'label'=>'Full text', 'type'=>'editor');
	    return $fields;
	}
	
	static function getList($params)
	{

	    //Transform stored data into associative array, to be rendered in templates
	    $values = $params->input->values;
	
	    $result = array();
	    if (count($values) >0){
		$labels = $values[0];
		for ($i=1;$i<count($values);$i++){
		    $row = array();
		    for ($j=0;$j<count($values[$i]);$j++){
			//$row['col' . (string)($i+1)] = $valuesRow[$i];
			$row[$labels[$j]] = $values[$i][$j];
		    }
		    $result[] = $row;
		}
		return $result;
	    }
	}	
}