<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */
// No direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.controllerform');

/**
 * Brik controller class.
 */
class NgeControllerLayout extends JControllerForm {
    
    /**
     * NgeControllerLayout::loadContent()
     * load the layout content
     * @return void
     */
    public function loadContent() {
        
    	$attribs = array();
    	$result = array();
    	$jinput = JFactory::getApplication()->input;

    	$attribs["type"] = (isset($_POST['layoutType'])) ? $_POST['layoutType'] : "";
    	$attribs["return"] = (isset($_POST['return'])) ? $_POST['return'] : "";
  
        // If no key, error and stopping script
        if(!(isset($_POST['pk'])) || ($_POST['pk'] =="" )) {
            print('ERROR - No key defined');
            exit();
        }
        else
        	$pk = $_POST['pk'];
               	
       	//Loading renderer
        if ($attribs["return"] == 'wireframe'){ //Wireframe rendering
        	require_once NGEPATH_HELPERS . '/parts/renderer/wireframe.php';
			$document	= JFactory::getDocument();
			$renderer 	= new JDocumentRendererWireframe($document);        	
			$result["html"] = $renderer->render('['.$pk.']', $attribs);

        }else {//Preview rendering
		require_once NGEPATH_HELPERS . '/parts/renderer/default.php';
		$result["html"] = NgePartRendererDefault::render('['.$pk.']');
        }
        
        $result["pk"] = $pk;
        $result["result"] = "1"; //Loading result is OK

        print(json_encode($result));
        exit();
    }
        
    /**
     * NgeControllerLayout::savecontent()
     * For page Layouts
     * Saving new content in the layout content property
     * */
	public function savecontent(){
		$user = JFactory::getUser();
		if ($user->authorise('core.edit', 'com_nge') || $user->authorise('core.edit.state', 'com_nge')) {		
			require_once NGEPATH_HELPERS . '/ngepartshelper.php';		
			$partModel = JModelAdmin::getInstance('part','NgeModel');
		
			$value = urldecode($_POST['value']);
			$pk = $_POST['pk'];
		
			if(!$pk) {
				print('error - No part id');
				exit();
			}				
			
			// Loading part information (in cache)
			//$content = $partModel->load_part_content($pk);
			
			// params non trouves, erreur et interruption du script
// 			if(!$content) {
// 				print('error - No params found');
// 				exit();
// 			}
			
			//Get information of the part (in cache)
			$part = NgePartsHelper::getPart($pk);
			if(!$part) {
				print('error - Part not found');
				exit();
			}
					
			//Putting new content : in the "content" property
			$part->content = $value;
			$contentJson = json_encode($part);

			//saving content field in the table
			$result = $partModel->savepart_content($pk, $contentJson);
		
			print(json_encode($result));
			exit();
		
		} else {
			throw new Exception(500);
		}
		
	}
	
	/**
	 * NgeControllerLayout::savecontent()
	 * For columns Layouts
	 * Saving new content in the layout columncontent property
	 * */
	public function savecolumncontent(){
		$user = JFactory::getUser();
		if ($user->authorise('core.edit', 'com_nge') || $user->authorise('core.edit.state', 'com_nge')) {
			//require_once NGEPATH_HELPERS . '/ngecontenthelper.php';
			$partModel = JModelAdmin::getInstance('part','NgeModel');
	
			$value = urldecode($_POST['value']);
			$pk = $_POST['pk'];
			$col = $_POST['col'];
	
			if(!$pk) {
				print('error - No part id');
				exit();
			}
	
			$propertyKey = 'contents.'.$col;
			
			// Saving
			$result = $partModel->saveContentProperty($pk, $propertyKey, $value);
				
			// params non trouves, erreur et interruption du script
			if(!$params) {
				print('error - No params found');
				exit();
			}
				
			print(json_encode($result));
			exit();
	
		} else {
			throw new Exception(500);
		}
	
	}
}