<?php /**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */
// No direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.controllerform');
require_once JPATH_SITE . '/components/com_nge/classes/ngemodulehelper.php';
require_once JPATH_SITE . '/components/com_nge/helpers/ngecontenthelper.php';

/**
 * Module front editing controller class.
 */
class NgeControllerModule extends JControllerForm
{

    function __construct()
    {
        parent::__construct();
    }

    /**
     * NgeControllerConfigmodule::save()
     * 
     * @param mixed $key
     * @param mixed $urlVar
     * @return void
     */
    public function save($key = NULL, $urlVar = NULL){

	$app = JFactory::getApplication();
	$user = JFactory::getUser();
	$jinput = JFactory::getApplication()->input;
	$result = array();
	$pk = $jinput->get('pk', '', 'string');
	
	
        if ($pk == '' && (!$user->authorise('core.create', 'com_modules'))){
            $result["result"] = "0";
            $result["message"] = NGE::translate('JLIB_APPLICATION_ERROR_CREATE_RECORD_NOT_PERMITTED');
            echo json_encode($result);
            exit();
        }
        else
        if ($pk != '' && (!$user->authorise('core.edit', 'com_modules.module.' . $pk))){
            $result["result"] = "0";
            $result["message"] = NGE::translate('JLIB_APPLICATION_ERROR_EDIT_ITEM_NOT_PERMITTED');
            echo json_encode($result);
            exit();
        }
        
        //Id of the module is sent in the url (GET), adding it to the form data (POST)
        if ($pk != '')
        	$_POST['id'] = $pk;
         
       	//jModelAdmin::addModelPath(JPATH_ADMINISTRATOR.'components/com_modules/models');
       	//$model = JModelAdmin::getInstance('module','ModulesModel');
       	$model = $this->getModel();
       	 
       	// get module ordering
       	$module_before = $jinput->get('m_before_id', 0, 'int');
       	if ($module_before != 0)
       	{
       		$prev_module = $model->getItem($module_before);
       		 
       		if ($prev_module)
       		{
       			$_POST['ordering'] = $prev_module->ordering;
       		}
       	}

        $return = $model->save($_POST);

        if ($return){

            $model->getState('module.id');
            //If caller is an editor, we return the module id

            $caller = $jinput->get('caller', '');
            //Caller is inline editing (front or layout). Preview is sent back
            if ($caller == 'layout.position')
            {
                $result["m_id"] = $model->getState('module.id');
                $result["result"] = "1"; //Saving result is OK

                $result["position"] = $jinput->get('position', '', 'string');
                ;
                //$result['position'] = $jinput->get('position');
                //$content_return = "{loadmodule " . $jinput->get('module') . "," . $jinput->get('title') . "}";

                // rendering module            
                $result["html"] = NgeModuleHelper::render($result["m_id"]);
                $result["title"] = $jinput->get('title');
                $result["module"] = $jinput->get('module');

                echo json_encode($result);
                exit();
            } else if ($caller == 'layout.article'){

                    $result["m_id"] = $model->getState('module.id');
                    $result["result"] = "1"; //Saving result is OK
                    $jform = $jinput->get('jform', '', 'array');
                    $result["position"] = $jinput->get('position');
                    $result["html"] = $this->renderLoadPosition($result['position']);
                    $result["title"] = $jinput->get('title');
                    $result["module"] = $jinput->get('module');

                    echo json_encode($result);
                    exit();
			}else{
				/*No caller module content editing*/
				$result["result"] = 1;
				$result["message"] = NGE::translate('COM_NGE_EDITING_MSG_SAVE_MODULE');
				echo json_encode($result);
				exit();
			}
        }else{
            $result["result"] = "0"; //Saving result is OK, or session problem
            $result["message"] = $model->getError();
            print (json_encode($result));
            exit();
        }
    }


    /**
     * NgeControllerConfigmodule::trash()
     * 
     * @return void
     */
    public function trash()
    {
	$app = JFactory::getApplication();
	$user = JFactory::getUser();
	$jinput = JFactory::getApplication()->input;
              $m_id = $jinput->get('m_id',0,'int');
	
	if (!$user->authorise('core.delete', 'com_modules.module.' . $m_id)){
		$result = array();
		$result["result"] = "0"; // Deleting is not permitted
		$result["message"] = NGE::translate('JLIB_APPLICATION_ERROR_DELETE_NOT_PERMITTED');
		echo json_encode($result);
		exit();
	}
	else
	    $this->setRemoved(-2);
    }

        /**
     * NgeControllerConfigmodule::publish()
     * $state : True to publish, False to unpublish
     * @return void
     */
    /*public function publish(){
	   $this->setPublish(1);
    }
*/
        /**
     * NgeControllerConfigmodule::publish()
     * $state : True to publish, False to unpublish
     * @return void
     */
   /* public function unpublish(){
	   $this->setPublish(0);
    }
*/	    
	    
    /**
     * NgeControllerConfigmodule::publish()
     * $state : True to publish, False to unpublish
     * @return void
     */
    //private function setPublish($stateId=true)
    private function setRemoved($stateId=true)
    {
        $app = JFactory::getApplication();
        $user = JFactory::getUser();
        
        $result = array();

        // user authorisation
        if (!$user->authorise('core.delete', 'com_modules'))
        {
            $result["result"] = "0"; // Publishing is not permitted
            $result["message"] = NGE::translate('JLIB_APPLICATION_ERROR_ACCESS_FORBIDDEN');
        } else // check token
            if (!JSession::checkToken())
            {
                $result["result"] = "0"; // Publishing is not premitted : session expired
                $result["message"] = NGE::translate('SESSION_EXPIRED');
            } else
            { // publish state modification
                $jinput = JFactory::getApplication()->input;
                $m_id = $jinput->get('m_id',0,'int');
                if ($m_id) // module_id exist in request
                {
                    //require_once (JPATH_ROOT . '/libraries/legacy/model/admin.php');
                    JControllerForm::addModelPath(JPATH_ADMINISTRATOR .
                        '/components/com_modules/models');
    
    		        // modify joomla module publish field using admin/com_modules module model  
                    $model = $this->getModel('module', 'ModulesModel');
                    // get module
                    $module = $model->getItem($m_id);
                    //In demo mode, not removed, but do as if it where
                    if (NGE::features('nge.demo') || $model->publish($m_id, $stateId))
                    {
                    	$result["m_id"] = $module->id;
                    	$result["result"] = "1"; //Publish or unpublished result is OK
                    	$result["position"] = $module->position;
                    	// rendering module
                    	//$result["html"] = $this->rendermodule($module->module, $module->title);
		$result["html"] = NgeContentHelper::parse(NgeModuleHelper::render($module->id));
                    	$result["title"] = $module->title;
                    	$result["module"] = $module->module;
		if (NGE::features('nge.demo'))
		    $result['message'] = NGE::translate('COM_NGE_DEMO_MODE_MESSAGE');
                    }
                } else // no module id in request, error
                {
                    $result["result"] = "0"; // Deleting is not permitted : session expired
                    $result["message"] = NGE::translate('COM_NGE_EDITING_MSG_NO_MODULE_IN_GET');

                }
            }
            echo json_encode($result);
        exit();
    }

    /**
     * NgeControllerConfigmodule::duplicate()
     * 
     * @return void
     */
    public function duplicate() {
    	
	$jinput = JFactory::getApplication()->input; 
	$m_id = $jinput->get('m_id',0,'int');
	
	if(!$m_id) {
		$result["result"] = "0"; 
		$result["message"] = NGE::translate('COM_NGE_EDITING_MSG_NO_MODULE_TO_DUPLICATE');
	       print (json_encode($result));
	       exit();			
	}
	
	$newModule = NgeModuleHelper::duplicate($m_id);

	$result = array();
	if ($newModule != '')	{
		$result["result"] = "1"; //Saving result is OK
		$result["m_id"] = $newModule->id;
		$result["title"] = $newModule->title;
		$result["html"] = $newModule->render();
        } else
        {
            $result["result"] = "0"; //Saving result is OK, or session problem
            $result["message"] = $model->getError();
        }
				
        print (json_encode($result));
        exit();         
    }

    
    /**
     * NgeControllerConfigmodule::move()
     * 
     * @return void
     */
    public function move() {
        $model = $this->getModel();
        $jinput = JFactory::getApplication()->input; 
        
	$pk = $jinput->get('m_id',0,'int');
	if ($pk == 0)
		return false;
	
	$newPosition = $jinput->get('end_position','','string');
	$previousModulePk = $jinput->get('m_before_id', 0, 'int');
		
	if (NgeModuleHelper::move($pk, $position, $previousModulePk)){            
            $result["pk"] = $pk;
            $result["result"] = "1"; //Saving result is OK
            $result["position"] = $newPosition;
        } else
        {
            $result["result"] = "0"; //Saving result is OK, or session problem
            $result["message"] = $model->getError();
        }
	
        print (json_encode($result));
        exit();         
    }

    /**
     * NgeControllerConfigmodule::move()
     * 
     * @return void
     */
    public function moduletoarticle() {
        $model = $this->getModel();
        $jinput = JFactory::getApplication()->input; 
        
        // get module 
        $module_to_move = $model->getItem($jinput->get('m_id',0,'int'));
        
        // change module position
        $article_id = $jinput->get('a_id',0,'int');
        
        $module_to_move->position = $model->getNewPositionInArticle($article_id);

       
		//TODO si le ordering change changer le ordering de tout les modules suivant de +1
        // transform module_to_move to jregistry
        $registry = new JRegistry();
        $registry->loadObject($module_to_move);
        
        // save module via configmodule model
        $result = array();
        if($model->save($registry->toArray()) ) {
            
            $result["pk"] = $module_to_move->id;
            $result["result"] = "1"; //Saving result is OK
            $result["position"] = $module_to_move->position;
            $result['title'] = $module_to_move->title;
            $result['module'] = $module_to_move->module;
            $result['html'] = $this->renderLoadPosition($module_to_move->position);
            
        } else
        {

            $result["result"] = "0"; //Saving result is OK, or session problem
            $result["message"] = $model->getError();
        }
    
        print (json_encode($result));
        exit();
         
    }    
    
    /**
     * NgeControllerConfigmodule::move()
     * 
     * @return void
     */
    public function moduletok2item() {
        $model = $this->getModel();
        $jinput = JFactory::getApplication()->input; 
        
        // get module 
        $module_to_move = $model->getItem($jinput->get('m_id',0,'int'));
        
        // change module position
        $item_id = $jinput->get('a_id',0,'int');
        
        $module_to_move->position = $model->getNewPositionInItem($item_id);
       
	//TODO si le ordering change changer le ordering de tout les modules suivant de +1
        // transform module_to_move to jregistry
        $registry = new JRegistry();
        $registry->loadObject($module_to_move);
        
        // save module via configmodule model
        $result = array();
        if($model->save($registry->toArray()) ) {
            
            $result["pk"] = $module_to_move->id;
            $result["result"] = "1"; //Saving result is OK
            $result["position"] = $module_to_move->position;
            $result['title'] = $module_to_move->title;
            $result['module'] = $module_to_move->module;
            $result['html'] = $this->renderLoadPosition($module_to_move->position);
            
        } else
        {

            $result["result"] = "0"; //Saving result is OK, or session problem
            $result["message"] = $model->getError();
        }
    
        print (json_encode($result));
        exit();
         
    }    

    /**
     * NgeControllerConfigmodule::renderLoadPosition()
     * 
     * @param mixed $module_title
     * @return
     */
    private function renderLoadPosition($module_title) {
        return '{loadposition '.$module_title.'}';   
        
    }
    
    
}