<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */
defined('_JEXEC') or die;


defined('JPATH_PLATFORM') or die;

require_once(NGEPATH_HELPERS . '/api/content/customcontent.php');
require_once(NGEPATH_HELPERS . '/api/link.php');
require_once(NGEPATH_HELPERS . '/api/content/headercontent.php');

/**
 * Content class 
 * @package     CORE
 * @version 	1.0.0
 * @since       1.0.0
 */
 
class PartThumbnailCustomContent{

	/**
	 * @var PartHeaderContent $header
	 */
	public $header;
	
	/**   
	 * @var PartCustomContent $body
	 */
	public $body;
	
	/**   
	 * @var PartCustomContent $hover
	 */
	public $hover;
	
	/**   
	 * @var PartLink $link
	 */
	public $link;

		
	function __construct(){
		$this->header = new PartHeaderContent();
		$this->body = 	new PartCustomContent();
		$this->hover = 	new PartCustomContent();
		$this->link = 	new PartLink();
		$this->legend = "";
	}
	
	public function bind($data){

		if (isset($data->header))	$this->header->bind($data->header);
		if (isset($data->hover))	$this->hover->bind($data->hover);
		if (isset($data->link))		$this->link->bind($data->link);
		//No bind for tabs (shortcuts) if (isset($data->tab))	$this->link->bind($data->tab);
		$this->body->bind($data);
		if (isset($data->legend))	$this->legend = $data->legend;
	}
	
	public function codeWizard($partObject){}
}
