<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */
defined('_JEXEC') or die;


defined('JPATH_PLATFORM') or die;

require_once(NGEPATH_HELPERS . '/api/body.php');

require_once(NGEPATH_HELPERS . '/api/part/panels/thumbnails/thumbnailwidth.php');
require_once(NGEPATH_HELPERS . '/api/part/panels/thumbnails/thumbnailspacing.php');
require_once(NGEPATH_HELPERS . '/api/imageproperties.php');
require_once(NGEPATH_HELPERS . '/api/multiplebodyheight.php');

/**
 * Thumbnails general class 
 * @package     CORE
 * @version 	1.0.0
 * @since       1.0.0
 */
 
class PartThumbnails {

	/**
	 * @var String $mode
	 */
	public $mode;
	/**
	 * @var String $rowitems
	 */
	public $rowitems;
	/**
	 * @var String $css
	 */
	public $css;
	/**
	 * @var PartMultipleBodyHeight $height
	 */
	public $height;
	/**
	 * @var String $margin
	 */
	public $margin;

	/**
	 * @var PartHeader $header
	 */
	public $header;
	/**
	 * @var PartThumbnailsbody $body
	 */
	public $body;
	
	/**   
	 * @var parCaption $caption   
	 * Caption content and options
	 */
	public $caption;

	/**
	 * @var PartLegend $legend
	 */
	public $legend;
	/**
	 * @var PartThumbnailshoverpanel $hoverpanel
	 */
	public $body_hover;
	
	/**
	 * @var NgePartImagesProperties $images
	 */
	public $images;
	
	function __construct(){	
				
		$this->header = 		new PartHeader();
		$this->body =		new PartBody();
		$this->legend =		new PartLegend();
		$this->caption =		new PartCaption();
		
		$this->width = 		new PartThumbnailWidth();
		$this->height = 		new PartMultipleBodyHeight();
		$this->spacing = 		new PartThumbnailSpacing();
				
		$this->body_hover =                new PartBody();
		
		//When mode image
		$this->images =		new NgePartImagesImageProperties();

	}
	
	public function bind($data){

	    
		if (isset($data->header))			$this->header->bind($data->header);
		if (isset($data->body))			$this->body->bind($data->body);
		if (isset($data->body_hover))			$this->body_hover->bind($data->body_hover);
		
		if (isset($data->legend))			$this->legend->bind($data->legend);
		if (isset($data->caption))			$this->caption->bind($data->caption);
		if (isset($data->width))			$this->width->bind($data->width);
		if (isset($data->height))			$this->height->bind($data->height);
		if (isset($data->spacing))			$this->spacing->bind($data);

		if (isset($data->images))		 	$this->images->bind($data->images);
	}
	
	public function codeWizard($partObject){}
}
