<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 * 
 * 
 * Used to add custom css to any item in the page
 * 
 * 
 */

defined('_JEXEC') or die;

require_once (NGEPATH_HELPERS . '/data/datadriver.php');
require_once NGEPATH_HELPERS . '/ngedata.php';

class NgeItemDriver extends NgeDataDriver
{

        /**
     * NgeItemHelper::getItem()
     *
     * @param int $pk
     * @return $part object
     */
    public static function load($id) {
    	$sql = 'SELECT * FROM #__nge_items WHERE id="' . $id.'"';
	return NGEDATA::loadObject($sql);
    }
    
    public static function save($id, $item, $selector, $title, $params){
	$user = JFactory::getUser();

	if(is_string($params))
	    parse_str($params, $params);
	$jsonParams = json_encode($params);
	$css = addslashes(self::parseCss($id, $selector, $item, $jsonParams));
	$js = addslashes(self::parseJs($id, $selector, $item, $jsonParams));
	
	
	$params = addslashes($jsonParams);
	
	$resut = array();
	try {
	    $sql = sprintf('REPLACE INTO #__nge_items (id, item, title, selector, params, css, js, modified, modified_by) VALUES( "%s", "%s", "%s", "%s", "%s", "%s", "%s", NOW(), %d)' , $id, $item, $title, $selector, $params, $css, $js, $user->id);
	    NGEDATA::execute($sql);
	    $itemId = NGEDATA::insertid();
	    $result['result'] = "1";
	    $result['status'] = "Item stored";
	    $result['css'] = $css;
	    //Update general css and js file
            $result = array_merge($result, self::updateCustomCss());
            $result = array_merge($result, self::updateCustomJs());
	}
	catch (Exception $e) {
	    $result['result'] = "0";
	    $result['status'] = JErrorPage::render($e);
	}	
    return $result;
}

    /* Parse params content for css*/
    private static function parseCss($id, $selector, $item, $paramsObject){
	return self::parse('css', $id, $selector, $item, $paramsObject);
    }
    
    /* Parse params content for js*/
    private static function parseJs($id, $selector, $item, $paramsObject){
	return self::parse('js', $id, $selector, $item, $paramsObject);
    }
    
    /* Parse params content */
    private static function parse($file, $id, $selector, $item, $paramsObject){
		
	    $itempath = explode('.', $item);		
	    $directories = '';
	    $name = "";
	    for ($i=0; $i<count($itempath); $i++)
		    $directories .= $itempath[$i].'/';
	    $name .= $itempath[count($itempath)-1];
	    $path = NGEPATH_ITEMS . '/' . $directories . $file . '.php';

	    // Load the path
	    if (file_exists($path))
	    { 
		    $content = '';
		    //global var for API
		    $item = new stdClass();
		    $item->id = $id;
		    $item->selector = $selector;
		    $item->params = $paramsObject;
		    ob_start();
		    include $path;
		    $content = ob_get_contents(); // . $content;
		    ob_end_clean();
	    }
	    else
		$content = '';
	    return $content;
    }
    
    /*
     * Writing general css file containing all items css 
     */
    public static function updateCustomCss(){
	$sql = "select css FROM #__nge_items";
	$result = NGEDATA::loadObjectList($sql);
        $return = array();
        $return["css_id"] = "";
        $return["old_css_id"] = "";
	$css = array();
        
	foreach ($result as $item){
	    $css[] = $item->css;
	}
	$cssResult = NGE::minify(implode($css));
	
	//Writing cache file
	if ($cssResult != ''){
	    //Erase old files
	    foreach (glob(NGEPATH_ASSETS. '/css/ngecustom*.min.css') as $filename) {
                $matches = null;
                preg_match('/ngecustom_(.*?)\\./is', addslashes($filename), $matches);
                if($matches !== null && isset($matches[1])){
                    $return["old_css_id"] = $matches[1];
                }
		unlink($filename);
	    }
	    //Writing file using random name to get file flushed by the browser cache when is renewed
            $return["css_id"] = round(microtime(true) * 1000);
	    file_put_contents(NGEPATH_ASSETS. '/css/ngecustom_' . $return["css_id"] . '.min.css', $cssResult);
	}
        
        return $return;
    }
    
    /*
     * Writing general css file containing all items js
     */
    public static function updateCustomJs(){
	$sql = "select js FROM #__nge_items";
	$result = NGEDATA::loadObjectList($sql);
        $return = array();
        $return["js_id"] = "";
        $return["old_js_id"] = "";
	$js = array();
        
	foreach ($result as $item){
	    $js[] = $item->js;
	}
	$jsResult = NGE::minify(implode($js));
	if ($jsResult != ''){
	    //Erase old files
	    foreach (glob(NGEPATH_ASSETS. '/js/ngecustom*.min.js') as $filename) {
                $matches = null;
                preg_match('/ngecustom_(.*?)\\./is', addslashes($filename), $matches);
                if($matches !== null && isset($matches[1])){
                    $return["old_js_id"] = $matches[1];
                }
		unlink($filename);
	    }
            
            $return["js_id"] = round(microtime(true) * 1000);
	    //Writing file using random name to get file flushed by the browser cache when is renewed
	    file_put_contents(NGEPATH_ASSETS. '/js/ngecustom_' . $return["js_id"] . '.min.js', $jsResult);
	    
	}
        
        return $return;
    }	
}