<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 * 
 * 
 * Used to add custom css to any item in the page
 * 
 * 
 */

defined('_JEXEC') or die;

require_once (NGEPATH_HELPERS . '/data/datadriver.php');

class NgePatternsDriver extends NgeDataDriver
{

    /**
     * Get list of patterns
     * @param type $type
     * @param type $name
     * @param type $thumbnail if true, including thumbnail preview. If empty, is generated while loading
     * 
     * @return type
     */
    public static function loadList($type, $name, $loadThumbnails=false)
	{
    		// Get the database object.
		$db = JFactory::getDbo();

		// Set the query and get the result list.
		$query = $db->getQuery(true);
		if ($loadThumbnails == true)
		    $query->select('p.id, p.title, p.description, p.content, p.params, settings, thumbnail, created_by');
		else
		    $query->select('p.id, p.title, p.description, p.settings, created_by');
		$query->from('#__nge_patterns AS p')
		->where('p.state = 1')
		->where('p.type = "'.$type.'"')			
		->where('p.name = "'.$name.'"')
		->order('title');

		$db->setQuery($query);
		$patternsList = $db->loadObjectlist();
		/*
		//Removing patterns if have conditions not ok
		for ($i = count($patternsList); $i--;$i>0){
		    if (isset($patternsList[$i]->params)){
			$params = json_decode($patternsList[$i]->params);
			if (isset($params->access) && isset($params->access->mode)){
			    switch ($params->access->mode){
				//Pattern only usable for their creator
				case 'creator' :
				    $currentUser = JFactory::getUser();
				    if ($currentUser->id != $patternsList[$i]->created_by)
					unset($patternsList[$i]);
				    break;
				    //Pattern only usable for some groups
				case 'usergroup' :				    
				    $patternIsOk= false;
				    $patternsGroups = $params->access->usergroup;
				    $currentUser = JFactory::getUser();
					$currentUserGroups = $currentUser->getAuthorisedGroups();

				    foreach($currentUserGroups as $group){
					if (in_array($group , $patternsGroups)){
					    $patternIsOk = true;
					    break;
					}
				    }
				    if ($patternIsOk == false){
					unset($patternsList[$i]);
				    }
				    break;
			    }
			    //Reorder array if rows removed
			    $patternsList = array_values($patternsList);
			}
		    }
		}
		*/
		
		//Thumbnails
		if ($loadThumbnails == true){
		    //Rendering content as if it was a part
		    $part = new stdClass();
		    $part->name = $name;
		    $attribs = new stdClass;
		    $attribs->rendering_mode = 'fastview'; //While building part content, adjust options

		    //$name = "";
		    $directories = '';
		    $partpath = explode('.', $part->name);
		    for ($j=0; $j<count($partpath); $j++)
			$directories .= $partpath[$j].'/';
		    //$name .= $partpath[count($partpath)-1];

		    //Type of pattern : part or options
		    //If part type, we use the parts directory
		    //If others types, we use the pattern directory
		    if ($type == 'part')
			$directories = NGEPATH_PARTS . '/' . $directories;
		    else
			$directories = NGEPATH_NGE . '/patterns/' . $directories;
		    
		    //File to use to build the part
		    $templateFilename = "thumbnail.php";
		    // If template not exists, using default template : file part.php
		    if(!file_exists($directories . $templateFilename))
			    $templateFilename = "part.php";
		    $templatePath = $directories.$templateFilename;

		    // Load the path
		    if (file_exists($templatePath))
		    { 		    
			for ($i = 0;$i< count($patternsList); $i++){
			    //If thumbnail cache data is empty, create cache data
			    if (trim($patternsList[$i]->thumbnail) == ''){
				
				require_once(NGEPATH_HELPERS . '/html/bootstrap/bootstraptag.php');
				require_once(NGEPATH_HELPERS . '/ngedata.php');

				//Loading pattern properties as if it where part params
				$part->id = $patternsList[$i]->id;
				$part->title = $patternsList[$i]->title;
				$part->library_title = $patternsList[$i]->title;
				
				//If fake content empty, load fake content from part library
				//Fake content can be empty when pattern is saved from config screen.
				if ($type == 'part'){
				    if ($patternsList[$i]->content == '')
					$patternsList[$i]->content = NGEDATA::loadResult('SELECT content FROM #__nge_parts_library WHERE part = "'.$name.'"');

				    //Using fake content when type is part
				    $contentArray = json_decode($patternsList[$i]->content, true);
				    $paramsArray = json_decode($patternsList[$i]->params, true);
				    
//				    $part->params = new JRegistry;
//				    $contentArraypart->params->loadString($patternsList[$i]->content);
				    $mergedParams = NGE::array_merge_recursive_replace($contentArray, $paramsArray);
				    $part->content = ''; //Property must be defined. If empty, we know params are already merged
				    $part->params = json_encode($mergedParams);
				}
				else {
				    $part->content = ''; //No content fort patterns others than part
				    $part->params = $patternsList[$i]->params;    
				}
				
				    ob_start();
				    include $templatePath;
				    $thumbnail = ob_get_contents(); // . $content;
				    ob_end_clean();
				    
				    //Saving in the patterns table
				    //Removing main div
				    require_once NGEPATH_HELPERS . '/data/nge/patterndriver.php';
				    NgePatternDriver::storeThumbnail($patternsList[$i]->id, $thumbnail);			

				    $patternsList[$i]->thumbnail = $thumbnail;				
			    }
			}
		    }		    
		}
		
		return $patternsList;
	}
}