<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */
defined('_JEXEC') or die;

/**
 * class NgeDatabaseDriver
 * @author jean-marc
 *
 */

class BourseDriver {

	private static function getContents($url){
	
		$result = '';
		if ($url != ''){
			$result = file_get_contents($url);
		}
		return $result;
	}
	
	static public function loadInstrument($nature, $instrument){

		$url = 'http://bourse.teatis.com/index.php?option=com_ttscotations&task=bourse.instrument';
		$url .= '&nature='.$nature;
		$url .= '&instrument='.$instrument;
		$content = self::getContents($url);
		$result = json_decode($content);
		return $result;		
	}
	
	static function loadPlaces(){

		$url = 'http://bourse.teatis.com/index.php?option=com_ttscotations&task=bourse.places';
		$content = self::getContents($url);
		return json_decode($content);
	}
	
	static function loadInstruments($params){
		$url = 'http://bourse.teatis.com/index.php?option=com_ttscotations&task=bourse.instruments';
		if (isset($params['search_value']))
			$url .= '&search_value='.$params['search_value'];
		if (isset($params['search_filtre']))
			$url .= '&search_filtre='.$params['search_filtre'];
		if (isset($params['instrument_type']))
			$url .= '&instrument_type='.$params['instrument_type'];
		if (isset($params['place_id']))
			$url .= '&place_id='.$params['place_id'];
				
		//$url = 'http://localhost/teatis_cotations/index.php?option=com_ttscotations&task=bourse.places';
		$content = self::getContents($url);
		return json_decode($content);
	}
	
	static function loadFutures($params){
		$url = 'http://bourse.teatis.com/index.php?option=com_ttscotations&task=bourse.futures';
		if (isset($params['search_value']))
			$url .= '&search_value='.$params['search_value'];
		if (isset($params['search_filtre']))
			$url .= '&search_filtre='.$params['search_filtre'];
		if (isset($params['instrument_type']))
			$url .= '&instrument_type='.$params['instrument_type'];
		if (isset($params['place_id']))
			$url .= '&place_id='.$params['place_id'];
				
		//$url = 'http://localhost/teatis_cotations/index.php?option=com_ttscotations&task=bourse.places';
		$content = self::getContents($url);
		return json_decode($content);
	}
	
	static function loadClotures($instrumentNature, $instrumentId, $dateStart = '', $dateEnd = ''){
		$url = 'http://bourse.teatis.com/index.php?option=com_ttscotations&task=bourse.clotures';
		$url .= '&nature='.$instrumentNature;
		$url .= '&instrument='.$instrumentId;
		$url .= '&date_start='.$dateStart;
		$url .= '&date_end='.$dateEnd;
		$content = self::getContents($url);
		$result = json_decode($content);
		return $result;
	}

    static function loadLastCloture($nature, $instrument){
		$url = 'http://bourse.teatis.com/index.php?option=com_ttscotations&task=bourse.lastcloture';
		$url .= '&nature='.$nature;
		$url .= '&instrument='.$instrument;
		$content = self::getContents($url);
		$result = json_decode($content);
		return $result;
	}
	//Valeurs multiples pour faire un graphe
	static function loadIntraday($instrumentNature, $instrumentId, $date, $timeStart = '', $timeEnd = ''){
		$url = 'http://bourse.teatis.com/index.php?option=com_ttscotations&task=bourse.intraday';
		$url .= '&nature='.$instrumentNature;
		$url .= '&instrument='.$instrumentId;
		$url .= '&date='.$date;
		$url .= '&time_start='.$timeStart;
		$url .= '&time_end='.$timeEnd;
		$content = self::getContents($url);
		$result = json_decode($content);
		return $result;
	}
	
	static function loadLastFutureIntraday($instrumentId, $echeance){
		$url = 'http://bourse.teatis.com/index.php?option=com_ttscotations&task=bourse.lastfutureintraday';
		$url .= '&instrument='.$instrumentId;
		$url .= '&echeance='.$echeance;
		$content = self::getContents($url);
		$result = json_decode($content);
		return $result;
	}
	
	static function getPlacesInformation(){
		$url = 'http://bourse.teatis.com/index.php?option=com_ttscotations&task=bourse.placesinformation';
		$content = self::getContents($url);
		return json_decode($content);		
	}
	
	static function getPlacesInstruments($nature){
		$url = 'http://bourse.teatis.com/index.php?option=com_ttscotations&task=bourse.placesinstruments';
		$url .= '&nature='.$nature;
		//$url = 'http://localhost/teatis_cotations/index.php?option=com_ttscotations&task=bourse.places';
		$content = self::getContents($url);
		return json_decode($content);
	}
	
}
