
	/* enableNgeInlineEditing 
	 * enable inlineediting in all tags ready for that.
	 * */
	enableNgeInlineEditingElements = function (selector) {
		var $selector = typeof selector !== 'undefined' ? jQuery(selector) : jQuery(document);
		enableInlineEditableElements($selector);		
	};
	
	disableNgeInlineEditingElements = function (selector) {
		var $selector = typeof selector !== 'undefined' ? jQuery(selector) : jQuery(document);

		disableInlineEditableElements($selector);
	};


    /*
     *Inline editing for elements */
    enableInlineEditableElements = function ($selector) {
			
	//Selectable items (glyphs, images)
	//$selector.find(".ngeinlineeditable").mouseenter(function () {
	    jQuery(".ngeinlineeditable").mouseenter(function () {
	    
	    //If glyph, image or article, displaying element toolbar
	    var dataNge = jQuery(this).data('nge');
	    var contentType = dataNge.type;
	    var elementTitle = dataNge.title;
	    jQuery(this).closest(".ngeeditablestructure").find(".ngetoolbar-status").html(elementTitle).show();
	    var selectableTypes = ["glyph", "image", "joomla.article", "joomla.module", "panel.header", "table.header", "table.row"];
	    if (selectableTypes.indexOf(contentType) != -1){
	    //if (contentTypejQuery(this).hasClass('ngeinlineglyph') || jQuery(this).hasClass('ngeinlineimage') || jQuery(this).hasClass('ngeinlinearticle') || jQuery(this).hasClass('ngeinlinemodule')){
		var $inlineToolbar = jQuery('#ngeinline-toolbar');	   

		//Moving the toolbar in the DOM, from the end body tag to the current element
		jQuery(this).prepend($inlineToolbar);
		switch (contentType){
		    case 'glyph' :
			jQuery('#ngeinline-toolbar-status').html("Choose glyph").show();
			break;
		    case 'image' :
			jQuery('#ngeinline-toolbar-status').html("Choose image").show();
			break;
		    case 'joomla.article' :
			jQuery('#ngeinline-toolbar-status').html("Choose article").show();
			break;
		    case 'joomla.module' :
			jQuery('#ngeinline-toolbar-status').html("Choose module").show();
			break;			
		    default :
			jQuery('#ngeinline-toolbar-status').html(elementTitle).show();
			break;
		}
		
		//Setting toolbar title
		jQuery("#ngeinline-toolbar-plugins").find('.ngetoolbarplugin').hide();
		if (jQuery(this).data('nge') !== undefined) {
		    jQuery('#ngeinline-toolbar-title').html(jQuery(this).data("nge").title);
		    //Displaying plugins for this element
		    jQuery("#ngeinline-toolbar-plugins").find('span[data-element="'+jQuery(this).data("nge").type+'"]').show();
		}	
		else
		    jQuery('#ngeinline-toolbar-title').html("Element");	    	    

		//Changing color
		var $structure = jQuery(this).closest('.ngeeditablestructure');
		var $toolbar = $structure.find('.ngetoolbar-title');
		if ($toolbar.length > 0) {
		    var backgroundColor = $structure.find('.ngetoolbar-title').css('background');
		}
		else {
		    //Part toolbar
		    var backgroundColor = jQuery('#part-toolbar-info').css('background');
		}
		jQuery('#ngeinline-toolbar-title').css('background', backgroundColor);
		jQuery('#ngeinline-toolbar-status').css('background', backgroundColor);
		jQuery('#ngeinline-toolbar').find('.ngetoolbar-icon').css('background', backgroundColor);

		//Setting toolbar position
		var toolbarHeight = $inlineToolbar.height();
		//$inlineToolbar.css('top', -toolbarHeight/2);
		$inlineToolbar.css('top', 0);

		//Displaying
		jQuery("#ngeinline-toolbar").css('display', 'inline-block');        
	    }
	    else
	    	jQuery('#ngeinline-toolbar-status').html(elementTitle).show();
	    
	}).mouseleave(function () {
	    jQuery("#ngeinline-toolbar").css('display', 'none');
	    jQuery('body').prepend(jQuery("#ngeinline-toolbar"));
	    jQuery(this).closest(".ngeeditablestructure").find(".ngetoolbar-status").html('').hide();
	});
	
	jQuery(".ngeinlineeditable").each(function () {
	    jQuery(this).addClass('ngeeditable');
	    
	});
		
    };
    /*disableEditablePart*/
    disableInlineEditableElements = function ($selector) {
	$selector.find(".ngeinlineeditable").removeClass('ngeeditable')
	.unbind("mouseenter")
	.unbind("mouseleave");
	/*.editable('destroy', true);*/
		
    };

    /*Triggering functions.*/
    jQuery(document).on( "ngeStartEdition", function() {
	enableNgeInlineEditingElements();
    });

    jQuery(document).on( "ngeDisableEdition", function() {
	disableNgeInlineEditingElements();
    });