	/*Activate sortable element in Layout    */
    enableArticleSortableLayout = function () {
    	var startLayout, currentlayout;
    	/*Current article becomes sortable (connectable with all other layouts)*/
    	var sortableArticle = jQuery("div.ngelayout-article").children(".content");
    	
    	/*Make sortable all child elements in the article, except other parts (selected further as editable parts)*/
    	/*In article content, enable Adding all editable content inside except parts*/
    	var sortableContent = sortableArticle.find("div, form, body, fieldset, h1, h2, h3, h4, h5, h6, pre, li, span,th , td").not(".part").not(".part *");
    	sortableContent.addClass("ngelayout-editablecontent");
    	
		/*All sortable elements : editable parts and their inside content*/
		var sortableElements = sortableArticle.add(sortableContent);
			
    	/*selectorArticleSortable.sortable({*/
        sortableElements.sortable({
            placeholder: "ngelayout-sortable-article",
            /*handle: ".ngetlb-move",*/
	handle: "#ngemove-toolbar",
            /* SORTABLE IN ALL LAYOUT This version is used to connect with other sortable layout
             * connectWith: ".ngelayout-article .content, .ngelayout-module .custom, .ngelayout-page .content, .ngelayout-part, .ngelayout-editablecontent",*/
            /* SORTABLE ONLY FOR REODER This version only accept sortable inside the current element*/
            connectWith: ".ngelayout-editablecontent",
            cursorAt: {top: 35, left: 35},
            start: function (e, ui) {
            	/*Set part sortable active to not trigger mouseover on other part when dragging a part*/
            	isPartSortable = true;
            	jQuery('#part-toolbar').hide();
            	if (!ui.item.hasClass('ngedraggable-mainbar')) {/*Comes from another sortable content*/
                    /* SORTABLE IN ALL LAYOUT This version is used to connect with other sortable layout
                     * enableSortableDragDropZone(["article", "part", "module"]);*/
                    /* SORTABLE ONLY FOR REORDER This version only accept sortable inside the current element*/
                    enableSortableDragDropCurrentZone(jQuery(this));
            	}
            	
            	startLayout = ui.item.closest(".nge-article-content");
            },
            helper: function (event, ui) {
            	var name = "";
            	var clone = jQuery(ui).clone(true);
            	
            	var name = clone.data("part-label");
            	
			    /*Get ajax default part html and return the html code*/
			    var target = '<div id="nge-sortable-helper">'+name+'</div>';
			    return target;
			},
            receive: function (e, ui) {      
                var partType = ui.item.data('part');
                var m_id	= ui.item.data('module-id');
                if (!ui.item.hasClass('ngedraggable-mainbar')) {
                	/*Come from another sortable content*/
        		    if (typeof m_id !== "undefined") {
        		    	if (ui.item.hasClass("ngemodule-part")) {/*It's a part module*/
        		    		/*Remove div Module and keep only the div part*/
        		    		var partElement = ui.item.find(".part");
        		    		ui.item.replaceWith(partElement);
        		    		/*Trash the module*/
        		    		removeModuleFromPosition(m_id);
        		    		/*Save the article with the new part*/
        		    		/*Auto save with update function*/
        		    	}else{/*Other module*/
        		    		var articleId = ui.item.closest(".nge-article-content").data('nge-id');
/*        		    		var objectCreated = saveModuleToArticle(m_id, articleId);*/
        		    		
        		    		/*Replace module by loadposition code*/
/*        		    		ui.item.replaceWith(objectCreated.html);*/
        		    		
        		    		var data = {
								"element": "module",
								"destination": "article",
								"m_id": m_id,
								"articleId": articleId,
							};
					    	
		    		    	updateDraggableElement(ui.item, data);
        		    		/*Save the article with the new part*/
        		    		/*Auto save with update function*/
        		    	}
        		    }else if(typeof partType !== "undefined"){
        				/*It's a part*/
        		    	currentlayout = ui.item.closest(".nge-article-content");
        		    	saveArticle(currentlayout);
        		    }
                }
            },
            update: function( event, ui ) {
                
            	if (ui.item.hasClass('ngedraggable-mainbar')) {
                	/*Active the creation of part if come from drag&drop*/
                        /*Test if we are in a nested article sortable if yes we don't update because it's always done by the parent article*/
                        if(!jQuery(this).hasClass("ngelayout-editablecontent")){
                            addPartToLayout(ui);
                        }
                }else{
                	/*Update start layout if defined*/
                	if (typeof startLayout !== 'undefined'){
                		saveArticle(startLayout);
    	            }
                }
            },
            stop: function (e, ui) {
            	
            	disableSortableDragDropZone();
            	isPartSortable = false;
            }
        });
    };

    disableArticleSortableLayout = function () {	
    	jQuery(".ngelayout-article").find(".ngelayout-editablecontent").removeClass("ngelayout-editablecontent");
		jQuery(".ngelayout-article").find(".content.ui-sortable").sortable("destroy");
    };
    
    
    /*Triggering functions.*/
    jQuery(document).on( "ngeEnableEdition", function() {
	enableArticleSortableLayout();
    });

    jQuery(document).on( "ngeDisableEdition", function() {
	disableArticleSortableLayout();
    });