/**
 *GLOBAL FUNCTION USED FOR SORTABLE LAYOUT
*/


/*jQuery(document).ready(function() {*/

    enableSortableDragDropCurrentZone = function(layout){
        jQuery('.ngedropping').removeClass('ngedropping');
        jQuery('.ngedragging').removeClass('ngedragging');

        layout.parents().addClass("ngedragging");
        if(layout.hasClass("ngedragging")){
            layout.removeClass('ngedragging');
        }
        layout.addClass('ngedropping');
    };
    
	enableSortableDragDropZone = function(currentDraggableElementDestinations){

        jQuery('.ngedropping').removeClass('ngedropping');
        jQuery('.ngedragging').removeClass('ngedragging');
        
        jQuery('div.ngelayout > .content').addClass("ngedragging");
        
		jQuery.each(currentDraggableElementDestinations, function(index, val){
			var currentLayout = jQuery('div.ngelayout-'+val);
			
			if(currentLayout.parents("div.ngelayout").length == 0){
				currentLayout.children(".content").parents().addClass("ngedragging");
			}
			
			if(currentLayout.children(".content").hasClass("ngedragging")){
				currentLayout.children(".content").removeClass('ngedragging');
			}
			
			currentLayout.children(".content").addClass('ngedropping');
		});
	};
	
	disableSortableDragDropZone = function(){
            jQuery('div.ngedropping').removeClass('ngedropping');
            jQuery('.ngedragging').removeClass('ngedragging');
            jQuery(".isDraggablePart").remove();
	};
	
	updateDraggableElement = function(currentItem, data){
		var url = "index.php?option=com_nge&task=draggable.updateElement";
		
		jQuery.ajax({
		    url: url,
		    data: data,
		    success: function (resultJson) {
				try {
				    result = jQuery.parseJSON(resultJson);
				    if (result.success == 1) {
				    	if(result.element == "module" && result.destination == "article"){
				    		/*Replace element*/
						    currentItem.replaceWith(result.html);
				    	}else if(result.element == "part" && typeof result.part !== "undefined") {
					    	/*Moving toolbar at the starting of the document, to avoid being removed with the part*/
					    	jQuery('#part-toolbar').hide();
					    	
						    /*Replace element*/
						    currentItem.replaceWith(result.html);
						    
							/*Add edit attributes and events for this new part if exist*/
							enableNgePartToolbar('#part-' + result.part.id);
							enableNgeInlineEditing('#part-' + result.part.id);
							enableNgeItemsAddable('#part-'+result.part.id);
							enableNgeItemsSortable('#part-'+result.part.id);																					
						}
				    }else {
						bootbox.alert(result.message);
				    }
				} catch (err) {
				    bootbox.alert(COM_NGE_JS_EDITING_UNABLE_DRAGGABLE_ELEMENT + "<br>" + err.toString());
				}
		    },
		    error: function (result) {
				bootbox.alert(COM_NGE_JS_EDITING_UNABLE_DRAGGABLE_ELEMENT);
		    }
		});
	};
	
	activeSortableLayout = function(selectorPartSortable){
		var currentPartData = selectorPartSortable.data("ngelayout");
		
		if (typeof currentPartData !== "undefined"){
			switch (currentPartData) {
				case "page":
					/*enablePageSortableLayout(selectorPartSortable.children("div.content"));*/
				break;
	
				/*Here Add the enable sortable layout function for the other layout Wall, grid, etc. When they will be created*/
	/*			case "wall":
					enableWallSortableLayout(selectorPartSortable.children("div.content"));
				break;	*/
			}
		}
	};
	
	saveCurrentLayout = function(currentLayout){
		if (currentLayout.hasClass('ngelayout-page')){
		    removePagePart(currentElement.closest(".part"));
		}else if (currentLayout.hasClass('ngelayout-grid')){
/*			removeGridPart(pk, content);*/
		}else if (currentLayout.hasClass('ngelayout-wall')){
/*			removeWallPart(pk, content);*/
		}else if (currentLayout.hasClass('ngelayout-workshop')){
			removeWorkshopPart(currentElement.closest(".part"));		
		}else if (currentLayout.hasClass('ngelayout-position')){
			removePositionModulePart(currentElement.closest(".ngemodule-part"));
		}else if (currentLayout.hasClass('ngelayout-article')){
			var articleContent = currentLayout.closest(".nge-article-content");
			saveArticle(articleContent);
		}else if (currentLayout.hasClass('ngelayout-part')){
			removePartPart(currentElement.closest(".part"));
		}else if (currentLayout.hasClass('ngelayout-module')){
			saveModule(currentLayout.children(".custom"));
		}
	};
	
	addPartToLayout = function(ui){
		var dragDest 	= ui.item.data('ngedraggable-dest');
    	var dragType 	= ui.item.data('ngedraggable-type');
    	var dragRef 	= ui.item.data('ngedraggable-ref');
    	var dragTitle 	= ui.item.data('ngedraggable-title');
    	
    	/*In case of old ones*/
    	jQuery("#part-temp-dropped").remove();
    	
        /*temporary part will be found after config screen by the "part-temp-dropped" class*/
        var tempDroppedPart = '<div id="part-temp-dropped" class="part" style="display:block; padding:10px"></div>';
        ui.item.hide();
        ui.item.after(tempDroppedPart);

        if (dragType == 'part') {
        	//jQuery("#partconfig_iframe").contents().find("html").html('<div style="margin-left:50%;margin-top:100px;"><img src="'+rootUrl+'components/com_nge/assets/images/spinner.gif" /></div>');
        	jQuery("#partConfigForm").modal("show");
        	//jQuery("#partconfig_iframe").attr("src", "index.php?option=com_nge&view=config&layout=default&caller=layout.page&mode=create&format=raw&plname=" + dragRef);
	document.getElementById("partconfig_iframe").contentWindow.loadContent("index.php?option=com_nge&view=config&layout=form&caller=layout.page&mode=create&format=raw&plname=" + dragRef);		
	    }else{				    			
	    	/*var data = {};
        	
        	switch (dragType) {
				case "module":
					data = {
		    			"module": ui.item.data('ngedraggable-module'),
		    			"articleId": ui.item.closest( ".ngelayout-article" ).data('nge-id'),
			    	};
					break;
			}
        	
        	showLayoutWizardPopover(dragType, dragRef, 'article', dragTitle, data);*/
	    }
        
        ui.item.remove();
	};
/*});*/