	var sortableModules, sortableModuleElements;
    
    /*Activate sortable element in module*/
    enableModuleSortableLayout = function (sortableModuleSelector) {
    	sortableModules = typeof sortableModuleSelector !== 'undefined' ? jQuery(sortableModuleSelector) : jQuery(".ngelayout-module").children(".custom");
    	
    	/*In editable parts content, enable Adding all editable content inside except parts*/
    	var sortableContent = sortableModules.find("div, form, body, fieldset, h1, h2, h3, h4, h5, h6, pre, li, span,th , td").not("div.part").not("div.part *");
    	sortableContent.addClass("ngelayout-editablecontent");
    	
    	/*All sortable elements : editable parts and their inside content*/
    	sortableModuleElements = sortableModules.add(sortableContent);
		
    	var startLayout, currentlayout;

    	/*sortableModuleselector.sortable({*/
    	sortableModuleElements.sortable({
            placeholder: "ngelayout-sortable-module",
            /*handle: ".ngetlb-move",*/
	handle: "#ngemove-toolbar",
            connectWith: ".ngelayout-module .custom, .ngelayout-article .content, .ngelayout-position .content, .ngelayout-page .content, .ngelayout-part, .ngelayout-editablecontent",
            cursorAt: {top: 35, left: 35},
            start: function (e, ui) {
            	/*Set part sortable active to not trigger mouseover on other part when dragging a part*/
            	isPartSortable = true;     	
            	jQuery('#part-toolbar').hide();
            	
            	if (!ui.item.hasClass('ngedraggable-mainbar')) {/*Come from another sortable content*/
            		enableSortableDragDropZone(["module", "article", "position", "page", "part"]);
            	}
            	
            	startLayout = ui.item.closest(".ngelayout-module");
            },
            helper: function (event, ui) {
            	var name = "";
            	var clone = jQuery(ui).clone(true);
            	
            	var name = clone.data("part-label");

			    /*Get ajax default part html and return the html code*/
			    var target = '<div id="nge-sortable-helper">'+name+'</div>';
			    return target;
			},
            receive: function (e, ui) {

                var partType 	= ui.item.data('part');
                var m_id		= ui.item.data('module-id');

                if (!ui.item.hasClass('ngedraggable-mainbar')) {
                	/*Come from another sortable content (module or part)*/
        		    if (typeof m_id !== "undefined") {
        		    	/*It's a module*/
        		    	if (ui.item.hasClass("ngemodule-part")) {
        		    		/*It's a part module*/
        		    		/*Remove div Module and keep only the div part*/
        		    		var partElement = ui.item.find(".part");
        		    		ui.item.replaceWith(partElement);
        		    		/*Trash the module*/
        		    		removeModuleFromPosition(m_id);
        		    		
        		    		currentlayout = ui.item.closest(".ngelayout-module");
            		    	saveModule(currentlayout.children(".custom"));
        		    	}else{
        		    		/*Other module*/
        		    		var articleId = ui.item.closest(".nge-article-content").data('nge-id');
        		    		
        		    		var data = {
				    			"element": "module",
				    			"destination": "article",
					    	    "m_id": m_id,
					    	    "articleId": articleId,
						    };
					    	
		    		    	updateDraggableElement(ui.item, data);
        		    		/*Save the artcle with the new part*/
        		    		/*Auto save with update function*/
        		    	}
        		    }else if(typeof partType !== "undefined"){
        				/*It's a part*/
        		    	currentlayout = ui.item.closest(".ngelayout-module");
        		    	saveModule(currentlayout.children(".custom"));
        		    }
               }
            },
            update: function( event, ui ) {
                
                if (ui.item.hasClass('ngedraggable-mainbar')) {
                	/*Active the creation of part if come from drag&drop*/
                	addPartToLayout(ui);
                }else{
                	/*Update start layout if defined*/
                	if (typeof startLayout !== 'undefined'){
                		saveModule(startLayout.children(".custom"));
    	            }
                }
            },
            stop: function (e, ui) {
            	
            	disableSortableDragDropZone();
            	isPartSortable = false;
            }
        });
    };

    disableModuleSortableLayout = function () {
    	if (typeof sortableModuleElements !== "undefined" && sortableModuleElements.hasClass("ui-sortable"))
    		sortableModuleElements.sortable("destroy");
		
    	/*Content*/
    	if (typeof sortableModules !== "undefined")
        	sortableModules.find(".ngelayout-editablecontent").removeClass("ngelayout-editablecontent");
    };
    
    /*Referencing functions.
    Adding to editing functions pool */
    /*ngeEnableEditFunctions.push(enableModuleSortableLayout);
    ngeDisableEditFunctions.push(disableModuleSortableLayout);*/