
    enableEditablePositionLayout = function () {		
	jQuery("div.ngelayout-position").addClass('ngeeditable');
    };

    disableEditablePositionLayout = function () {
    	jQuery("div.ngelayout-position").removeClass('ngeeditable');
    };

    /**
     * @name savePartInModulePosition
     * @description save part in position, that is, in other words that means that we save the part in a joomla module
     * @param endPosition, partId, m_before_id
     * @returns object or false
     */
    savePartInModulePosition = function (endPosition, partId, m_before_id) {
    	var res = false;
    	
    	var url = "index.php?option=com_nge&task=part.savetoposition";
    	var token = jQuery('#tokenform').find('input').attr('name');
    	var data = {};
    	data['end_position'] = endPosition;
    	data['pk'] = partId;
    	data['m_before_id'] = m_before_id;
    	data[token] = 1;
    	
    	jQuery.ajax({
    	    url: url,
    	    data: data,
    	    async: false,
    	    success: function (resultJson) {
	    		try {
	    		    result = jQuery.parseJSON(resultJson);
	    		    res = result;
	    		} catch (err) {
	    		    bootbox.alert(COM_NGE_JS_EDITING_ARTICLE_UNABLE_MOVE_PART_TO_POSITION + "<br>" + err.toString());
	    		}
    	    },
    	    error: function (result) {
    	    	bootbox.alert(COM_NGE_JS_EDITING_ARTICLE_UNABLE_MOVE_PART_TO_MODULE);
    	    }
    	});
    	
    	return res;
    };

    /**
     * @name saveModulePosition
     * @description save the new module position
     * @param endPosition, m_id, m_before_id
     * @returns void
     */
    saveModulePosition = function (endPosition, m_id, m_before_id) {
    	var url = "index.php?option=com_nge&task=module.move";
    	var token = jQuery('#tokenform').find('input').attr('name');
    	var data = {};
    	data['end_position'] = endPosition;
    	data['m_id'] = m_id;
    	data['m_before_id'] = m_before_id;
    	data[token] = 1;
    	
    	jQuery.ajax({
    	    url: url,
    	    data: data,
    	    success: function (resultJson) {
	    		try {
	    		    result = jQuery.parseJSON(resultJson);
	    		} catch (err) {
	    		    bootbox.alert(COM_NGE_JS_EDITING_ARTICLE_UNABLE_MOVE_MODULE + "<br>" + err.toString());
	    		}
    	    },
    	    error: function (result) {
    	    	bootbox.alert(COM_NGE_JS_EDITING_ARTICLE_UNABLE_MOVE_MODULE);
    	    }
    	});
    };

    /**
     * @name afterPositionLayoutPartCreate
     * @description Called by config screen when new part has been created
     * @returns void
     */
    afterPositionLayoutPartCreate = function (result) {
    	var createParentDivModule = '<div id="module-'+result.m_id+'" class="ngemodule ngemodule-part" data-module-label="'+result.title+'" data-module-id="'+result.m_id+'">';
    	createParentDivModule += result.html;
    	createParentDivModule += '</div>';
    	
    	/*Finding current dropped part with the part-temp-dropped class*/
		currentThumbTemporary = jQuery("#part-temp-dropped");
		currentThumbTemporary.after(createParentDivModule);
		currentThumbTemporary.remove();
	
		/*Add edit attributes and events for this new part*/
		enableNgePartToolbar('#part-' + result.pk);
		enableNgeInlineEditing('#part-' + result.pk);
		enableNgeItemsAddable('#part-'+result.pk);
		enableNgeItemsSortable('#part-'+result.pk);
		
		activeSortableLayout(jQuery('#part-'+result.pk));
    };

    /**
     * @name afterPositionLayoutModuleCreate
     * @description Called by config screen when new part has been created
     * @returns void
     */
    afterPositionLayoutModuleCreate = function (result) {
    	
    	var createParentDivModule = '<div id="module-'+result.m_id+'" class="ngemodule ngemodule-joomla" data-module-label="'+result.title+'" data-module-id="'+result.m_id+'">';
    	createParentDivModule += result.html;
    	createParentDivModule += '</div>';
    	
    	/*Finding current dropped module with the part-temp-dropped class*/
		currentThumbTemporary = jQuery("#part-temp-dropped");
		currentThumbTemporary.after(createParentDivModule);
		currentThumbTemporary.remove();
	
		/*Add edit attributes and events for this new module content*/
		updateNgeModuleEditable('#module-' + result.m_id);
    };

    /**
     * @name afterPositionLayoutModuleUpdate
     * @description Called by config screen when a module has been updated
     * @returns void
     */
    afterPositionLayoutModuleUpdate = function (result) {
    	
		jQuery('#module-' + result.m_id).html(result.html);
    };

    /*Triggering functions.*/
    jQuery(document).on( "ngeEnableEdition", function() {
	enableEditablePositionLayout();
    });

    jQuery(document).on( "ngeDisableEdition", function() {
	disableEditablePositionLayout();
    });

