    enableDraggableElementToLayout  = function(){
        jQuery(document).on("mouseenter", ".ngedraggable-mainbar", function(){
            activateDraggableElement(jQuery(this));
        }).on("mouseleave", ".ngedraggable-mainbar", function(){
            activateDraggableElement(jQuery(this));
        });
    };
	
    disableDraggableElementToLayout  = function(){
        jQuery(".ngedraggable-mainbar").off("mouseenter mouseleave");
    };
	
	activateDraggableElement = function(selector){
		var currentDraggableElement = selector;
                /*TODO : Module à été retiré temporairement. Remettre quand on veut le faire fonctionner. Attention le drag dans un module fonctionne peut etre pas.*/
		var allDraggableDestinations = ["article", "position", "page", "part", "workshop", "multiple", "wall"];
		var disableDraggableDestinations = allDraggableDestinations;
		var currentDraggableElementDestinations = currentDraggableElement.data("ngedraggable-dest").split(" ");
		var connectToSortable = "";
		
		var length = currentDraggableElementDestinations.length;
		jQuery.each(currentDraggableElementDestinations, function(index, val){
			disableDraggableDestinations.splice(disableDraggableDestinations.indexOf(val), 1);
			if(index == (currentDraggableElementDestinations.length - 1)){
				if(val == "part")
					connectToSortable += ".ngelayout-"+val;
				else if (val == "module")
					connectToSortable += ".ngelayout-"+val+" > .custom";
				else
					connectToSortable += ".ngelayout-"+val+" > .content";
			}else{
				if(val == "part")
					connectToSortable += ".ngelayout-"+val+", ";
				else if (val == "module")
					connectToSortable += ".ngelayout-"+val+" > .custom,";
				else
					connectToSortable += ".ngelayout-"+val+" > .content, ";
			}   
		});

		currentDraggableElement.draggable({
			connectToSortable: connectToSortable,
			cursor: "move",
			appendTo: "body",
			cursorAt: {top: 35, left: 35},
			scroll: true,
			scrollSensitivity: 100,
			helper: function (event, ui) {
			    /*Get ajax default part html and return the html code*/
			    var clone = jQuery(this).clone(true);
			    var cloneHtml = clone.html();
                            var dataProperties = "";
                                    
                            jQuery(jQuery(this)[0].attributes).each(function() {
                                if(this.nodeName.indexOf("data-ngedraggable") !== -1){
                                    dataProperties += this.nodeName+'="'+this.nodeValue+'" ';
                                }
                            });

			    var target = '<div class="isDraggablePart ngedraggable-mainbar" '+dataProperties+' style="display:block;padding:10px; background:#FFFFFF;max-width:64px;height:64px;z-index:1999;">' + cloneHtml + '</div>';  
            	
			    return target;
			},
			start: function(event, ui){
            	/*Set part sortable active to not trigger mouseover on other part when dragging a part*/
            	isPartSortable = true;
            	jQuery('#part-toolbar').hide();
            	
				if (typeof currentDraggableElements !== "undefined")
					currentDraggableElements.unbind("mouseenter mouseleave");
				
				jQuery("#part-temp-dropped").remove();

				enableSortableDragDropZone(currentDraggableElementDestinations);

				/*Disable all not permitted draggable destination*/
				toogleSortableLayout("disable", disableDraggableDestinations);
			},
			stop: function(event, ui){
				isPartSortable = false;
				
				disableSortableDragDropZone();
				
				currentDraggableElement.draggable("destroy");
				jQuery(".isDraggablePart").remove();
				
				/*Enable all not permitted draggable destination for the next drag*/
				toogleSortableLayout("enable", disableDraggableDestinations);
			}
	    });
	};
	
	desactivateDraggableElement = function(selector){
		if (typeof selector !== "undefined" && selector.hasClass("ui-draggable"))
			selector.draggable("destroy");
	};
	
	toogleSortableLayout = function(action, arrayDisableDestinations){
		/*action = enable or disable*/
		jQuery.each(arrayDisableDestinations, function(index, val){
			var functionName = action+val.charAt(0).toUpperCase()+val.substr(1)+"SortableLayout";
			
			if( typeof(window[functionName]) == "function" ){
				window[functionName]();
			}
		});
	};

	
    /*Triggering functions.*/
    jQuery(document).on( "ngeEnableEdition", function() {
	enableDraggableElementToLayout();
    });

    jQuery(document).on( "ngeDisableEdition", function() {
	disableDraggableElementToLayout();
    });

	