<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */

defined('_JEXEC') or die;

function chartTitle($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::radio($objectPrefix . 'position', 'COM_NGE_POSITION', 'COM_NGE_DESCRIPTION_TEXT_ALIGN', 'default',  array(
    	array('default', 'COM_NGE_POSITION_TOP', 'data-target="field:margin"'), 
    	array('floating', 'COM_NGECHARTS_FLOATING','data-target="field:verticalalign"')
    	));
    // vertical align
    $form[] = NgeFields::radio($objectPrefix . 'verticalalign', 'COM_NGECHARTS_VERTICALALIGN', 'COM_NGE_DESCRIPTION_TEXT_ALIGN', 'top',  array(
	array('top', 'COM_NGE_POSITION_TOP'), 
    	array('middle', 'COM_NGE_POSITION_MIDDLE'), 
    	array('bottom', 'COM_NGE_POSITION_BOTTOM')
    	)); 

        // horizontal align
    $form[] = NgeFields::radio($objectPrefix . 'align', 'COM_NGE_TEXT_ALIGN', 'COM_NGE_DESCRIPTION_TEXT_ALIGN', 'center',  array(
    	array('left', 'COM_NGE_TEXT_ALIGN_LEFT'), 
    	array('center', 'COM_NGE_TEXT_ALIGN_CENTER'), 
    	array('right', 'COM_NGE_TEXT_ALIGN_RIGHT')
    	));

    $form[] = NgeFields::slider($objectPrefix . 'x','COM_NGECHARTS_OFFSETX','COM_NGE_DESCRIPTION_SHADOW_OFFSETX','0', 'min="-200" max="200"step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'y','COM_NGECHARTS_OFFSETY','COM_NGE_DESCRIPTION_SHADOW_OFFSETY','0', 'min="-200" max="200"step="1"');

	return implode($form);
    
}

function chartTitleMargin($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::slider($objectPrefix . 'margin','COM_NGE_MARGIN','COM_NGE_DESCRIPTION_HPADDING','15', 'min="0" max="200" step="1"');

    return implode($form);    
}

function chartTitleFont($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::font($objectPrefix .'name', 'COM_NGE_FONT_NAME', 'COM_NGE_DESCRIPTION_FONT_NAME');
    $form[] = NgeFields::color($objectPrefix .'color', 'COM_NGE_FONT_COLOR', 'COM_NGE_DESCRIPTION_FONT_COLOR', '#333333');
    $form[] = NgeFields::slider($objectPrefix .'size', 'COM_NGE_FONT_SIZE', 'COM_NGE_DESCRIPTION_FONT_SIZE', '18', 'min="0" max="72"step="1"');
	$form[] = NgeFields::radio($objectPrefix .'weight', 'COM_NGE_FONT_WEIGHT', 'COM_NGE_DESCRIPTION_FONT_WEIGHT', 'normal', array(
	    array('lighter', 'COM_NGE_FONT_WEIGHT_LIGHTER'),
	    array('normal', 'COM_NGE_FONT_WEIGHT_NORMAL'),
	    array('bold', 'COM_NGE_FONT_WEIGHT_BOLD'),
	    array('bolder', 'COM_NGE_FONT_WEIGHT_BOLDER')
	    ));
        
     // font italic
	$form[] = NgeFields::radio($objectPrefix .'italic', 'COM_NGE_FONT_ITALIC', 'COM_NGE_DESCRIPTION_FONT_ITALIC', '0');

    // font case				    
	$form[] = NgeFields::radio($objectPrefix .'case', 'COM_NGE_FONT_CASE', 'COM_NGE_DESCRIPTION_FONT', 'none', array(
	    array('none', 'COM_NGE_DEFAULT', ''),
	    array('uppercase', 'COM_NGE_FONT_CASE_UPPERCASE'),
	    array('capitalize', 'COM_NGE_FONT_CASE_CAPITALIZE'),	    
	    array('lowercase', 'COM_NGE_FONT_CASE_LOWERCASE')
	    ));

	return implode($form);    
}

function chartSubtitleFont($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::font($objectPrefix .'name', 'COM_NGE_FONT_NAME', 'COM_NGE_DESCRIPTION_FONT_NAME');
    $form[] = NgeFields::color($objectPrefix .'color', 'COM_NGE_FONT_COLOR', 'COM_NGE_DESCRIPTION_FONT_COLOR', '#666666');
    $form[] = NgeFields::slider($objectPrefix .'size', 'COM_NGE_FONT_SIZE', 'COM_NGE_DESCRIPTION_FONT_SIZE', '12', 'min="0" max="72"step="1"');
	$form[] = NgeFields::radio($objectPrefix .'weight', 'COM_NGE_FONT_WEIGHT', 'COM_NGE_DESCRIPTION_FONT_WEIGHT', 'normal', array(
	    array('lighter', 'COM_NGE_FONT_WEIGHT_LIGHTER'),
	    array('normal', 'COM_NGE_FONT_WEIGHT_NORMAL'),
	    array('bold', 'COM_NGE_FONT_WEIGHT_BOLD'),
	    array('bolder', 'COM_NGE_FONT_WEIGHT_BOLDER')
	    ));
	$form[] = NgeFields::radio($objectPrefix .'italic', 'COM_NGE_FONT_ITALIC', 'COM_NGE_DESCRIPTION_FONT_ITALIC', '0');
	$form[] = NgeFields::radio($objectPrefix .'case', 'COM_NGE_FONT_CASE', 'COM_NGE_DESCRIPTION_FONT', 'none', array(
	    array('none', 'COM_NGE_DEFAULT', ''),
	    array('uppercase', 'COM_NGE_FONT_CASE_UPPERCASE'),
	    array('capitalize', 'COM_NGE_FONT_CASE_CAPITALIZE'),
	    array('lowercase', 'COM_NGE_FONT_CASE_LOWERCASE')	    
	    ));

	return implode($form);    
}

function chartFont($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::font($objectPrefix .'name', 'COM_NGE_FONT_NAME', 'COM_NGE_DESCRIPTION_FONT_NAME');
    $form[] = NgeFields::color($objectPrefix .'color', 'COM_NGE_FONT_COLOR', 'COM_NGE_DESCRIPTION_FONT_COLOR', '#666666');
    $form[] = NgeFields::slider($objectPrefix .'size', 'COM_NGE_FONT_SIZE', 'COM_NGE_DESCRIPTION_FONT_SIZE', '12', 'min="0" max="72"step="1"');
	$form[] = NgeFields::radio($objectPrefix .'weight', 'COM_NGE_FONT_WEIGHT', 'COM_NGE_DESCRIPTION_FONT_WEIGHT', 'normal', array(
	    array('lighter', 'COM_NGE_FONT_WEIGHT_LIGHTER'),
	    array('normal', 'COM_NGE_FONT_WEIGHT_NORMAL'),
	    array('bold', 'COM_NGE_FONT_WEIGHT_BOLD'),
	    array('bolder', 'COM_NGE_FONT_WEIGHT_BOLDER')
	    ));
        
	return implode($form);    
}


function chartDisplay($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = '<ul class="nav nav-tabs" data-tabs="tabs">
		<li class="active"><a href="#chart_display_display" data-toggle="tab">'.NGE::translate('COM_NGE_DISPLAY').'</a></li>
		 <li><a href="#chart_display_animations" data-toggle="tab">'.NGE::translate('COM_NGECHARTS_ANIMATION').'</a></li>
		<li><a href="#chart_display_3d" data-toggle="tab">'.NGE::translate('COM_NGECHARTS_3D').'</a></li>
	  </ul>
	  <div class="tab-content">';
    $form[] = '	<div class="tab-pane active" id="chart_display_display">';
    $form[] = NgeFields::radio($objectPrefix . 'width.mode','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_BACKGROUND_STYLE','auto', array(
        array('auto','COM_NGE_AUTO'),
        array('custom','COM_NGE_CUSTOM','data-target="field:chart[width][value]"')
    ));
    $form[] = NgeFields::text($objectPrefix . 'width.value','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_BACKGROUND_STYLE','300');

        $form[] = NgeFields::radio($objectPrefix . 'height.mode','COM_NGE_HEIGHT','COM_NGE_DESCRIPTION_BACKGROUND_STYLE','auto', array(
        array('auto','COM_NGE_AUTO'),
        array('custom','COM_NGE_CUSTOM','data-target="field:chart[height][value]"')
    ));
    $form[] = NgeFields::text($objectPrefix . 'height.value','COM_NGE_HEIGHT','COM_NGE_DESCRIPTION_BACKGROUND_STYLE','300');
    
    $form[] = NgeFields::slider($objectPrefix . 'spacing.top','COM_NGE_POSITION_TOP','COM_NGE_DESCRIPTION_HPADDING','10', 'min="0" max="500"step="1"');	
    $form[] = NgeFields::slider($objectPrefix . 'spacing.bottom','COM_NGE_POSITION_BOTTOM','COM_NGE_DESCRIPTION_HPADDING','15', 'min="0" max="500"step="1"');	
    $form[] = NgeFields::slider($objectPrefix . 'spacing.left','COM_NGE_POSITION_LEFT','COM_NGE_DESCRIPTION_HPADDING','10', 'min="0" max="500"step="1"');	
    $form[] = NgeFields::slider($objectPrefix . 'spacing.right','COM_NGE_POSITION_RIGHT','COM_NGE_DESCRIPTION_HPADDING','10', 'min="0" max="500"step="1"');	
    
    $form[] = '	</div>';

    $form[] = '	<div class="tab-pane" id="chart_display_animations">';
    $form[] = NgeFields::radio($objectPrefix . 'animation.mode','COM_NGECHARTS_ANIMATION','COM_NGE_DESCRIPTION_BACKGROUND_STYLE','auto', array(
	array('auto', 'COM_NGE_AUTO'),     	
	array('custom', 'COM_NGE_CUSTOM','data-target="field:duration field:limit"'),
	array('none', 'COM_NGE_NONE')
    ));
    $form[] = NgeFields::slider($objectPrefix . 'animation.duration','COM_NGE_EFFECT_DURATION','COM_NGE_EFFECT_DURATION_DESC','1.5', 'min="0" max="10"step="0.1"');   	
    $form[] = NgeFields::text($objectPrefix . 'animation.limit', 'COM_NGECHARTS_ANIMATIONLIMIT', 'COM_NGECHARTS_ANIMATIONLIMIT_DESC', '250');    
    $form[] = '	</div>';

    $form[] = '	<div class="tab-pane" id="chart_display_3d">';
    $form[] = NgeFields::radio($objectPrefix . 'display3d.display', 'COM_NGECHARTS_3D', '', '0',array(
    	array('1', 'JYES','data-target="field:width field:alpha field:beta field:depth"'),
    	array('0', 'JNO','data-success="false"')
    	));      
    
    $form[] = NgeFields::slider($objectPrefix . 'display3d.alpha','COM_NGECHARTS_ALPHA','COM_NGE_DESCRIPTION_BORDER_WIDTH','15', 'min="0" max="45" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'display3d.beta','COM_NGECHARTS_BETA','COM_NGE_DESCRIPTION_BORDER_WIDTH','15', 'min="-45" max="45" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'display3d.depth','COM_NGECHARTS_DEPTH','COM_NGE_DESCRIPTION_BORDER_WIDTH','50', 'min="0" max="100" step="1"');    
    $form[] = '	</div>';
    $form[] = '</div>';
    
    return implode($form);
    
}

/**
 * border group
 * used in text.title, text.label, text.dropcap, text.columns, text.expandable
 *         panels.panel, panels.thumbnails
 *         navigation.button, navigation.link
 *         images.image, images.zoomable
 *         galleries.ticker, galleries.thumbnails, galleries.slider, galleries.carousel, galleries.tabs
 *         media.video, media.flash
 * @param mixed $objectPrefix
 * @param bool $multiple 
 * @param integer $multipleIndex 
 * @return
 */
function chartBorder($objectPrefix, $multiple=false, $multipleIndex=0){
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

            $form[] = NgeFields::radio($objectPrefix . 'display', 'COM_NGE_DISPLAY', '', '0',array(
    	array('1', 'JYES','data-target="field:width field:color field:radius_width"'),
    	array('0', 'JNO','data-success="false"')
    	));      

    $form[] = NgeFields::slider($objectPrefix . 'width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_BORDER_WIDTH','1', 'min="0" max="50"step="1"');
    $form[] = NgeFields::color($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_BORDER_COLOR','#cccccc');
    $form[] = NgeFields::slider($objectPrefix . 'radius_width','COM_NGE_RADIUS','COM_NGE_DESCRIPTION_RADIUS','0', 'min="0" max="100"step="1"');
    
    return implode($form);
}

/**
 * background group
 * used in subitems in a part : background cannot be overflowed
 *         panels.panel, panels.thumbnails
 *         images.image, images.zoomable
 *         galleries.ticker, galleries.slider, galleries.carousel, galleries.tabs
 *         media.video, media.flash
 * @param mixed $objectPrefix
 * @param bool $multiple 
 * @param integer $multipleIndex 
 
 * @return
 */
function chartBackground($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    // background style
    $form[] = NgeFields::radio($objectPrefix . 'style','COM_NGE_STYLE','COM_NGE_DESCRIPTION_BACKGROUND_STYLE','none', array(
        array('none','COM_NGE_NONE', 'data-success="false"'),
        array('solid','COM_NGE_BACKGROUND_SOLID','data-target="field:color field:color_hover field:opacity field:background[overflow][direction] #'.str_replace('.', '_', $objectPrefix).'_effects"'),
        array('gradient','COM_NGE_BACKGROUND_GRADIENT','data-target="#'.str_replace('.', '_', $objectPrefix).'_direction field:color field:color2 field:color_hover field:color_hover2 field:opacity field:background[overflow][direction] #'.str_replace('.', '_', $objectPrefix).'_effects"')
    ));

    // background direction    
    $form[] = '<div id="'.str_replace('.', '_', $objectPrefix).'_direction">'; 
    $form[] = NgeFields::radio($objectPrefix . 'direction','COM_NGE_BACKGROUND_GRADIENT_DIRECTION','COM_NGE_DESCRIPTION_BACKGROUND_DIRECTION','vertical', array(
        array('vertical','COM_NGE_VERTICAL'), 
        array('horizontal','COM_NGE_HORIZONTAL'),
        array('circle','COM_NGE_CIRCLE'),
        array('ellipse','COM_NGE_ELLIPSE')
    ));
    $form[] = '</div>'; 

    $form[] = NgeFields::color($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_COLOR','#FFFFFF');
    $form[] = NgeFields::color($objectPrefix . 'color2','COM_NGE_COLOR_LAST','COM_NGE_DESCRIPTION_COLOR_LAST','#ffffff');
    $form[] = NgeFields::slider($objectPrefix . 'opacity','COM_NGE_OPACITY','COM_NGE_DESCRIPTION_BACKGROUND_OPACITY','100', 'min="0" max="100"step="1"');
    
    return implode($form);
    
}

function chartShadow($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();
    
    $form[] = NgeFields::radio($objectPrefix . 'style','COM_NGE_STYLE','COM_NGE_DESCRIPTION_BACKGROUND_STYLE','none', array(
        array('none','COM_NGE_NONE', 'data-success="false"'),
        array('default','COM_NGE_DEFAULT'),
        array('custom','COM_NGE_CUSTOM','data-target="#'.str_replace('.', '_', $objectPrefix).'_shadow"')
    ));        

    $form[] = '<div id="'.str_replace('.', '_', $objectPrefix).'_shadow">';     
    $form[] = NgeFields::slider($objectPrefix . 'offset_x','COM_NGECHARTS_OFFSETX','COM_NGE_DESCRIPTION_SHADOW_OFFSETX','0', 'min="0" max="20"step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'offset_y','COM_NGECHARTS_OFFSETY','COM_NGE_DESCRIPTION_SHADOW_OFFSETY','0', 'min="0" max="20"step="1"');
    $form[] = NgeFields::color($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_COLOR','#000000');
    $form[] = NgeFields::slider($objectPrefix . 'opacity','COM_NGE_OPACITY','COM_NGE_DESCRIPTION_BACKGROUND_OPACITY','15', 'min="0" max="100"step="1"');    
    $form[] = '</div>'; 
                
    return implode($form);
    
}


function chartLegendDisplay($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();    

    $form[] = NgeFields::radio($objectPrefix . 'orientation', 'COM_NGE_ORIENTATION', 'COM_NGE_SLIDER_ORIENTATION_DESC', 'horizontal', array(
    	array('horizontal', 'COM_NGE_HORIZONTAL'), 
    	array('vertical', 'COM_NGE_VERTICAL')
    ));  
    
    $form[] = NgeFields::radio($objectPrefix . 'position', 'COM_NGE_POSITION', 'COM_NGE_DESCRIPTION_TEXT_ALIGN', 'default',  array(
    	array('default', 'COM_NGECHARTS_POSITION_OUTSIDE', 'data-target="field:margin"'), 
    	array('floating', 'COM_NGECHARTS_FLOATING')
    	));
    // vertical align
    $form[] = NgeFields::radio($objectPrefix . 'verticalalign', 'COM_NGECHARTS_VERTICALALIGN', 'COM_NGE_DESCRIPTION_TEXT_ALIGN', 'bottom',  array(
	array('top', 'COM_NGE_POSITION_TOP'), 
    	array('middle', 'COM_NGE_POSITION_MIDDLE'), 
    	array('bottom', 'COM_NGE_POSITION_BOTTOM')
    	)); 
    $form[] = NgeFields::radio($objectPrefix . 'align', 'COM_NGE_TEXT_ALIGN', 'COM_NGE_DESCRIPTION_TEXT_ALIGN', 'center',  array(
    	array('left', 'COM_NGE_TEXT_ALIGN_LEFT'), 
    	array('center', 'COM_NGE_TEXT_ALIGN_CENTER'), 
    	array('right', 'COM_NGE_TEXT_ALIGN_RIGHT')
    	));
    
    $form[] = NgeFields::slider($objectPrefix . 'x','COM_NGECHARTS_OFFSETX','COM_NGE_DESCRIPTION_OFFSET','0', 'min="-1000" max="1000" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'y','COM_NGECHARTS_OFFSETY','COM_NGE_DESCRIPTION_OFFSET','0', 'min="-1000" max="1000" step="1"');

    
	
    
        $form[] = NgeFields::slider($objectPrefix . 'padding','COM_NGE_PADDING','COM_NGE_DESCRIPTION_HPADDING','8', 'min="0" max="100"step="1"');
        $form[] = NgeFields::slider($objectPrefix . 'margin','COM_NGECHARTS_EXTERNALMARGIN','COM_NGE_DESCRIPTION_HPADDING','12', 'min="0" max="100"step="1"');	

    return implode($form);
    
}

function chartLegendTitle($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();
    
    $form[] = NgeFields::font($objectPrefix .'name', 'COM_NGE_FONT_NAME', 'COM_NGE_DESCRIPTION_FONT_NAME');
    $form[] = NgeFields::color($objectPrefix .'color', 'COM_NGE_FONT_COLOR', 'COM_NGE_DESCRIPTION_FONT_COLOR', '#333333');
    $form[] = NgeFields::slider($objectPrefix .'size', 'COM_NGE_FONT_SIZE', 'COM_NGE_DESCRIPTION_FONT_SIZE', '12', 'min="0" max="72"step="1"');
    $form[] = NgeFields::slider($objectPrefix .'letter_spacing', 'COM_NGE_FONT_LETTER_SPACING', 'COM_NGE_DESCRIPTION_FONT_LETTER_SPACING', '0', 'min="-5" max="10"step="1"');
	$form[] = NgeFields::radio($objectPrefix .'weight', 'COM_NGE_FONT_WEIGHT', 'COM_NGE_DESCRIPTION_FONT_WEIGHT', 'bold', array(
	    array('lighter', 'COM_NGE_FONT_WEIGHT_LIGHTER'),
	    array('normal', 'COM_NGE_FONT_WEIGHT_NORMAL'),
	    array('bold', 'COM_NGE_FONT_WEIGHT_BOLD'),
	    array('bolder', 'COM_NGE_FONT_WEIGHT_BOLDER')
	    ));
	$form[] = NgeFields::radio($objectPrefix .'italic', 'COM_NGE_FONT_ITALIC', 'COM_NGE_DESCRIPTION_FONT_ITALIC', '0');
	$form[] = NgeFields::radio($objectPrefix .'case', 'COM_NGE_FONT_CASE', 'COM_NGE_DESCRIPTION_FONT', 'none', array(
	    array('none', 'COM_NGE_DEFAULT', ''),
	    array('uppercase', 'COM_NGE_FONT_CASE_UPPERCASE'),
	    array('capitalize', 'COM_NGE_FONT_CASE_CAPITALIZE'),	    
	    array('lowercase', 'COM_NGE_FONT_CASE_LOWERCASE')
	    ));

	return implode($form);    
}

function chartLegendItems($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::font($objectPrefix .'name', 'COM_NGE_FONT_NAME', 'COM_NGE_DESCRIPTION_FONT_NAME');
    $form[] = NgeFields::color($objectPrefix .'color', 'COM_NGE_FONT_COLOR', 'COM_NGE_DESCRIPTION_FONT_COLOR', '#333333');
    $form[] = NgeFields::color($objectPrefix .'color_hover', 'COM_NGE_FONT_COLOR_HOVER', 'COM_NGE_DESCRIPTION_FONT_COLOR_HOVER', '#000000');
    $form[] = NgeFields::color($objectPrefix .'color_hidden', 'COM_NGECHARTS_COLOR_HIDDEN', 'COM_NGE_DESCRIPTION_FONT_COLOR_HIDDEN', '#CCCCCC');
    $form[] = NgeFields::slider($objectPrefix .'size', 'COM_NGE_FONT_SIZE', 'COM_NGE_DESCRIPTION_FONT_SIZE', '12', 'min="0" max="72"step="1"');
	$form[] = NgeFields::radio($objectPrefix .'weight', 'COM_NGE_FONT_WEIGHT', 'COM_NGE_DESCRIPTION_FONT_WEIGHT', 'bold', array(
	    array('lighter', 'COM_NGE_FONT_WEIGHT_LIGHTER'),
	    array('normal', 'COM_NGE_FONT_WEIGHT_NORMAL'),
	    array('bold', 'COM_NGE_FONT_WEIGHT_BOLD'),
	    array('bolder', 'COM_NGE_FONT_WEIGHT_BOLDER')
	    ));
        
    
	return implode($form);    
}


/**
 * border group
 * used in text.title, text.label, text.dropcap, text.columns, text.expandable
 *         panels.panel, panels.thumbnails
 *         navigation.button, navigation.link
 *         images.image, images.zoomable
 *         galleries.ticker, galleries.thumbnails, galleries.slider, galleries.carousel, galleries.tabs
 *         media.video, media.flash
 * @param mixed $objectPrefix
 * @param bool $multiple 
 * @param integer $multipleIndex 
 * @return
 */
function chartLegendBorder($objectPrefix, $multiple=false, $multipleIndex=0){
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();
            
    // border width
    $form[] = NgeFields::slider($objectPrefix . 'width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_BORDER_WIDTH','0', 'min="0" max="50"step="1"');

    // border color
    $form[] = NgeFields::color($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_BORDER_COLOR','#999999');

    // border color jover
    //$form[] = NgeFields::color($objectPrefix . 'color_hover','COM_NGE_COLOR_HOVER','COM_NGE_DESCRIPTION_BORDER_COLOR_HOVER');
    
    // radius width
    $form[] = NgeFields::slider($objectPrefix . 'radius_width','COM_NGE_RADIUS','COM_NGE_DESCRIPTION_RADIUS','0', 'min="0" max="100"step="1"');
    
    return implode($form);
}

/**
 * background group
 * used in subitems in a part : background cannot be overflowed
 *         panels.panel, panels.thumbnails
 *         images.image, images.zoomable
 *         galleries.ticker, galleries.slider, galleries.carousel, galleries.tabs
 *         media.video, media.flash
 * @param mixed $objectPrefix
 * @param bool $multiple 
 * @param integer $multipleIndex 
 
 * @return
 */
function chartLegendBackground($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    // background style
    $form[] = NgeFields::radio($objectPrefix . 'style','COM_NGE_STYLE','COM_NGE_DESCRIPTION_BACKGROUND_STYLE','none', array(
        array('none','COM_NGE_NONE', 'data-success="false"'),
        array('solid','COM_NGE_BACKGROUND_SOLID','data-target="field:color field:color_hover field:opacity field:background[overflow][direction] #'.str_replace('.', '_', $objectPrefix).'_effects"'),
        array('gradient','COM_NGE_BACKGROUND_GRADIENT','data-target="#'.str_replace('.', '_', $objectPrefix).'_direction field:color field:color2 field:color_hover field:color_hover2 field:opacity field:background[overflow][direction] #'.str_replace('.', '_', $objectPrefix).'_effects"')
    ));

    // background direction    
    $form[] = '<div id="'.str_replace('.', '_', $objectPrefix).'_direction">'; 
    $form[] = NgeFields::radio($objectPrefix . 'direction','COM_NGE_BACKGROUND_GRADIENT_DIRECTION','COM_NGE_DESCRIPTION_BACKGROUND_DIRECTION','vertical', array(
        array('vertical','COM_NGE_VERTICAL'), 
        array('horizontal','COM_NGE_HORIZONTAL'),
        array('circle','COM_NGE_CIRCLE'),
        array('ellipse','COM_NGE_ELLIPSE')
    ));
    $form[] = '</div>'; 

    $form[] = NgeFields::color($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_COLOR','#FFFFFF');
    $form[] = NgeFields::color($objectPrefix . 'color2','COM_NGE_COLOR_LAST','COM_NGE_DESCRIPTION_COLOR_LAST','#ffffff');
    $form[] = NgeFields::slider($objectPrefix . 'opacity','COM_NGE_OPACITY','COM_NGE_DESCRIPTION_BACKGROUND_OPACITY','100', 'min="0" max="100"step="1"');

    return implode($form);    
}

function chartLegendShadow($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();
    
    $form[] = NgeFields::radio($objectPrefix . 'display','COM_NGE_DISPLAY','COM_NGE_DESCRIPTION_BACKGROUND_STYLE','0', array(
        array('1','JYES','data-target="#'.str_replace('.', '_', $objectPrefix).'_shadow"'),
    array('0','JNO', 'data-success="false"')
    ));        

    $form[] = '<div id="'.str_replace('.', '_', $objectPrefix).'_shadow">';     
    $form[] = NgeFields::slider($objectPrefix . 'offset_x','COM_NGECHARTS_OFFSETX','COM_NGE_DESCRIPTION_SHADOW_OFFSETX','0', 'min="0" max="20" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'offset_y','COM_NGECHARTS_OFFSETY','COM_NGE_DESCRIPTION_SHADOW_OFFSETY','0', 'min="0" max="20" step="1"');
    $form[] = NgeFields::color($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_COLOR','#000000');
    $form[] = NgeFields::slider($objectPrefix . 'opacity','COM_NGE_OPACITY','COM_NGE_DESCRIPTION_BACKGROUND_OPACITY','15', 'min="0" max="100" step="1"');    
    $form[] = '</div>'; 
                
    return implode($form);

}

function chartPlotareaDisplay($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::slider($objectPrefix . 'margins.top','COM_NGE_POSITION_TOP','COM_NGE_DESCRIPTION_HPADDING','0', 'min="0" max="500"step="1"');	
    $form[] = NgeFields::slider($objectPrefix . 'margins.bottom','COM_NGE_POSITION_BOTTOM','COM_NGE_DESCRIPTION_HPADDING','0', 'min="0" max="500"step="1"');	
    $form[] = NgeFields::slider($objectPrefix . 'margins.left','COM_NGE_POSITION_LEFT','COM_NGE_DESCRIPTION_HPADDING','0', 'min="0" max="500"step="1"');	
    $form[] = NgeFields::slider($objectPrefix . 'margins.right','COM_NGE_POSITION_RIGHT','COM_NGE_DESCRIPTION_HPADDING','0', 'min="0" max="500"step="1"');	



    return implode($form);    
}

/**
 * border group
 * used in text.title, text.label, text.dropcap, text.columns, text.expandable
 *         panels.panel, panels.thumbnails
 *         navigation.button, navigation.link
 *         images.image, images.zoomable
 *         galleries.ticker, galleries.thumbnails, galleries.slider, galleries.carousel, galleries.tabs
 *         media.video, media.flash
 * @param mixed $objectPrefix
 * @param bool $multiple 
 * @param integer $multipleIndex 
 * @return
 */
function chartPlotareaBorder($objectPrefix, $multiple=false, $multipleIndex=0){
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

        $form[] = NgeFields::radio($objectPrefix . 'display', 'COM_NGE_DISPLAY', '', '0',array(
    	array('1', 'JYES','data-target="field:width field:color"'),
    	array('0', 'JNO','data-success="false"')
    	));      
    
    // border width
    $form[] = NgeFields::slider($objectPrefix . 'width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_BORDER_WIDTH','1', 'min="1" max="50"step="1"');

    // border color
    $form[] = NgeFields::color($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_BORDER_COLOR','#cccccc');
    
    return implode($form);
}

/**
 * background group
 * used in subitems in a part : background cannot be overflowed
 *         panels.panel, panels.thumbnails
 *         images.image, images.zoomable
 *         galleries.ticker, galleries.slider, galleries.carousel, galleries.tabs
 *         media.video, media.flash
 * @param mixed $objectPrefix
 * @param bool $multiple 
 * @param integer $multipleIndex 
 
 * @return
 */
function chartPlotareaBackground($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    // background style
    $form[] = NgeFields::radio($objectPrefix . 'style','COM_NGE_STYLE','COM_NGE_DESCRIPTION_BACKGROUND_STYLE','none', array(
        array('none','COM_NGE_NONE', 'data-success="false"'),
        array('solid','COM_NGE_BACKGROUND_SOLID','data-target="field:color field:color_hover field:opacity field:background[overflow][direction] #'.str_replace('.', '_', $objectPrefix).'_effects"'),
        array('gradient','COM_NGE_BACKGROUND_GRADIENT','data-target="#'.str_replace('.', '_', $objectPrefix).'_direction field:color field:color2 field:color_hover field:color_hover2 field:opacity field:background[overflow][direction] #'.str_replace('.', '_', $objectPrefix).'_effects"'),
	array('image','COM_NGE_PATTERN'),
	array('image','COM_NGE_IMAGE', 'data-target="field:image"')
    ));

    // background direction    
    $form[] = '<div id="'.str_replace('.', '_', $objectPrefix).'_direction">'; 
    $form[] = NgeFields::radio($objectPrefix . 'direction','COM_NGE_BACKGROUND_GRADIENT_DIRECTION','COM_NGE_DESCRIPTION_BACKGROUND_DIRECTION','vertical', array(
        array('vertical','COM_NGE_VERTICAL'), 
        array('horizontal','COM_NGE_HORIZONTAL'),
        array('circle','COM_NGE_CIRCLE'),
        array('ellipse','COM_NGE_ELLIPSE')
    ));
    $form[] = '</div>'; 

    $form[] = NgeFields::color($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_COLOR','#FFFFFF');
    $form[] = NgeFields::color($objectPrefix . 'color2','COM_NGE_COLOR_LAST','COM_NGE_DESCRIPTION_COLOR_LAST','#ffffff');
    $form[] = NgeFields::slider($objectPrefix . 'opacity','COM_NGE_OPACITY','COM_NGE_DESCRIPTION_BACKGROUND_OPACITY','100', 'min="0" max="100"step="1"');
                
    // background image
    $form[] = NgeFields::filemanager($objectPrefix . 'image','COM_NGE_CONTENT_IMAGE','COM_NGE_DESCRIPTION_CONTENT_PICTURE','', 'images');
    
    
    return implode($form);
    
}

function chartPlotareaShadow($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();
    
    $form[] = NgeFields::radio($objectPrefix . 'style','COM_NGE_STYLE','COM_NGE_DESCRIPTION_BACKGROUND_STYLE','none', array(
        array('none','JNO', 'data-success="false"'),
        array('custom','JYES','data-target="#'.str_replace('.', '_', $objectPrefix).'_shadow"')
    ));        

    $form[] = '<div id="'.str_replace('.', '_', $objectPrefix).'_shadow">';     
    $form[] = NgeFields::slider($objectPrefix . 'offset_x','COM_NGECHARTS_OFFSETX','COM_NGE_DESCRIPTION_SHADOW_OFFSETX','0', 'min="0" max="20"step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'offset_y','COM_NGECHARTS_OFFSETY','COM_NGE_DESCRIPTION_SHADOW_OFFSETY','0', 'min="0" max="20"step="1"');
    $form[] = NgeFields::color($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_COLOR','#000000');
    $form[] = NgeFields::slider($objectPrefix . 'opacity','COM_NGE_OPACITY','COM_NGE_DESCRIPTION_BACKGROUND_OPACITY','15', 'min="0" max="100"step="1"');    
    $form[] = '</div>'; 
                
    return implode($form);
    
}



function chartCreditsContent($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::text($objectPrefix . 'text', 'COM_NGE_TEXT', '');
    $form[] = NgeFields::url($objectPrefix . 'url', 'COM_NGE_CONTENT_URL', '');
    

    return implode($form);
    
}

function chartCreditsDisplay($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::radio($objectPrefix . 'display', 'COM_NGE_DISPLAY', '', '1',array(
    	array('1', 'JYES','data-target="field:align field:verticalAlign field:x field:y"'),
    	array('0', 'JNO','data-success="false"')
    	));      
    
        // horizontal align
    $form[] = NgeFields::radio($objectPrefix . 'align', 'COM_NGE_TEXT_ALIGN', 'COM_NGE_DESCRIPTION_TEXT_ALIGN', 'right',  array(
    	array('left', 'COM_NGE_TEXT_ALIGN_LEFT'), 
    	array('center', 'COM_NGE_TEXT_ALIGN_CENTER'), 
    	array('right', 'COM_NGE_TEXT_ALIGN_RIGHT')
    	));

        // vertical align
    $form[] = NgeFields::radio($objectPrefix . 'verticalAlign', 'COM_NGE_TEXT_ALIGN', 'COM_NGE_DESCRIPTION_TEXT_ALIGN', 'bottom',  array(
	array('top', 'COM_NGE_POSITION_TOP'), 
    	array('middle', 'COM_NGE_POSITION_MIDDLE'), 
    	array('bottom', 'COM_NGE_POSITION_BOTTOM')
    	)); 

        $form[] = NgeFields::slider($objectPrefix . 'x','COM_NGECHARTS_OFFSETX','COM_NGE_DESCRIPTION_OFFSET','-10', 'min="-200" max="200" step="1"');
$form[] = NgeFields::slider($objectPrefix . 'y','COM_NGECHARTS_OFFSETY','COM_NGE_DESCRIPTION_OFFSET','-5', 'min="-200" max="200" step="1"');

    return implode($form);
    
}


function chartCreditsFont($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::font($objectPrefix .'name', 'COM_NGE_FONT_NAME', 'COM_NGE_DESCRIPTION_FONT_NAME');
    $form[] = NgeFields::color($objectPrefix .'color', 'COM_NGE_FONT_COLOR', 'COM_NGE_DESCRIPTION_FONT_COLOR', '#999999');    
    $form[] = NgeFields::slider($objectPrefix .'size', 'COM_NGE_FONT_SIZE', 'COM_NGE_DESCRIPTION_FONT_SIZE', '10', 'min="0" max="72"step="1"');
	$form[] = NgeFields::radio($objectPrefix .'weight', 'COM_NGE_FONT_WEIGHT', 'COM_NGE_DESCRIPTION_FONT_WEIGHT', 'bold', array(
	    array('lighter', 'COM_NGE_FONT_WEIGHT_LIGHTER'),
	    array('normal', 'COM_NGE_FONT_WEIGHT_NORMAL'),
	    array('bold', 'COM_NGE_FONT_WEIGHT_BOLD'),
	    array('bolder', 'COM_NGE_FONT_WEIGHT_BOLDER')
	    ));
        
    	$form[] = NgeFields::radio($objectPrefix .'italic', 'COM_NGE_FONT_ITALIC', 'COM_NGE_DESCRIPTION_FONT_ITALIC', '0');

	return implode($form);    
}

 function chartMultipleShapes($objectPrefix, $multiple=false, $multipleIndex=0){
     $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();
    
    $tabPrefix = str_replace('.', '_', $objectPrefix);
    
        $form[] = NgeFields::radio($objectPrefix . 'type','COM_NGE_SHAPE','COM_NGE_LINK_ON_CLINK','text', array(
            array('text', 'COM_NGE_TEXT','data-target="#'.$tabPrefix . '_text"'),
            array('label', 'COM_NGE_LABEL','data-target="#'.$tabPrefix . '_label"'),
            array('image', 'COM_NGE_IMAGE','data-target="#'.$tabPrefix . '_image"'),
            array('shape', 'COM_NGECHARTS_FIGURE','data-target="#'.$tabPrefix . '_shape"'),
            array('path', 'SVG','data-target="#'.$tabPrefix . '_path"')
        ), array('multiple' => $multiple, 'multipleIndex' => $multipleIndex));
    
    //$form[] = $multipleIndex;

    $form[] = '<div id="'.$tabPrefix . '_text" class="tab-pane tabs">
		<div class="tabbable tabs-left">
    		      <ul class="nav nav-tabs" data-tabs="tabs">
			<li class="active"><a href="#'.$tabPrefix . '_text_content" data-toggle="tab">'.NGE::translate('COM_NGE_CONTENT').'</a></li>
    			<li><a href="#'.$tabPrefix . '_text_display" data-toggle="tab">'.NGE::translate('COM_NGE_DISPLAY').'</a></li>
			<li><a href="#'.$tabPrefix . '_text_conditions" data-toggle="tab">'.NGE::translate('COM_NGE_CONDITIONS').'</a></li>
    			<li><a href="#'.$tabPrefix . '_text_font" data-toggle="tab">'.NGE::translate('COM_NGE_FONT').'</a></li>
    		      </ul>
    		      <div class="tab-content">';
    $form[] = '<div class="tab-pane active" id="'.$tabPrefix . '_text_content">';
        $form[] = NgeFields::radio($objectPrefix . 'text.source', 'COM_NGE_SOURCE', 'COM_NGE_DESCRIPTION_FONT_H', 'text',  array(
	array('text', 'COM_NGECHARTS_TEXT','data-target="field:label"'),
    	array('data', 'COM_NGECHARTS_DATA','data-target="field:field"'),	
	array('format', 'COM_NGE_CUSTOM','data-target="field:format"')
    	));

    $form[] = NgeFields::text($objectPrefix . 'text.label', 'COM_NGE_TEXT', 'COM_NGE_DESCRIPTION_BADGE', '', array('attributes' => 'class="span6"'));
    
         $form[] = NgeFields::select($objectPrefix . 'text.field','COM_NGECHARTS_DATA','COM_NGE_DESCRIPTION_SHADOW_STYLE','title', $multiple, $multipleIndex,
            array(
                "ajax" => false,
                "options" => array(
	    array('title','COM_NGE_TITLE'),
                    array('subtitle','COM_NGE_SUBTITLE'),
	    array('first.value','COM_NGECHARTS_FIRST_VALUE'),
                    array('first.label','COM_NGECHARTS_FIRST_LABEL'), 
	    array('last.value','COM_NGECHARTS_LAST_VALUE'), 
	    array('last.variation','COM_NGECHARTS_LAST_VARIATION'),
                    array('last.label','COM_NGECHARTS_LAST_LABEL'),	    
	    array('serie.label','COM_NGECHARTS_SERIE_LABEL')		    
                ),
                "target" => null,
                "multiple" => false
            )
        );
         
    $form[] = NgeFields::text($objectPrefix . 'text.format', 'COM_NGE_TEXT', 'COM_NGE_DESCRIPTION_BADGE', 'last : {last.value} ', array('attributes' => 'class="span6"'));
    $form[] = '		</div>		      
        			<div class="tab-pane" id="'.$tabPrefix . '_text_display">';
        $form[] = NgeFields::radio($objectPrefix . 'text.hposition.mode','COM_NGECHARTS_HPOSITION','COM_NGE_LINK_ON_CLINK','center', array(
            array('outsideleft','COM_NGE_POSITION_OUTSIDELEFT', 'data-target="#'.$tabPrefix . '_text_hposition""'), 
            array('left','COM_NGE_POSITION_LEFT', 'data-target="#'.$tabPrefix . '_text_hposition""'), 
            array('center','COM_NGE_POSITION_CENTER'), 
            array('right','COM_NGE_POSITION_RIGHT', 'data-target="#'.$tabPrefix . '_text_hposition""'), 
            array('outsideright','COM_NGE_POSITION_OUTSIDERIGHT', 'data-target="#'.$tabPrefix . '_text_hposition""')
        ));
        $form[] = '<div id="'.$tabPrefix . '_text_hposition">';
        $form[] = NgeFields::slider($objectPrefix . 'text.hposition.margin','COM_NGE_MARGIN','COM_NGE_DESCRIPTION_OFFSET','0', 'min="0" max="200" step="1"');
        $form[] = '</div>';

        $form[] = NgeFields::radio($objectPrefix . 'text.vposition.mode','COM_NGECHARTS_VPOSITION','COM_NGE_LINK_ON_CLINK','middle', array(
            array('outsidetop','COM_NGE_POSITION_OUTSIDETOP', 'data-target="#'.$tabPrefix . '_text_vposition"'), 
            array('abovetitle','COM_NGECHARTS_POSITION_ABOVETITLE', 'data-target="#'.$tabPrefix . '_text_vposition"'), 
            array('top','COM_NGE_POSITION_TOP', 'data-target="#'.$tabPrefix . '_text_vposition""'), 
            array('middle','COM_NGE_POSITION_MIDDLE'), 
            array('bottom','COM_NGE_POSITION_BOTTOM', 'data-target="#'.$tabPrefix . '_text_vposition""'), 
            array('outsidebottom','COM_NGE_POSITION_OUTSIDEBOTTOM', 'data-target="#'.$tabPrefix . '_text_vposition""')
        ));
        $form[] = '<div id="'.$tabPrefix . '_text_vposition">';
        $form[] = NgeFields::slider($objectPrefix . 'text.vposition.margin','COM_NGE_MARGIN','COM_NGE_DESCRIPTION_OFFSET','0', 'min="0" max="200" step="1"');	    
        $form[] = '</div>';
    $form[] = NgeFields::slider($objectPrefix . 'text.rotation','COM_NGECHARTS_ROTATION','COM_NGE_DESCRIPTION_OFFSET','0', 'min="0" max="360" step="1"');
    $form[] = '</div>';
    $form[] = '<div class="tab-pane" id="'.$tabPrefix . '_text_conditions">';




	$form[] = NgeFields::radio($objectPrefix . 'text.conditions.mode', 'COM_NGE_DISPLAY', 'COM_NGE_DESCRIPTION_FONT_H', 'all',  array(
    	array('all', 'COM_NGE_ALWAYS'), 
    	array('only', 'COM_NGE_ONLY','data-target="field:field field:operator field:value"')
    	));


    


         $form[] = NgeFields::select($objectPrefix . 'text.conditions.field','COM_NGECHARTS_DATA','COM_NGE_DESCRIPTION_SHADOW_STYLE','title', $multiple, $multipleIndex,
            array(
                "ajax" => false,
                "options" => array(
	    array('title','COM_NGE_TITLE'),
                    array('subtitle','COM_NGE_SUBTITLE'),
	    array('first.value','COM_NGECHARTS_FIRST_VALUE'),
                    array('first.label','COM_NGECHARTS_FIRST_LABEL'), 
	    array('last.value','COM_NGECHARTS_LAST_VALUE'), 
	    array('last.variation','COM_NGECHARTS_LAST_VARIATION'),
                    array('last.label','COM_NGECHARTS_LAST_LABEL'),	    
	    array('serie.label','COM_NGECHARTS_SERIE_LABEL')		    
                ),
                "target" => null,
                "multiple" => false
            )
        );


	$form[] = NgeFields::select($objectPrefix.'text.conditions.operator','','','', $multiple, $multipleIndex,
	    array(
		"ajax" => false,
		"options" => array(
		    array('equals', 'COM_NGECHARTS_DATA_EQUALS'),
		    array('different', 'COM_NGECHARTS_DATA_DIFFERENT'),
		    array('more', 'COM_NGECHARTS_DATA_MORE'),
		    array('moreorequals','COM_NGECHARTS_DATA_MOREOREQUALS'),
		    array('less','COM_NGECHARTS_DATA_LESS'),
		    array('lessorequals', 'COM_NGECHARTS_DATA_LESSOREQUALS')
		),
		"target" => null,
		"multiple" => false,
		"width" => '18%',
		"placeholder" => "Un opérateur",
		"class" => "ngefield_select_filter_operators"
	    )
	);
    $form[] = NgeFields::text($objectPrefix . 'text.conditions.value', '', '', '', array('attributes' => 'class="span4"'));	 	 
    $form[] = '</div>';
    $form[] = '<div class="tab-pane" id="'.$tabPrefix . '_text_font">';
    $form[] = NgeFields::font($objectPrefix .'text.font.name', 'COM_NGE_FONT_NAME', 'COM_NGE_DESCRIPTION_FONT_NAME');
    $form[] = NgeFields::color($objectPrefix .'text.font.color', 'COM_NGE_FONT_COLOR', 'COM_NGE_DESCRIPTION_FONT_COLOR', '#333333');
    $form[] = NgeFields::slider($objectPrefix .'text.font.size', 'COM_NGE_FONT_SIZE', 'COM_NGE_DESCRIPTION_FONT_SIZE', '16', 'min="0" max="72"step="1"');
	$form[] = NgeFields::radio($objectPrefix .'text.font.weight', 'COM_NGE_FONT_WEIGHT', 'COM_NGE_DESCRIPTION_FONT_WEIGHT', 'normal', array(
	    array('lighter', 'COM_NGE_FONT_WEIGHT_LIGHTER'),
	    array('normal', 'COM_NGE_FONT_WEIGHT_NORMAL'),
	    array('bold', 'COM_NGE_FONT_WEIGHT_BOLD'),
	    array('bolder', 'COM_NGE_FONT_WEIGHT_BOLDER')
	    ));
	$form[] = NgeFields::radio($objectPrefix .'text.font.italic', 'COM_NGE_FONT_ITALIC', 'COM_NGE_DESCRIPTION_FONT_ITALIC', '0');
	$form[] = NgeFields::radio($objectPrefix .'text.font.case', 'COM_NGE_FONT_CASE', 'COM_NGE_DESCRIPTION_FONT', 'none', array(
	    array('none', 'COM_NGE_DEFAULT', ''),
	    array('uppercase', 'COM_NGE_FONT_CASE_UPPERCASE'),
	    array('capitalize', 'COM_NGE_FONT_CASE_CAPITALIZE'),	    
	    array('lowercase', 'COM_NGE_FONT_CASE_LOWERCASE')
	    ));
    $form[] = '		</div>
    		      </div>
		            </div>
    		</div>';	

    //Data
        $form[] = '<div id="'.$tabPrefix . '_label" class="tab-pane tabs">
	    	<div class="tabbable tabs-left">
    		      <ul class="nav nav-tabs" data-tabs="tabs">
			    <li class="active"><a href="#'.$tabPrefix . '_label_content" data-toggle="tab">'.NGE::translate('COM_NGE_CONTENT').'</a></li>		      
    			     <li><a href="#'.$tabPrefix . '_label_display" data-toggle="tab">'.NGE::translate('COM_NGE_DISPLAY').'</a></li>
			    <li><a href="#'.$tabPrefix . '_label_conditions" data-toggle="tab">'.NGE::translate('COM_NGE_CONDITIONS').'</a></li>
			    <li><a href="#'.$tabPrefix . '_label_font" data-toggle="tab">'.NGE::translate('COM_NGE_FONT').'</a></li>
    			     <li><a href="#'.$tabPrefix . '_label_border" data-toggle="tab">'.NGE::translate('COM_NGE_BORDER').'</a></li>
    			     <li><a href="#'.$tabPrefix . '_label_background" data-toggle="tab">'.NGE::translate('COM_NGE_BACKGROUND').'</a></li>
    		      </ul>
    		      <div class="tab-content">';
    $form[] = '	<div class="tab-pane active" id="'.$tabPrefix . '_label_content">';

        $form[] = NgeFields::radio($objectPrefix . 'label.source', 'COM_NGE_SOURCE', 'COM_NGE_DESCRIPTION_FONT_H', 'text',  array(
	array('text', 'COM_NGECHARTS_TEXT','data-target="field:label"'),
    	array('data', 'COM_NGECHARTS_DATA','data-target="#'.$tabPrefix . '_label_data"'),	
	array('format', 'COM_NGE_CUSTOM','data-target="field:format"')
    	));

    $form[] = NgeFields::text($objectPrefix . 'label.label', 'COM_NGE_TEXT', 'COM_NGE_DESCRIPTION_BADGE', '', array('attributes' => 'class="span6"'));
    $form[] = '<div class="tab-pane" id="'.$tabPrefix . '_label_data">';
        $form[] = NgeFields::select($objectPrefix . 'label.data.field','COM_NGECHARTS_DATA','COM_NGE_DESCRIPTION_SHADOW_STYLE','title', $multiple, $multipleIndex,
            array(
                "ajax" => false,
                "options" => array(
	    array('title','COM_NGE_TITLE'),
                    array('subtitle','COM_NGE_SUBTITLE'),
	    array('first.value','COM_NGECHARTS_FIRST_VALUE'),
                    array('first.label','COM_NGECHARTS_FIRST_LABEL'), 
	    array('last.value','COM_NGECHARTS_LAST_VALUE'), 
	    array('last.variation','COM_NGECHARTS_LAST_VARIATION'),
                    array('last.label','COM_NGECHARTS_LAST_LABEL'),	    
	    array('serie.label','COM_NGECHARTS_SERIE_LABEL')		    
                ),
                "target" => null,
                "multiple" => false
            )
        );
	
        $form[] = NgeFields::radio($objectPrefix . 'label.data.format.mode','COM_NGE_FORMAT','COM_NGE_LINK_ON_CLINK','auto', array(	    
            array('auto', 'COM_NGE_AUTO'),
            array('text', 'COM_NGECHARTS_FORMAT_TEXT','data-target="field:width field:height"'),
	array('number', 'COM_NGE_NGECHARTS_FORMATNUMBER','data-target="field:decimals field:decimal_separator field:thousands_separator"'),
	array('date', 'COM_NGE_NGECHARTS_FORMATDATE','data-target="field:width field:height"')
        ));
	$form[] = NgeFields::text($objectPrefix . 'label.data.format.decimais', 'COM_NGE_NUMBERDECIMALS', 'COM_NGE_DESCRIPTION_BADGE', '2', array('attributes' => 'class="span2"'));
	$form[] = NgeFields::text($objectPrefix . 'label.data.format.decimal_separator', 'COM_NGE_SEPARATORDECIMALS', 'COM_NGE_DESCRIPTION_BADGE', ',', array('attributes' => 'class="span2"'));
	$form[] = NgeFields::text($objectPrefix . 'label.data.format.thousands_separator', 'COM_NGE_SEPARATOR_THOUSANDS', 'COM_NGE_DESCRIPTION_BADGE', ' ', array('attributes' => 'class="span2"'));
	
    $form[] = '</div>';
	
	
    $form[] = NgeFields::text($objectPrefix . 'label.format', 'COM_NGE_TEXT', 'COM_NGE_DESCRIPTION_BADGE', 'last : {last.value} ', array('attributes' => 'class="span6"'));

    $form[] = NgeFields::slider($objectPrefix . 'label.padding','COM_NGE_PADDING','COM_NGE_DESCRIPTION_PADDING','8', 'min="0" max="100" step="1"');
        
    $form[] = '		</div>';	
    $form[] = '<div class="tab-pane" id="'.$tabPrefix . '_label_display">';    	
        $form[] = NgeFields::radio($objectPrefix . 'label.shape.style','COM_NGE_SHAPE','COM_NGE_LINK_ON_CLINK','rectangle', array(	    
            array('rectangle', 'COM_NGE_RECTANGLE','data-target="field:[label][size][mode] field:radius_width field:color"'),
            array('callout', 'COM_NGE_CALLOUT','data-target="[label][size][mode] field:radius_width field:color"'),
            array('circle', 'COM_NGE_CIRCLE','data-target="[label][size][mode] field:color"'),
            array('triangle', 'COM_NGE_TRIANGLE','data-target="[label][size][mode] field:color field:direction"')
        ), array('multiple' => $multiple, 'multipleIndex' => $multipleIndex));
   
        $form[] = NgeFields::radio($objectPrefix . 'label.size.mode','COM_NGE_SIZE','COM_NGE_LINK_ON_CLINK','content', array(	    
            array('content', 'COM_NGE_AUTO'),
            array('custom', 'COM_NGE_CUSTOM','data-target="field:width field:height"')
        ));
	
	$form[] = NgeFields::slider($objectPrefix . 'label.width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_BORDER_WIDTH','100', 'min="0" max="1000"step="1"');
	$form[] = NgeFields::slider($objectPrefix . 'label.height','COM_NGE_HEIGHT','COM_NGE_DESCRIPTION_BORDER_WIDTH','75', 'min="0" max="700"step="1"');

    $form[] = NgeFields::radio($objectPrefix . 'label.hposition.mode','COM_NGECHARTS_HPOSITION','COM_NGE_LINK_ON_CLINK','center', array(
	array('outsideleft','COM_NGE_POSITION_OUTSIDELEFT', 'data-target="#'.$tabPrefix . '_label_hposition""'), 
	array('left','COM_NGE_POSITION_LEFT', 'data-target="#'.$tabPrefix . '_label_hposition""'), 
	array('center','COM_NGE_POSITION_CENTER'), 
	array('right','COM_NGE_POSITION_RIGHT', 'data-target="#'.$tabPrefix . '_label_hposition""'), 
	array('outsideright','COM_NGE_POSITION_OUTSIDERIGHT', 'data-target="#'.$tabPrefix . '_label_hposition""'),
	/*array('custom', 'COM_NGE_CUSTOM', 'data-target="field:x field:align"')*/
    ));
    $form[] = '<div id="'.$tabPrefix . '_label_hposition">';
    $form[] = NgeFields::slider($objectPrefix . 'label.hposition.margin','COM_NGE_MARGIN','COM_NGE_DESCRIPTION_OFFSET','0', 'min="0" max="200" step="1"');
    $form[] = '</div>';
    /*$form[] = NgeFields::slider($objectPrefix . 'label.hposition.x','COM_NGE_POSITION','COM_NGE_DESCRIPTION_OFFSET','100', 'min="0" max="1000" step="1"');
    $form[] = NgeFields::radio($objectPrefix . 'label.align', 'COM_NGECHARTS_ANCHOR', 'COM_NGE_DESCRIPTION_TEXT_ALIGN', 'left',  array(
    	array('left', 'COM_NGE_TEXT_ALIGN_LEFT'), 
    	array('center', 'COM_NGE_TEXT_ALIGN_CENTER'), 
    	array('right', 'COM_NGE_TEXT_ALIGN_RIGHT')
    	));    */    

    $form[] = NgeFields::radio($objectPrefix . 'label.vposition.mode','COM_NGECHARTS_VPOSITION','COM_NGE_LINK_ON_CLINK','middle', array(
	array('outsidetop','COM_NGE_POSITION_OUTSIDETOP', 'data-target="#'.$tabPrefix . '_label_vposition"'), 
	array('abovetitle','COM_NGECHARTS_POSITION_ABOVETITLE', 'data-target="#'.$tabPrefix . '_label_vposition"'), 
	array('top','COM_NGE_POSITION_TOP', 'data-target="#'.$tabPrefix . '_label_vposition""'), 
	array('middle','COM_NGE_POSITION_MIDDLE'), 
	array('bottom','COM_NGE_POSITION_BOTTOM', 'data-target="#'.$tabPrefix . '_label_vposition""'), 
	array('outsidebottom','COM_NGE_POSITION_OUTSIDEBOTTOM', 'data-target="#'.$tabPrefix . '_label_vposition""'),
	/*array('custom', 'COM_NGE_CUSTOM', 'data-target="field:y"')*/
    ));
    $form[] = '<div id="'.$tabPrefix . '_label_vposition">';
    $form[] = NgeFields::slider($objectPrefix . 'label.vposition.margin','COM_NGE_MARGIN','COM_NGE_DESCRIPTION_OFFSET','0', 'min="0" max="200" step="1"');	    
    $form[] = '</div>';
    /*$form[] = NgeFields::slider($objectPrefix . 'label.vposition.y','COM_NGE_POSITION','COM_NGE_DESCRIPTION_OFFSET','100', 'min="0" max="1000" step="1"');*/
    
    $form[] = '	</div>';
    $form[] = '<div class="tab-pane" id="'.$tabPrefix . '_label_conditions">';




	$form[] = NgeFields::radio($objectPrefix . 'label.conditions.mode', 'COM_NGE_DISPLAY', 'COM_NGE_DESCRIPTION_FONT_H', 'all',  array(
    	array('all', 'COM_NGE_ALWAYS'), 
    	array('only', 'COM_NGE_ONLY','data-target="field:field field:operator field:value"')
    	));


    

         $form[] = NgeFields::select($objectPrefix . 'label.conditions.field','COM_NGECHARTS_DATA','COM_NGE_DESCRIPTION_SHADOW_STYLE','title', $multiple, $multipleIndex,
            array(
                "ajax" => false,
                "options" => array(
	    array('title','COM_NGE_TITLE'),
                    array('subtitle','COM_NGE_SUBTITLE'),
	    array('first.value','COM_NGECHARTS_FIRST_VALUE'),
                    array('first.label','COM_NGECHARTS_FIRST_LABEL'), 
	    array('last.value','COM_NGECHARTS_LAST_VALUE'), 
	    array('last.variation','COM_NGECHARTS_LAST_VARIATION'),
                    array('last.label','COM_NGECHARTS_LAST_LABEL'),	    
	    array('serie.label','COM_NGECHARTS_SERIE_LABEL')		    
                ),
                "target" => null,
                "multiple" => false
            )
        );





	$form[] = NgeFields::select($objectPrefix.'label.conditions.operator','','','', $multiple, $multipleIndex,
	    array(
		"ajax" => false,
		"options" => array(
		    array('equals', 'COM_NGECHARTS_DATA_EQUALS'),
		    array('different', 'COM_NGECHARTS_DATA_DIFFERENT'),
		    array('more', 'COM_NGECHARTS_DATA_MORE'),
		    array('moreorequals','COM_NGECHARTS_DATA_MOREOREQUALS'),
		    array('less','COM_NGECHARTS_DATA_LESS'),
		    array('lessorequals', 'COM_NGECHARTS_DATA_LESSOREQUALS')
		),
		"target" => null,
		"multiple" => false,
		"width" => '18%',
		"placeholder" => "Un opérateur",
		"class" => "ngefield_select_filter_operators"
	    )
	);
    $form[] = NgeFields::text($objectPrefix . 'label.conditions.value', '', '', '', array('attributes' => 'class="span4"'));	 	 
    $form[] = '</div>';
    $form[] = '<div class="tab-pane" id="'.$tabPrefix . '_label_font">';

    $form[] = NgeFields::font($objectPrefix .'label.font.name', 'COM_NGE_FONT_NAME', 'COM_NGE_DESCRIPTION_FONT_NAME');
    $form[] = NgeFields::color($objectPrefix .'label.font.color', 'COM_NGE_FONT_COLOR', 'COM_NGE_DESCRIPTION_FONT_COLOR', '#333333');
    $form[] = NgeFields::slider($objectPrefix .'label.font.size', 'COM_NGE_FONT_SIZE', 'COM_NGE_DESCRIPTION_FONT_SIZE', '16', 'min="0" max="72"step="1"');
	$form[] = NgeFields::radio($objectPrefix .'label.font.weight', 'COM_NGE_FONT_WEIGHT', 'COM_NGE_DESCRIPTION_FONT_WEIGHT', 'normal', array(
	    array('lighter', 'COM_NGE_FONT_WEIGHT_LIGHTER'),
	    array('normal', 'COM_NGE_FONT_WEIGHT_NORMAL'),
	    array('bold', 'COM_NGE_FONT_WEIGHT_BOLD'),
	    array('bolder', 'COM_NGE_FONT_WEIGHT_BOLDER')
	    ));
	$form[] = NgeFields::radio($objectPrefix .'label.font.italic', 'COM_NGE_FONT_ITALIC', 'COM_NGE_DESCRIPTION_FONT_ITALIC', '0');

    // font case				    
	$form[] = NgeFields::radio($objectPrefix .'label.font.case', 'COM_NGE_FONT_CASE', 'COM_NGE_DESCRIPTION_FONT', 'none', array(
	    array('none', 'COM_NGE_DEFAULT', ''),
	    array('uppercase', 'COM_NGE_FONT_CASE_UPPERCASE'),
	    array('capitalize', 'COM_NGE_FONT_CASE_CAPITALIZE'),	    
	    array('lowercase', 'COM_NGE_FONT_CASE_LOWERCASE')
	    ));
    $form[] = '		</div>
	
        			<div class="tab-pane" id="'.$tabPrefix . '_label_border">';
	$form[] = NgeFields::radio($objectPrefix . 'label.border.display', 'COM_NGE_DISPLAY', '', '1',array(
    	array('1', 'JYES','data-target="field:width field:color field:radius_width"'),
    	array('0', 'JNO','data-success="false"')
    	));
    
        $form[] = NgeFields::slider($objectPrefix . 'label.border.width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_BORDER_WIDTH','1', 'min="1" max="50"step="1"');
    $form[] = NgeFields::color($objectPrefix . 'label.border.color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_BORDER_COLOR','#cccccc');
    $form[] = NgeFields::slider($objectPrefix . 'label.border.radius_width','COM_NGE_RADIUS','COM_NGE_DESCRIPTION_RADIUS','0', 'min="0" max="100"step="1"');

    $form[] = '		</div>
        			<div class="tab-pane" id="'.$tabPrefix . '_label_background">';
    // background style
    	$form[] = NgeFields::radio($objectPrefix . 'label.background.display', 'COM_NGE_DISPLAY', '', '1',array(
    	array('1', 'JYES','data-target="field:color field:opacity"'),
    	array('0', 'JNO','data-success="false"')
    	));

    $form[] = NgeFields::color($objectPrefix . 'label.background.color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_COLOR','#FFFFFF');
    $form[] = NgeFields::slider($objectPrefix . 'label.background.opacity','COM_NGE_OPACITY','COM_NGE_DESCRIPTION_BACKGROUND_OPACITY','100', 'min="0" max="100"step="1"');

    $form[] = '		</div>
    		      </div>
		      </div>
    		</div>';	
    
    //Image
    $form[] = '<div id="'.$tabPrefix . '_image">';





    $form[] = '    	<div class="tabbable tabs-left">
		  <ul class="nav nav-tabs" data-tabs="tabs">
			 <li class="active"><a href="#'.$tabPrefix . '_image_display" data-toggle="tab">'.NGE::translate('COM_NGE_DISPLAY').'</a></li>
			<li><a href="#'.$tabPrefix . '_image_conditions" data-toggle="tab">'.NGE::translate('COM_NGE_CONDITIONS').'</a></li>
		  </ul>
		  <div class="tab-content">';
    $form[] = '	<div class="tab-pane active" id="'.$tabPrefix . '_image_display">';
    //$form[] = NgeFields::filemanager($objectPrefix.'image.path','COM_NGE_CONTENT_IMAGE','COM_NGE_DESCRIPTION_CONTENT_PICTURE', '', 'images');
    $form[] = NgeFields::text($objectPrefix . 'image.path','Url','Url externe de votre image','',array(
        "place_holder" => "https://chemin_de_votre_image.jpg",
        'attributes' => 'class="span6"'
    ));
	$form[] = NgeFields::radio($objectPrefix . 'image.hposition.mode','COM_NGECHARTS_HPOSITION','COM_NGE_LINK_ON_CLINK','center', array(
        array('outsideleft','COM_NGE_POSITION_OUTSIDELEFT', 'data-target="#'.$tabPrefix . '_image_hposition""'), 
        array('left','COM_NGE_POSITION_LEFT', 'data-target="#'.$tabPrefix . '_image_hposition""'), 
        array('center','COM_NGE_POSITION_CENTER'), 
        array('right','COM_NGE_POSITION_RIGHT', 'data-target="#'.$tabPrefix . '_image_hposition""'), 
        array('outsideright','COM_NGE_POSITION_OUTSIDERIGHT', 'data-target="#'.$tabPrefix . '_image_hposition""')
    ));
    $form[] = '<div id="'.$tabPrefix . '_image_hposition">';
    $form[] = NgeFields::slider($objectPrefix . 'image.hposition.margin','COM_NGE_MARGIN','COM_NGE_DESCRIPTION_OFFSET','0', 'min="0" max="200" step="1"');
    $form[] = '</div>';

    $form[] = NgeFields::radio($objectPrefix . 'image.vposition.mode','COM_NGECHARTS_VPOSITION','COM_NGE_LINK_ON_CLINK','middle', array(
        array('outsidetop','COM_NGE_POSITION_OUTSIDETOP', 'data-target="#'.$tabPrefix . '_image_vposition"'), 
        array('abovetitle','COM_NGECHARTS_POSITION_ABOVETITLE', 'data-target="#'.$tabPrefix . '_image_vposition"'), 
        array('top','COM_NGE_POSITION_TOP', 'data-target="#'.$tabPrefix . '_image_vposition""'), 
        array('middle','COM_NGE_POSITION_MIDDLE'), 
        array('bottom','COM_NGE_POSITION_BOTTOM', 'data-target="#'.$tabPrefix . '_image_vposition""'), 
        array('outsidebottom','COM_NGE_POSITION_OUTSIDEBOTTOM', 'data-target="#'.$tabPrefix . '_image_vposition""')
    ));
    $form[] = '<div id="'.$tabPrefix . '_image_vposition">';
    $form[] = NgeFields::slider($objectPrefix . 'image.vposition.margin','COM_NGE_MARGIN','COM_NGE_DESCRIPTION_OFFSET','0', 'min="0" max="200" step="1"');	    
    $form[] = '</div>';
    $form[] = NgeFields::slider($objectPrefix . 'image.width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_BORDER_WIDTH','200', 'min="0" max="1000"step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'image.height','COM_NGE_HEIGHT','COM_NGE_DESCRIPTION_BORDER_WIDTH','130', 'min="0" max="700"step="1"');
    
    $form[] = '</div>';
    $form[] = '	<div class="tab-pane" id="'.$tabPrefix . '_image_conditions">';
	$form[] = NgeFields::radio($objectPrefix . 'image.conditions.mode', 'COM_NGE_DISPLAY', 'COM_NGE_DESCRIPTION_FONT_H', 'all',  array(
    	array('all', 'COM_NGE_ALWAYS'), 
    	array('only', 'COM_NGE_ONLY','data-target="field:field field:operator field:value"')
    	));    
         $form[] = NgeFields::select($objectPrefix . 'image.conditions.field','COM_NGECHARTS_DATA','COM_NGE_DESCRIPTION_SHADOW_STYLE','title', $multiple, $multipleIndex,
            array(
                "ajax" => false,
                "options" => array(
	    array('title','COM_NGE_TITLE'),
                    array('subtitle','COM_NGE_SUBTITLE'),
	    array('first.value','COM_NGECHARTS_FIRST_VALUE'),
                    array('first.label','COM_NGECHARTS_FIRST_LABEL'), 
	    array('last.value','COM_NGECHARTS_LAST_VALUE'), 
	    array('last.variation','COM_NGECHARTS_LAST_VARIATION'),
                    array('last.label','COM_NGECHARTS_LAST_LABEL'),	    
	    array('serie.label','COM_NGECHARTS_SERIE_LABEL')		    
                ),
                "target" => null,
                "multiple" => false
            )
        );
	$form[] = NgeFields::select($objectPrefix.'image.conditions.operator','','','', $multiple, $multipleIndex,
	    array(
		"ajax" => false,
		"options" => array(
		    array('equals', 'COM_NGECHARTS_DATA_EQUALS'),
		    array('different', 'COM_NGECHARTS_DATA_DIFFERENT'),
		    array('more', 'COM_NGECHARTS_DATA_MORE'),
		    array('moreorequals','COM_NGECHARTS_DATA_MOREOREQUALS'),
		    array('less','COM_NGECHARTS_DATA_LESS'),
		    array('lessorequals', 'COM_NGECHARTS_DATA_LESSOREQUALS')
		),
		"target" => null,
		"multiple" => false,
		"width" => '18%',
		"placeholder" => "Un opérateur",
		"class" => "ngefield_select_filter_operators"
	    )
	);
    $form[] = NgeFields::text($objectPrefix . 'image.conditions.value', '', '', '', array('attributes' => 'class="span4"'));	 	     
    $form[] = '</div>';
    $form[] = '</div>';
    $form[] = '</div>';    
    $form[] = '</div>';	
    
    //Shape
    $form[] = '<div id="'.$tabPrefix . '_shape">';
        $form[] = NgeFields::radio($objectPrefix . 'shape.style','COM_NGE_SHAPE','COM_NGE_LINK_ON_CLINK','square', array(
        array('square', 'COM_NGE_SQUARE','data-target="field:width field:radius_width field:color"'),
        array('rectangle', 'COM_NGE_RECTANGLE','data-target="field:width field:height field:radius_width field:color"'),
        array('circle', 'COM_NGE_CIRCLE','data-target="field:width field:color"'),
        array('ellipse', 'COM_NGE_ELLIPSE','data-target="field:width field:height field:color"'),
        array('triangle', 'COM_NGE_TRIANGLE','data-target="field:width field:height field:color field:direction"'),
	array('line', 'COM_NGE_LINE','data-target="field:x field:y field:x2 field:y2 field:color"')
    ), array('multiple' => $multiple, 'multipleIndex' => $multipleIndex));

        $form[] = '    	<div class="tabbable tabs-left">
    		      <ul class="nav nav-tabs" data-tabs="tabs">
    			     <li class="active"><a href="#'.$tabPrefix . '_shape_display" data-toggle="tab">'.NGE::translate('COM_NGE_DISPLAY').'</a></li>
			    <li><a href="#'.$tabPrefix . '_shape_conditions" data-toggle="tab">'.NGE::translate('COM_NGE_CONDITIONS').'</a></li>
    			     <li><a href="#'.$tabPrefix . '_shape_border" data-toggle="tab">'.NGE::translate('COM_NGE_BORDER').'</a></li>
    			     <li><a href="#'.$tabPrefix . '_shape_background" data-toggle="tab">'.NGE::translate('COM_NGE_BACKGROUND').'</a></li>
    		      </ul>
    		      <div class="tab-content">';
	$form[] = '	<div class="tab-pane active" id="'.$tabPrefix . '_shape_display">';
        $form[] = NgeFields::radio($objectPrefix . 'shape.hposition.mode','COM_NGECHARTS_HPOSITION','COM_NGE_LINK_ON_CLINK','center', array(
            array('outsideleft','COM_NGE_POSITION_OUTSIDELEFT', 'data-target="#'.$tabPrefix . '_shape_hposition""'), 
            array('left','COM_NGE_POSITION_LEFT', 'data-target="#'.$tabPrefix . '_shape_hposition""'), 
            array('center','COM_NGE_POSITION_CENTER'), 
            array('right','COM_NGE_POSITION_RIGHT', 'data-target="#'.$tabPrefix . '_shape_hposition""'), 
            array('outsideright','COM_NGE_POSITION_OUTSIDERIGHT', 'data-target="#'.$tabPrefix . '_shape_hposition""')
        ));
        $form[] = '<div id="'.$tabPrefix . '_shape_hposition">';
        $form[] = NgeFields::slider($objectPrefix . 'shape.hposition.margin','COM_NGE_MARGIN','COM_NGE_DESCRIPTION_OFFSET','0', 'min="0" max="200" step="1"');
        $form[] = '</div>';

        $form[] = NgeFields::radio($objectPrefix . 'shape.vposition.mode','COM_NGECHARTS_VPOSITION','COM_NGE_LINK_ON_CLINK','middle', array(
            array('outsidetop','COM_NGE_POSITION_OUTSIDETOP', 'data-target="#'.$tabPrefix . '_shape_vposition"'), 
            array('abovetitle','COM_NGECHARTS_POSITION_ABOVETITLE', 'data-target="#'.$tabPrefix . '_shape_vposition"'), 
            array('top','COM_NGE_POSITION_TOP', 'data-target="#'.$tabPrefix . '_shape_vposition""'), 
            array('middle','COM_NGE_POSITION_MIDDLE'), 
            array('bottom','COM_NGE_POSITION_BOTTOM', 'data-target="#'.$tabPrefix . '_shape_vposition""'), 
            array('outsidebottom','COM_NGE_POSITION_OUTSIDEBOTTOM', 'data-target="#'.$tabPrefix . '_shape_vposition""')
        ));
        $form[] = '<div id="'.$tabPrefix . '_shape_vposition">';
        $form[] = NgeFields::slider($objectPrefix . 'shape.vposition.margin','COM_NGE_MARGIN','COM_NGE_DESCRIPTION_OFFSET','0', 'min="0" max="200" step="1"');	    
        $form[] = '</div>';
        
	$form[] = NgeFields::radio($objectPrefix . 'shape.triangle.direction','COM_NGE_BACKGROUND_GRADIENT_DIRECTION','COM_NGE_LINK_ON_CLINK','right', array(
		array('left', 'COM_NGE_EFFECTS_DIRECTION_LEFT'),
		array('up', 'COM_NGE_EFFECTS_DIRECTION_UP'),
		array('down', 'COM_NGE_EFFECTS_DIRECTION_DOWN'),
		array('right', 'COM_NGE_EFFECTS_DIRECTION_RIGHT')
	    ));	
	    $form[] = NgeFields::slider($objectPrefix . 'shape.x','COM_NGECHARTS_POSITIONX','COM_NGE_DESCRIPTION_OFFSET','50', 'min="0" max="1000" step="1"');
	    $form[] = NgeFields::slider($objectPrefix . 'shape.y','COM_NGECHARTS_POSITIONY','COM_NGE_DESCRIPTION_OFFSET','50', 'min="0" max="1000" step="1"');
	    $form[] = NgeFields::slider($objectPrefix . 'shape.x2','COM_NGECHARTS_POSITIONX2','COM_NGE_DESCRIPTION_OFFSET','300', 'min="0" max="1000" step="1"');
	    $form[] = NgeFields::slider($objectPrefix . 'shape.y2','COM_NGECHARTS_POSITIONY2','COM_NGE_DESCRIPTION_OFFSET','100', 'min="0" max="1000" step="1"');
	    $form[] = NgeFields::slider($objectPrefix . 'shape.width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_BORDER_WIDTH','50', 'min="0" max="500"step="1"');
	    $form[] = NgeFields::slider($objectPrefix . 'shape.height','COM_NGE_HEIGHT','COM_NGE_DESCRIPTION_BORDER_WIDTH','40', 'min="0" max="500"step="1"');
	    $form[] = NgeFields::slider($objectPrefix . 'shape.radius_width','COM_NGE_RADIUS','COM_NGE_DESCRIPTION_RADIUS','0', 'min="0" max="100"step="1"');
	
	$form[] = '	</div>';
	$form[] = '<div class="tab-pane" id="'.$tabPrefix . '_shape_conditions">';
	$form[] = NgeFields::radio($objectPrefix . 'shape.conditions.mode', 'COM_NGE_DISPLAY', 'COM_NGE_DESCRIPTION_FONT_H', 'all',  array(
    	array('all', 'COM_NGE_ALWAYS'), 
    	array('only', 'COM_NGE_ONLY','data-target="field:field field:operator field:value"')
    	));    
         $form[] = NgeFields::select($objectPrefix . 'shape.conditions.field','COM_NGECHARTS_DATA','COM_NGE_DESCRIPTION_SHADOW_STYLE','title', $multiple, $multipleIndex,
            array(
                "ajax" => false,
                "options" => array(
	    array('title','COM_NGE_TITLE'),
                    array('subtitle','COM_NGE_SUBTITLE'),
	    array('first.value','COM_NGECHARTS_FIRST_VALUE'),
                    array('first.label','COM_NGECHARTS_FIRST_LABEL'), 
	    array('last.value','COM_NGECHARTS_LAST_VALUE'), 
	    array('last.variation','COM_NGECHARTS_LAST_VARIATION'),
                    array('last.label','COM_NGECHARTS_LAST_LABEL'),	    
	    array('serie.label','COM_NGECHARTS_SERIE_LABEL')		    
                ),
                "target" => null,
                "multiple" => false
            )
        );
	$form[] = NgeFields::select($objectPrefix.'shape.conditions.operator','','','', $multiple, $multipleIndex,
	    array(
		"ajax" => false,
		"options" => array(
		    array('equals', 'COM_NGECHARTS_DATA_EQUALS'),
		    array('different', 'COM_NGECHARTS_DATA_DIFFERENT'),
		    array('more', 'COM_NGECHARTS_DATA_MORE'),
		    array('moreorequals','COM_NGECHARTS_DATA_MOREOREQUALS'),
		    array('less','COM_NGECHARTS_DATA_LESS'),
		    array('lessorequals', 'COM_NGECHARTS_DATA_LESSOREQUALS')
		),
		"target" => null,
		"multiple" => false,
		"width" => '18%',
		"placeholder" => "Un opérateur",
		"class" => "ngefield_select_filter_operators"
	    )
	);
    $form[] = NgeFields::text($objectPrefix . 'shape.conditions.value', '', '', '', array('attributes' => 'class="span4"'));	 	 
    $form[] = '</div>';		
	$form[] = '	<div class="tab-pane" id="'.$tabPrefix . '_shape_border">';
	$form[] = NgeFields::radio($objectPrefix . 'shape.border.display', 'COM_NGE_DISPLAY', '', '1',array(
    	array('1', 'JYES','data-target="field:width field:color"'),
    	array('0', 'JNO','data-success="false"')
    	));
	$form[] = NgeFields::select($objectPrefix .'shape.border.style', 'COM_NGE_STYLE', 'COM_NGE_DESCRIPTION_TYPE', 'solid', $multiple, $multipleIndex, 
		array(
                "options" => array(
	    array('solid', 'COM_NGECHARTS_LINE_SOLID'),
	    array('shortdot', 'COM_NGECHARTS_LINE_SHORTDOT'),
	    array('dot', 'COM_NGECHARTS_LINE_DOT'),
	    array('shortdash', 'COM_NGECHARTS_LINE_SHORTDASH'),
	    array('dash', 'COM_NGECHARTS_LINE_DASH'),
	    array('longdash', 'COM_NGECHARTS_LINE_LONGDASH')
	    )
		    )
		);
	
	
	$form[] = NgeFields::slider($objectPrefix . 'shape.border.width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_BORDER_WIDTH','1', 'min="1" max="50"step="1"');
	$form[] = NgeFields::color($objectPrefix . 'shape.border.color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_COLOR','#CCCCCC');	
	$form[] = '	</div>';
	$form[] = '	<div class="tab-pane" id="'.$tabPrefix . '_shape_background">';
	$form[] = NgeFields::radio($objectPrefix . 'shape.background.display', 'COM_NGE_DISPLAY', '', '1',array(
    	array('1', 'JYES','data-target="field:color"'),
    	array('0', 'JNO','data-success="false"')
    	));
	$form[] = NgeFields::color($objectPrefix . 'shape.background.color','COM_NGE_BACKGROUND','COM_NGE_DESCRIPTION_COLOR','#F9F9F9');    	
	$form[] = '	</div>';
	$form[] = '	      </div>
		      </div>';

    $form[] = '</div>';	
    $form[] = '<div id="'.$tabPrefix . '_path">';	
        $form[] = '    	<div class="tabbable tabs-left">
    		      <ul class="nav nav-tabs" data-tabs="tabs">
    			     <li class="active"><a href="#'.$tabPrefix . '_path_data" data-toggle="tab">'.NGE::translate('COM_NGECHARTS_SVGPATH').'</a></li>
			    <li><a href="#'.$tabPrefix . '_path_conditions" data-toggle="tab">'.NGE::translate('COM_NGE_CONDITIONS').'</a></li>				 
    			     <li><a href="#'.$tabPrefix . '_path_border" data-toggle="tab">'.NGE::translate('COM_NGE_BORDER').'</a></li>
    			     <li><a href="#'.$tabPrefix . '_path_background" data-toggle="tab">'.NGE::translate('COM_NGE_BACKGROUND').'</a></li>
    		      </ul>
    		      <div class="tab-content">';
	$form[] = '	<div class="tab-pane active" id="'.$tabPrefix . '_path_data">';
	    $form[] = NgeFields::textarea($objectPrefix.'path.data','COM_NGE_DISPLAY','COM_NGE_DESCRIPTION_CONTENT_PICTURE', '', '');	
        $form[] = NgeFields::radio($objectPrefix . 'path.hposition.mode','COM_NGECHARTS_HPOSITION','COM_NGE_LINK_ON_CLINK','center', array(
            array('outsideleft','COM_NGE_POSITION_OUTSIDELEFT', 'data-target="#'.$tabPrefix . '_path_hposition""'), 
            array('left','COM_NGE_POSITION_LEFT', 'data-target="#'.$tabPrefix . '_path_hposition""'), 
            array('center','COM_NGE_POSITION_CENTER'), 
            array('right','COM_NGE_POSITION_RIGHT', 'data-target="#'.$tabPrefix . '_path_hposition""'), 
            array('outsideright','COM_NGE_POSITION_OUTSIDERIGHT', 'data-target="#'.$tabPrefix . '_path_hposition""')
        ));
        $form[] = '<div id="'.$tabPrefix . '_path_hposition">';
        $form[] = NgeFields::slider($objectPrefix . 'path.hposition.margin','COM_NGE_MARGIN','COM_NGE_DESCRIPTION_OFFSET','0', 'min="0" max="200" step="1"');
        $form[] = '</div>';

        $form[] = NgeFields::radio($objectPrefix . 'path.vposition.mode','COM_NGECHARTS_VPOSITION','COM_NGE_LINK_ON_CLINK','middle', array(
            array('outsidetop','COM_NGE_POSITION_OUTSIDETOP', 'data-target="#'.$tabPrefix . '_path_vposition"'), 
            array('abovetitle','COM_NGECHARTS_POSITION_ABOVETITLE', 'data-target="#'.$tabPrefix . '_path_vposition"'), 
            array('top','COM_NGE_POSITION_TOP', 'data-target="#'.$tabPrefix . '_path_vposition""'), 
            array('middle','COM_NGE_POSITION_MIDDLE'), 
            array('bottom','COM_NGE_POSITION_BOTTOM', 'data-target="#'.$tabPrefix . '_path_vposition""'), 
            array('outsidebottom','COM_NGE_POSITION_OUTSIDEBOTTOM', 'data-target="#'.$tabPrefix . '_path_vposition""')
        ));
        $form[] = '<div id="'.$tabPrefix . '_path_vposition">';
        $form[] = NgeFields::slider($objectPrefix . 'path.vposition.margin','COM_NGE_MARGIN','COM_NGE_DESCRIPTION_OFFSET','0', 'min="0" max="200" step="1"');	    
        $form[] = '</div>';
	$form[] = '	</div>';
	$form[] = '<div class="tab-pane" id="'.$tabPrefix . '_path_conditions">';
	$form[] = NgeFields::radio($objectPrefix . 'path.conditions.mode', 'COM_NGE_DISPLAY', 'COM_NGE_DESCRIPTION_FONT_H', 'all',  array(
    	array('all', 'COM_NGE_ALWAYS'), 
    	array('only', 'COM_NGE_ONLY','data-target="field:field field:operator field:value"')
    	));
    
         $form[] = NgeFields::select($objectPrefix . 'path.conditions.field','COM_NGECHARTS_DATA','COM_NGE_DESCRIPTION_SHADOW_STYLE','title', $multiple, $multipleIndex,
            array(
                "ajax" => false,
                "options" => array(
	    array('title','COM_NGE_TITLE'),
                    array('subtitle','COM_NGE_SUBTITLE'),
	    array('first.value','COM_NGECHARTS_FIRST_VALUE'),
                    array('first.label','COM_NGECHARTS_FIRST_LABEL'), 
	    array('last.value','COM_NGECHARTS_LAST_VALUE'), 
	    array('last.variation','COM_NGECHARTS_LAST_VARIATION'),
                    array('last.label','COM_NGECHARTS_LAST_LABEL'),	    
	    array('serie.label','COM_NGECHARTS_SERIE_LABEL')		    
                ),
                "target" => null,
                "multiple" => false
            )
        );
	$form[] = NgeFields::select($objectPrefix.'path.conditions.operator','','','', $multiple, $multipleIndex,
	    array(
		"ajax" => false,
		"options" => array(
		    array('equals', 'COM_NGECHARTS_DATA_EQUALS'),
		    array('different', 'COM_NGECHARTS_DATA_DIFFERENT'),
		    array('more', 'COM_NGECHARTS_DATA_MORE'),
		    array('moreorequals','COM_NGECHARTS_DATA_MOREOREQUALS'),
		    array('less','COM_NGECHARTS_DATA_LESS'),
		    array('lessorequals', 'COM_NGECHARTS_DATA_LESSOREQUALS')
		),
		"target" => null,
		"multiple" => false,
		"width" => '18%',
		"placeholder" => "Un opérateur",
		"class" => "ngefield_select_filter_operators"
	    )
	);
    $form[] = NgeFields::text($objectPrefix . 'path.conditions.value', '', '', '', array('attributes' => 'class="span4"'));	 	 
    $form[] = '</div>';	
	$form[] = '	<div class="tab-pane" id="'.$tabPrefix . '_path_border">';
	$form[] = NgeFields::radio($objectPrefix . 'path.border.display', 'COM_NGE_DISPLAY', '', '1',array(
    	array('1', 'JYES','data-target="field:width field:color"'),
    	array('0', 'JNO','data-success="false"')
    	));
	$form[] = NgeFields::select($objectPrefix .'path.border.style', 'COM_NGE_STYLE', 'COM_NGE_DESCRIPTION_TYPE', 'solid', $multiple, $multipleIndex, 
		array(
                "options" => array(
	    array('solid', 'COM_NGECHARTS_LINE_SOLID'),
	    array('shortdot', 'COM_NGECHARTS_LINE_SHORTDOT'),
	    array('dot', 'COM_NGECHARTS_LINE_DOT'),
	    array('shortdash', 'COM_NGECHARTS_LINE_SHORTDASH'),
	    array('dash', 'COM_NGECHARTS_LINE_DASH'),
	    array('longdash', 'COM_NGECHARTS_LINE_LONGDASH')
	    )
		    )
		);
	
	
	$form[] = NgeFields::slider($objectPrefix . 'path.border.width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_BORDER_WIDTH','1', 'min="1" max="50"step="1"');
	$form[] = NgeFields::color($objectPrefix . 'path.border.color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_COLOR','#CCCCCC');	
	$form[] = '	</div>';
	$form[] = '	<div class="tab-pane" id="'.$tabPrefix . '_path_background">';
	$form[] = NgeFields::radio($objectPrefix . 'path.background.display', 'COM_NGE_DISPLAY', '', '1',array(
    	array('1', 'JYES','data-target="field:color"'),
    	array('0', 'JNO','data-success="false"')
    	));
	$form[] = NgeFields::color($objectPrefix . 'path.background.color','COM_NGE_BACKGROUND','COM_NGE_DESCRIPTION_COLOR','#F9F9F9');    	
	$form[] = '	</div>';
	$form[] = '	      </div>
		      </div>';
    $form[] = '</div>';	
            
    
    return implode($form);
}
