<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */

defined('_JEXEC') or die;


function xAxisDisplay($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::radio($objectPrefix . 'position', 'COM_NGE_POSITION', 'COM_NGE_POSITION_DESC', 'bottom',  array(
    	array('top', 'COM_NGE_POSITION_TOP'), 
	array('bottom', 'COM_NGE_POSITION_BOTTOM'),
	array('both', 'COM_NGECHARTS_POSITION_BOTH')
    	)); 
    $form[] = NgeFields::slider($objectPrefix . 'offset','COM_NGECHARTS_OFFSET','COM_NGE_DESCRIPTION_OFFSET','0', 'min="-1000" max="1000"step="1"');
    
    return implode($form);
    
}

function yAxisDisplay($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::radio($objectPrefix . 'position', 'COM_NGE_POSITION', 'COM_NGE_POSITION_DESC', 'left',  array(
    	array('left', 'COM_NGE_TEXT_ALIGN_LEFT'), 
	array('right', 'COM_NGE_TEXT_ALIGN_RIGHT'),
	array('both', 'COM_NGECHARTS_POSITION_BOTH')
    	)); 
    $form[] = NgeFields::slider($objectPrefix . 'offset','COM_NGECHARTS_OFFSET','COM_NGE_DESCRIPTION_OFFSET','0', 'min="-1000" max="1000"step="1"');
    return implode($form);
    
}


function xAxisTitle($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

        // horizontal align
    $form[] = NgeFields::radio($objectPrefix . 'align', 'COM_NGE_TEXT_ALIGN', 'COM_NGE_DESCRIPTION_TEXT_ALIGN', 'middle',  array(
	array('high', 'COM_NGE_POSITION_TOP'),    	
    	array('middle', 'COM_NGE_POSITION_MIDDLE'),
	array('low', 'COM_NGE_POSITION_BOTTOM')
    	));
       
    $form[] = NgeFields::slider($objectPrefix . 'margin','COM_NGE_MARGIN','COM_NGE_DESCRIPTION_MARGIN','0', 'min="0" max="100" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'offset','COM_NGECHARTS_OFFSET','COM_NGE_DESCRIPTION_OFFSET','0', 'min="0" max="100" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'x','COM_NGECHARTS_OFFSETX','COM_NGE_DESCRIPTION_OFFSET','0', 'min="-200" max="200" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'y','COM_NGECHARTS_OFFSETY','COM_NGE_DESCRIPTION_OFFSET','0', 'min="-200" max="200" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'rotation','COM_NGECHARTS_ROTATION','COM_NGE_DESCRIPTION_OFFSET','0', 'min="0" max="360" step="1"');

	return implode($form);
    
}

function xAxisData($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::radio($objectPrefix . 'direction', 'COM_NGECHARTS_DIRECTION', 'COM_NGE_DESCRIPTION_FONT_H', 'asc',  array(
    	array('asc', 'COM_NGECHARTS_DIRECTION_ASCENDING'), 
	array('desc', 'COM_NGECHARTS_DIRECTION_DESCENDING')
    	));    
    
    $form[] = NgeFields::radio($objectPrefix . 'type', 'COM_NGECHARTS_TYPE', 'COM_NGE_DESCRIPTION_FONT_H', 'category',  array(
	array('linear', 'COM_NGECHARTS_TYPE_NUMBERS','data-target="#chart_xaxis_type_date"'), 
	array('logarithmic', 'COM_NGECHARTS_TYPE_LOGARITHMIC','data-target="#chart_xaxis_type_date"'), 
    	array('datetime', 'COM_NGECHARTS_TYPE_DATES','data-target="#chart_xaxis_type_date"'), 
	array('category', 'COM_NGE_CUSTOM')
    	));    
    
    $form[] = NgeFields::radio($objectPrefix . 'min.mode', 'COM_NGE_MINIMUM', 'COM_NGE_DESCRIPTION_FONT_H', 'default',  array(
    	array('default', 'COM_NGE_DEFAULT'), 
	array('floor', 'COM_NGE_FLOOR','data-target="#chart_xaxis_min_value"'), 
	array('soft', 'COM_NGE_SOFT','data-target="#chart_xaxis_min_value"'), 	
    	array('custom', 'COM_NGE_CUSTOM','data-target="#chart_xaxis_min_value"')
    	));
    $form[] = '<div id="chart_xaxis_min_value">';
    $form[] = NgeFields::text($objectPrefix . 'min.value', 'COM_NGE_VALUE', 'COM_NGE_DESCRIPTION_FONT_H', '0');
    $form[] = '</div>';
    $form[] = NgeFields::radio($objectPrefix . 'max.mode', 'COM_NGE_MAXIMUM', 'COM_NGE_DESCRIPTION_FONT_H', 'default',  array(
    	array('default', 'COM_NGE_DEFAULT'), 
	array('ceiling', 'COM_NGE_CEILING','data-target="#chart_xaxis_max_value"'), 
	array('soft', 'COM_NGE_SOFT','data-target="#chart_xaxis_max_value"'), 	
    	array('custom', 'COM_NGE_CUSTOM','data-target="#chart_xaxis_max_value"')
    	));
    $form[] = '<div id="chart_xaxis_max_value">';
    $form[] = NgeFields::text($objectPrefix . 'max.value', 'COM_NGE_VALUE', 'COM_NGE_DESCRIPTION_FONT_H', '100');
    $form[] = '</div>';    
    
    $form[] = NgeFields::radio($objectPrefix . 'interval.mode', 'COM_NGECHARTS_INTERVAL', 'COM_NGE_DESCRIPTION_FONT_H', 'default',  array(
    	array('default', 'COM_NGE_DEFAULT'), 
	array('amount', 'COM_NGECHARTS_INTERVAL_AMOUNT','data-target="#chart_xaxis_interval_amount"'),
	array('value', 'COM_NGECHARTS_INTERVAL_VALUE','data-target="#chart_xaxis_interval_value"'),
	array('length', 'COM_NGECHARTS_INTERVAL_LENGTH','data-target="#chart_xaxis_interval_length"')
    	));
    $form[] = '<div id="chart_xaxis_interval_amount">';
    $form[] = NgeFields::slider($objectPrefix . 'interval.amount','COM_NGECHARTS_INTERVAL_AMOUNT','COM_NGE_DESCRIPTION_MARGIN','8', 'min="1" max="20" step="1"');
    $form[] = '</div>';    
    $form[] = '<div id="chart_xaxis_interval_value">';
    $form[] = NgeFields::text($objectPrefix . 'interval.value', 'COM_NGECHARTS_INTERVAL_VALUE', 'COM_NGE_DESCRIPTION_FONT_H', '10');
    $form[] = '</div>';    
    $form[] = '<div id="chart_xaxis_interval_length">';
    $form[] = NgeFields::slider($objectPrefix . 'interval.length','COM_NGECHARTS_INTERVAL_LENGTH','COM_NGE_DESCRIPTION_MARGIN','20', 'min="1" max="100" step="1"');
    $form[] = '</div>';    
    
	return implode($form);
    
}

function yAxisData($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::radio($objectPrefix . 'direction', 'COM_NGECHARTS_DIRECTION', 'COM_NGE_DESCRIPTION_FONT_H', 'asc',  array(
    	array('asc', 'COM_NGECHARTS_DIRECTION_ASCENDING'), 
	array('desc', 'COM_NGECHARTS_DIRECTION_DESCENDING')
    	));    
    $form[] = NgeFields::radio($objectPrefix . 'allowdecimals', 'COM_NGECHARTS_DECIMALS', 'COM_NGE_DESCRIPTION_FONT_H', '1',  array(
    	array('1', 'JYES'), 
	array('0', 'COM_NGE_ROUNDED')
    	));    
    $form[] = NgeFields::radio($objectPrefix . 'min.mode', 'COM_NGECHARTS_MINIMUM', 'COM_NGE_DESCRIPTION_FONT_H', 'default',  array(
    	array('default', 'COM_NGE_DEFAULT'), 
	array('floor', 'COM_NGE_FLOOR','data-target="#chart_yaxis_min_value"'), 
	array('soft', 'COM_NGE_SOFT','data-target="#chart_yaxis_min_value"'), 	
    	array('custom', 'COM_NGE_CUSTOM','data-target="#chart_yaxis_min_value"')
    	));
    $form[] = '<div id="chart_yaxis_min_value">';
    $form[] = NgeFields::text($objectPrefix . 'min.value', 'COM_NGE_VALUE', 'COM_NGE_DESCRIPTION_FONT_H', '0');
    $form[] = '</div>';
    $form[] = NgeFields::radio($objectPrefix . 'max.mode', 'COM_NGECHARTS_MAXIMUM', 'COM_NGE_DESCRIPTION_FONT_H', 'default',  array(
    	array('default', 'COM_NGE_DEFAULT'), 
	array('ceiling', 'COM_NGE_CEILING','data-target="#chart_yaxis_max_value"'), 
	array('soft', 'COM_NGE_SOFT','data-target="#chart_yaxis_max_value"'), 	
    	array('custom', 'COM_NGE_CUSTOM','data-target="#chart_yaxis_max_value"')
    	));
    $form[] = '<div id="chart_yaxis_max_value">';
    $form[] = NgeFields::text($objectPrefix . 'max.value', 'COM_NGE_VALUE', 'COM_NGE_DESCRIPTION_FONT_H', '100');
    $form[] = '</div>';    
    
    $form[] = NgeFields::radio($objectPrefix . 'interval.mode', 'COM_NGECHARTS_INTERVAL', 'COM_NGE_DESCRIPTION_FONT_H', 'default',  array(
    	array('default', 'COM_NGE_DEFAULT'), 
	array('amount', 'COM_NGECHARTS_INTERVAL_AMOUNT','data-target="#chart_yaxis_interval_amount"'),
	array('value', 'COM_NGECHARTS_INTERVAL_VALUE','data-target="#chart_yaxis_interval_value"'),
	array('length', 'COM_NGECHARTS_INTERVAL_LENGTH','data-target="#chart_yaxis_interval_length"')
    	));
    $form[] = '<div id="chart_yaxis_interval_amount">';
    $form[] = NgeFields::slider($objectPrefix . 'interval.amount','COM_NGECHARTS_INTERVAL_AMOUNT','COM_NGE_DESCRIPTION_MARGIN','8', 'min="1" max="20" step="1"');
    $form[] = '</div>';    
    $form[] = '<div id="chart_yaxis_interval_value">';
    $form[] = NgeFields::text($objectPrefix . 'interval.value', 'COM_NGECHARTS_INTERVAL_VALUE', 'COM_NGE_DESCRIPTION_FONT_H', '10');
    $form[] = '</div>';    
    $form[] = '<div id="chart_yaxis_interval_length">';
    $form[] = NgeFields::slider($objectPrefix . 'interval.length','COM_NGECHARTS_INTERVAL_LENGTH','COM_NGE_DESCRIPTION_MARGIN','20', 'min="1" max="100" step="1"');
    $form[] = '</div>';    
	return implode($form);    
}


function yAxisTitle($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

        // horizontal align
    $form[] = NgeFields::radio($objectPrefix . 'align', 'COM_NGE_TEXT_ALIGN', 'COM_NGE_DESCRIPTION_TEXT_ALIGN', 'middle',  array(
	array('high', 'COM_NGE_POSITION_TOP'),    	
    	array('middle', 'COM_NGE_POSITION_MIDDLE'),
	array('low', 'COM_NGE_POSITION_BOTTOM')
    	));    
       
    $form[] = NgeFields::slider($objectPrefix . 'margin','COM_NGE_MARGIN','COM_NGE_DESCRIPTION_MARGIN','40', 'min="0" max="100" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'offset','COM_NGECHARTS_OFFSET','COM_NGE_DESCRIPTION_OFFSET','0', 'min="0" max="100" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'x','COM_NGE_XOFFSET','COM_NGE_DESCRIPTION_OFFSET','0', 'min="-200" max="200" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'y','COM_NGE_YOFFSET','COM_NGE_DESCRIPTION_OFFSET','0', 'min="-200" max="200" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'rotation','COM_NGECHARTS_ROTATION','COM_NGE_DESCRIPTION_OFFSET','270', 'min="0" max="360" step="1"');

	return implode($form);    
}


function axisTitleFont($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::font($objectPrefix .'name', 'COM_NGE_FONT_NAME', 'COM_NGE_DESCRIPTION_FONT_NAME');
    $form[] = NgeFields::color($objectPrefix .'color', 'COM_NGE_FONT_COLOR', 'COM_NGE_DESCRIPTION_FONT_COLOR', '#666666');
    $form[] = NgeFields::slider($objectPrefix .'size', 'COM_NGE_FONT_SIZE', 'COM_NGE_DESCRIPTION_FONT_SIZE', '12', 'min="0" max="72"step="1"');
	$form[] = NgeFields::radio($objectPrefix .'weight', 'COM_NGE_FONT_WEIGHT', 'COM_NGE_DESCRIPTION_FONT_WEIGHT', 'normal', array(
	    array('lighter', 'COM_NGE_FONT_WEIGHT_LIGHTER'),
	    array('normal', 'COM_NGE_FONT_WEIGHT_NORMAL'),
	    array('bold', 'COM_NGE_FONT_WEIGHT_BOLD'),
	    array('bolder', 'COM_NGE_FONT_WEIGHT_BOLDER')
	    ));
	$form[] = NgeFields::radio($objectPrefix .'italic', 'COM_NGE_FONT_ITALIC', 'COM_NGE_DESCRIPTION_FONT_ITALIC', '0');
	$form[] = NgeFields::radio($objectPrefix .'case', 'COM_NGE_FONT_CASE', 'COM_NGE_DESCRIPTION_FONT', 'none', array(
	    array('none', 'COM_NGE_DEFAULT', ''),
	    array('uppercase', 'COM_NGE_FONT_CASE_UPPERCASE'),
	    array('capitalize', 'COM_NGE_FONT_CASE_CAPITALIZE'),	    
	    array('lowercase', 'COM_NGE_FONT_CASE_LOWERCASE')
	    ));

	return implode($form);    
}

function xAxisLabels($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

        // horizontal align
    $form[] = NgeFields::radio($objectPrefix . 'align', 'COM_NGE_TEXT_ALIGN', 'COM_NGE_DESCRIPTION_TEXT_ALIGN', 'default',  array(
	array('default', 'COM_NGE_DEFAULT'), 
    	array('left', 'COM_NGE_TEXT_ALIGN_LEFT'), 
    	array('center', 'COM_NGE_TEXT_ALIGN_CENTER'), 
    	array('right', 'COM_NGE_TEXT_ALIGN_RIGHT')
    	));
       //Ne marche pas
//    $form[] = NgeFields::slider($objectPrefix . 'padding','COM_NGE_PADDING','COM_NGE_DESCRIPTION_MARGIN','5', 'min="0" max="100" step="1"');    
    $form[] = NgeFields::slider($objectPrefix . 'x','COM_NGECHARTS_OFFSETX','COM_NGE_DESCRIPTION_OFFSET','0', 'min="-100" max="100" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'y','COM_NGECHARTS_OFFSETY','COM_NGE_DESCRIPTION_OFFSET','0', 'min="-100" max="100" step="1"');
    $form[] = NgeFields::radio($objectPrefix . 'rotation.mode', 'COM_NGECHARTS_ROTATION', 'COM_NGE_DESCRIPTION_TEXT_ALIGN', 'auto',  array(
	array('auto', 'COM_NGE_AUTO'),     	
    	array('custom', 'COM_NGE_CUSTOM','data-target="field:value"'),
	array('none', 'COM_NGE_NONE')
    	));
    $form[] = NgeFields::slider($objectPrefix . 'rotation.value','COM_NGECHARTS_ROTATION','COM_NGE_DESCRIPTION_OFFSET','0', 'min="0" max="360" step="1"');
    $form[] = NgeFields::text($objectPrefix . 'zindex','COM_NGE_ZINDEX','COM_NGE_DESCRIPTION_OFFSET','7');
    
    return implode($form);    
}

function yAxisLabels($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::radio($objectPrefix . 'format.mode', 'COM_NGE_TEXT_FORMAT', 'COM_NGE_DESCRIPTION_TEXT_ALIGN', 'default',  array(
    	array('default', 'COM_NGE_DEFAULT'), 
    	array('custom', 'COM_NGE_CUSTOM','data-target="field:custom"')
    	));
    
    $form[] = NgeFields::text($objectPrefix . 'format.custom', 'COM_NGE_TEXT_FORMAT', 'COM_NGE_DESCRIPTION_FORMAT', '{value}');
    
        // horizontal align
    $form[] = NgeFields::radio($objectPrefix . 'align', 'COM_NGE_TEXT_ALIGN', 'COM_NGE_DESCRIPTION_TEXT_ALIGN', 'right',  array(
    	array('right', 'COM_NGE_TEXT_ALIGN_LEFT', 'data-target="field:x field:y field:extendplotline"'), 
    	array('center', 'COM_NGE_TEXT_ALIGN_CENTER', 'data-target="field:y"'), 
    	array('left', 'COM_NGE_TEXT_ALIGN_RIGHT', 'data-target="field:x field:y"')
    ));
       //Ne marche pas
//    $form[] = NgeFields::slider($objectPrefix . 'padding','COM_NGE_PADDING','COM_NGE_DESCRIPTION_MARGIN','5', 'min="0" max="100" step="1"'); 
    $form[] = NgeFields::radio($objectPrefix . 'extendplotline', 'Étendre les lignes', 'Étend les lignes en dessosu des labels', '0',array(
        array('1', 'JYES'),
        array('0', 'JNO','data-success="false"')
    )); 
    $form[] = NgeFields::slider($objectPrefix . 'x','COM_NGE_MARGIN','COM_NGE_DESCRIPTION_OFFSET','5', 'min="0" max="100" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'y','COM_NGECHARTS_OFFSETY','COM_NGE_DESCRIPTION_OFFSET','3', 'min="-100" max="100" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'rotation','COM_NGECHARTS_ROTATION','COM_NGE_DESCRIPTION_OFFSET','0', 'min="0" max="360" step="1"');
    $form[] = NgeFields::text($objectPrefix . 'zindex','COM_NGE_ZINDEX','COM_NGE_DESCRIPTION_OFFSET','7');
    
    return implode($form);    
}

function axisLabelsFont($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::font($objectPrefix .'name', 'COM_NGE_FONT_NAME', 'COM_NGE_DESCRIPTION_FONT_NAME');
    $form[] = NgeFields::color($objectPrefix .'color', 'COM_NGE_FONT_COLOR', 'COM_NGE_DESCRIPTION_FONT_COLOR', '#666666');
    $form[] = NgeFields::slider($objectPrefix .'size', 'COM_NGE_FONT_SIZE', 'COM_NGE_DESCRIPTION_FONT_SIZE', '12', 'min="0" max="72"step="1"');
	$form[] = NgeFields::radio($objectPrefix .'weight', 'COM_NGE_FONT_WEIGHT', 'COM_NGE_DESCRIPTION_FONT_WEIGHT', 'normal', array(
	    array('lighter', 'COM_NGE_FONT_WEIGHT_LIGHTER'),
	    array('normal', 'COM_NGE_FONT_WEIGHT_NORMAL'),
	    array('bold', 'COM_NGE_FONT_WEIGHT_BOLD'),
	    array('bolder', 'COM_NGE_FONT_WEIGHT_BOLDER')
	    ));
        
	return implode($form);    
}

function xAxisLine($objectPrefix, $multiple=false, $multipleIndex=0){
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();
            
    $form[] = NgeFields::radio($objectPrefix . 'display', 'COM_NGE_DISPLAY', '', '1',array(
    	array('1', 'JYES','data-target="field:width field:color"'),
    	array('0', 'JNO','data-success="false"')
    	));      
    $form[] = NgeFields::slider($objectPrefix . 'width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_AXIS_WIDTH','1', 'min="1" max="50" step="1"');
    $form[] = NgeFields::color($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_AXIS_COLOR','#ccd6eb');
    
    return implode($form);
}

function xAxisLineBackground($objectPrefix, $multiple=false, $multipleIndex=0){
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();
    
    $form[] = NgeFields::radio($objectPrefix.'display', 'COM_NGE_DISPLAY', '', '0',array(
        array('1', 'JYES','data-target="field:color field:width"'),
        array('0', 'JNO','data-success="false"')
    ));  
    $form[] = NgeFields::radio($objectPrefix . 'width', 'Largeur du background', '', 'all',  array(
        array('all', 'Tout'), 
        array('origin', "A partir de l'origine")
    ));  
    $form[] = NgeFields::color($objectPrefix.'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_AXIS_COLOR','#cccccc');
                                                    
    return implode($form);
}

function yAxisLine($objectPrefix, $multiple=false, $multipleIndex=0){
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();
            
    $form[] = NgeFields::radio($objectPrefix . 'display', 'COM_NGE_DISPLAY', '', '0',array(
    	array('1', 'JYES','data-target="field:width field:color"'),
    	array('0', 'JNO','data-success="false"')
    	));      
    $form[] = NgeFields::slider($objectPrefix . 'width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_AXIS_WIDTH','1', 'min="1" max="50" step="1"');
    $form[] = NgeFields::color($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_AXIS_COLOR','#ccd6eb');
    
    return implode($form);
}

function axisTickoptions($objectPrefix, $multiple=false, $multipleIndex=0){
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();        
    
    return implode($form);
}


function axisTicks($objectPrefix, $multiple=false, $multipleIndex=0){
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::radio($objectPrefix . 'display', 'COM_NGE_DISPLAY', '', '1',array(
    	array('1', 'JYES','data-target="field:position field:width field:length field:color"'),
    	array('0', 'JNO','data-success="false"')
    	));      
    
    $form[] = NgeFields::radio($objectPrefix . 'position', 'COM_NGE_POSITION', 'COM_NGE_POSITION_DESC', 'outside',  array(
    	array('outside', 'COM_NGE_OUTSIDE'), 
	array('inside', 'COM_NGE_INSIDE')
    	)); 
    
    $form[] = NgeFields::slider($objectPrefix . 'width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_TICK_WIDTH','1', 'min="1" max="50" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'length','COM_NGE_LENGTH','COM_NGE_DESCRIPTION_TICK_LENGTH','10', 'min="0" max="50" step="1"');
    $form[] = NgeFields::color($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_AXIS_COLOR','#ccd6eb');
    
    
    return implode($form);
}

function xAxisMinorticks($objectPrefix, $multiple=false, $multipleIndex=0){
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::radio($objectPrefix . 'display', 'COM_NGE_DISPLAY', '', '0', array(
    	array('1', 'JYES','data-target="field:position field:width field:length field:color"'),
    	array('0', 'JNO','data-success="false"')
    	));      
    
    $form[] = NgeFields::radio($objectPrefix . 'position', 'COM_NGE_POSITION', 'COM_NGE_POSITION_DESC', 'outside',  array(
    	array('outside', 'COM_NGE_OUTSIDE'), 
	array('inside', 'COM_NGE_INSIDE')
    	)); 
    
    $form[] = NgeFields::slider($objectPrefix . 'width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_TICK_WIDTH','1', 'min="1" max="50" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'length','COM_NGE_LENGTH','COM_NGE_DESCRIPTION_TICK_LENGTH','10', 'min="0" max="50" step="1"');
    $form[] = NgeFields::color($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_AXIS_COLOR','#ccd6eb');
    
    
    return implode($form);
}

function yAxisMinorticks($objectPrefix, $multiple=false, $multipleIndex=0){
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::radio($objectPrefix . 'display', 'COM_NGE_DISPLAY', '', '1',array(
    	array('1', 'JYES','data-target="field:position field:width field:length field:color"'),
    	array('0', 'JNO','data-success="false"')
    	));      
    
    $form[] = NgeFields::radio($objectPrefix . 'position', 'COM_NGE_POSITION', 'COM_NGE_POSITION_DESC', 'outside',  array(
    	array('outside', 'COM_NGE_OUTSIDE'), 
	array('inside', 'COM_NGE_INSIDE')
    	)); 
    
    $form[] = NgeFields::slider($objectPrefix . 'width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_TICK_WIDTH','1', 'min="1" max="50" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'length','COM_NGE_LENGTH','COM_NGE_DESCRIPTION_TICK_LENGTH','10', 'min="0" max="50" step="1"');
    $form[] = NgeFields::color($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_AXIS_COLOR','#ccd6eb');
    
    
    return implode($form);
}

function xAxisGridLines($objectPrefix, $multiple=false, $multipleIndex=0){
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();
    
    $form[] = NgeFields::radio($objectPrefix . 'display', 'COM_NGE_DISPLAY', '', '0',array(
    	array('1', 'JYES','data-target="field:style field:width field:color"'),
    	array('0', 'JNO','data-success="false"')
    	));      
    $form[] = NgeFields::select($objectPrefix .'style', 'COM_NGE_STYLE', 'COM_NGE_DESCRIPTION_TYPE', 'solid', $multiple, $multipleIndex, 
		array(
                "options" => array(
	    array('solid', 'COM_NGECHARTS_LINE_SOLID'),
	    array('shortdot', 'COM_NGECHARTS_LINE_SHORTDOT'),
	    array('dot', 'COM_NGECHARTS_LINE_DOT'),
	    array('shortdash', 'COM_NGECHARTS_LINE_SHORTDASH'),
	    array('dash', 'COM_NGECHARTS_LINE_DASH'),
	    array('longdash', 'COM_NGECHARTS_LINE_LONGDASH')
	    )
		    )
		);        
    $form[] = NgeFields::slider($objectPrefix . 'width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_GRID_WIDTH','1', 'min="1" max="50" step="1"');
    $form[] = NgeFields::color($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_AXIS_COLOR','#e6e6e6');    
    
    return implode($form);
}

function yAxisGridLines($objectPrefix, $multiple=false, $multipleIndex=0){
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();
    
    $form[] = NgeFields::radio($objectPrefix . 'display', 'COM_NGE_DISPLAY', '', '1',array(
    	array('1', 'JYES','data-target="field:style field:width field:color"'),
    	array('0', 'JNO','data-success="false"')
    	));      
    $form[] = NgeFields::select($objectPrefix .'style', 'COM_NGE_STYLE', 'COM_NGE_DESCRIPTION_TYPE', 'solid', $multiple, $multipleIndex, 
		array(
                "options" => array(
	    array('solid', 'COM_NGECHARTS_LINE_SOLID'),
	    array('shortdot', 'COM_NGECHARTS_LINE_SHORTDOT'),
	    array('dot', 'COM_NGECHARTS_LINE_DOT'),
	    array('shortdash', 'COM_NGECHARTS_LINE_SHORTDASH'),
	    array('dash', 'COM_NGECHARTS_LINE_DASH'),
	    array('longdash', 'COM_NGECHARTS_LINE_LONGDASH')
	    )
		    )
		);    
    $form[] = NgeFields::slider($objectPrefix . 'width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_GRID_WIDTH','1', 'min="1" max="50" step="1"');
    $form[] = NgeFields::color($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_AXIS_COLOR','#e6e6e6');    
    
    return implode($form);
}


function xAxisGridMinorlines($objectPrefix, $multiple=false, $multipleIndex=0){
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();
    
    $form[] = NgeFields::radio($objectPrefix . 'display', 'COM_NGE_DISPLAY', '', '0',array(
    	array('1', 'JYES','data-target="field:style field:width field:color"'),
    	array('0', 'JNO','data-success="false"')
    	));      
$form[] = NgeFields::select($objectPrefix .'style', 'COM_NGE_STYLE', 'COM_NGE_DESCRIPTION_TYPE', 'solid', $multiple, $multipleIndex, 
		array(
                "options" => array(
	    array('solid', 'COM_NGECHARTS_LINE_SOLID'),
	    array('shortdot', 'COM_NGECHARTS_LINE_SHORTDOT'),
	    array('dot', 'COM_NGECHARTS_LINE_DOT'),
	    array('shortdash', 'COM_NGECHARTS_LINE_SHORTDASH'),
	    array('dash', 'COM_NGECHARTS_LINE_DASH'),
	    array('longdash', 'COM_NGECHARTS_LINE_LONGDASH')
	    )
		    )
		);            
    $form[] = NgeFields::slider($objectPrefix . 'width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_GRID_WIDTH','1', 'min="1" max="50" step="1"');
    $form[] = NgeFields::color($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_AXIS_COLOR','#e6e6e6');
    
    return implode($form);
}

function yAxisGridMinorlines($objectPrefix, $multiple=false, $multipleIndex=0){
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();
    
    $form[] = NgeFields::radio($objectPrefix . 'display', 'COM_NGE_DISPLAY', '', '1',array(
    	array('1', 'JYES','data-target="field:style field:width field:color"'),
    	array('0', 'JNO','data-success="false"')
    	));      
    $form[] = NgeFields::select($objectPrefix .'style', 'COM_NGE_STYLE', 'COM_NGE_DESCRIPTION_TYPE', 'solid', $multiple, $multipleIndex, 
		array(
                "options" => array(
	    array('solid', 'COM_NGECHARTS_LINE_SOLID'),
	    array('shortdot', 'COM_NGECHARTS_LINE_SHORTDOT'),
	    array('dot', 'COM_NGECHARTS_LINE_DOT'),
	    array('shortdash', 'COM_NGECHARTS_LINE_SHORTDASH'),
	    array('dash', 'COM_NGECHARTS_LINE_DASH'),
	    array('longdash', 'COM_NGECHARTS_LINE_LONGDASH')
	    )
		    )
		);        
    $form[] = NgeFields::slider($objectPrefix . 'width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_GRID_WIDTH','1', 'min="1" max="50" step="1"');
    $form[] = NgeFields::color($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_AXIS_COLOR','#e6e6e6');
    
    return implode($form);
}


function axisGridBands($objectPrefix, $multiple=false, $multipleIndex=0){
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();
    
        $form[] = NgeFields::radio($objectPrefix . 'display', 'COM_NGE_DISPLAY', '', '0',array(
    	array('1', 'JYES','data-target="field:color"'),
    	array('0', 'JNO','data-success="false"')
    	));  

    $form[] = NgeFields::color($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_AXIS_COLOR','#ccd6eb');
        
    return implode($form);
}
