<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */

defined('_JEXEC') or die;


function chartSeriesDefaultBar($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::hidden($objectPrefix .'type', 'bar');
    $form[] = NgeFields::radio($objectPrefix .'style', 'COM_NGE_TYPE', 'COM_NGE_DESCRIPTION_TYPE', 'default', array(
	    array('default', 'COM_NGE_DEFAULT', 'data-target="field:chart[series][default][pie][start]"'),
	    array('stacked', 'COM_NGECHARTS_TYPE_STACKED', 'data-target="field:chart[series][default][pie][start] field:width"'),
	    array('stackedpercent', 'COM_NGECHARTS_TYPE_STACKEDPERCENT', 'data-target="field:chart[series][default][semicircle][start] field:chart[series][default][semicircle][end]"'),
	    array('pyramid', 'COM_NGECHARTS_TYPE_PYRAMID', 'data-target="field:chart[series][default][semicircle][start] field:chart[series][default][semicircle][end] field:width"')
	    ));
        
    $form[] = NgeFields::radio($objectPrefix . 'animation', 'COM_NGE_ANIMATION', '', '1');      
    
    
        $form[] = NgeFields::radio($objectPrefix .'width.mode', 'COM_NGE_WIDTH', 'COM_NGE_DESCRIPTION_TYPE', 'auto', array(
	    array('auto', 'COM_NGE_AUTO'),
	    array('relative', 'COM_NGE_DISPLAY_WIDTH_FLEXIBLE', 'data-target="field:chart[series][default][width][relative][value]"'),
	    array('fixed', 'COM_NGE_DISPLAY_WIDTH_FIXED', 'data-target="field:chart[series][default][width][fixed][value]"')	    
	    ));
    $form[] = NgeFields::slider($objectPrefix . 'width.relative.value','COM_NGE_WIDTH','COM_NGE_DISPLAY_WIDTH_FLEXIBLE_DESC','75', 'min="1" max="100" step="1"  suffix="%"');	
    // fixed mode value    
    
    $form[] = NgeFields::text($objectPrefix . 'width.fixed.value', 'COM_NGE_WIDTH', 'COM_NGE_DISPLAY_WIDTH_FIXED_DESC', '200', array('attributes' => 'class="span3"', 'suffix' => 'px'));

	
    
    return implode($form);    
}

/*
 * Border of bars
 * 
 */
function chartSeriesDefaultBarBorder($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();
    $form[] = NgeFields::radio($objectPrefix . 'display', 'COM_NGE_DISPLAY', '', '1',array(
    array('1', 'JYES','data-target="field:width field:color field:radius"'),
    array('0', 'JNO','data-success="false"')
    ));      

    $form[] = NgeFields::slider($objectPrefix . 'width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_LINE_WIDTH','1', 'min="1" max="50"step="1"');
    $form[] = NgeFields::color($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_COLOR','#FFFFFF');
    $form[] = NgeFields::slider($objectPrefix . 'radius','COM_NGE_RADIUS','COM_NGE_DESCRIPTION_LINE_WIDTH','0', 'min="0" max="50"step="1"');
    return implode($form);
    
}
