<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */

defined('_JEXEC') or die;

function chartSeriesDefaultPie($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::hidden($objectPrefix .'type', 'pie');
    $form[] = NgeFields::radio($objectPrefix .'style', 'COM_NGECHARTS_TYPE', 'COM_NGE_DESCRIPTION_TYPE', 'pie', array(
	    array('pie', 'COM_NGECHARTS_TYPE_PIE', 'data-target="field:chart[series][default][pie][start]"'),
	    array('donut', 'COM_NGECHARTS_TYPE_DONUT', 'data-target="field:chart[series][default][pie][start] field:width"'),
	    array('semipie', 'COM_NGECHARTS_TYPE_SEMIPIE', 'data-target="field:chart[series][default][semicircle][start] field:chart[series][default][semicircle][end]"'),
	    array('semidonut', 'COM_NGECHARTS_TYPE_SEMIDONUT', 'data-target="field:chart[series][default][semicircle][start] field:chart[series][default][semicircle][end] field:width"')
	    ));
    $form[] = NgeFields::slider($objectPrefix . 'pie.start','COM_NGECHARTS_STARTANGLE','COM_NGE_DESCRIPTION_LINE_WIDTH','0', 'min="-180" max="180" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'donut.width','COM_NGECHARTS_HOLE','COM_NGE_DESCRIPTION_LINE_WIDTH','50', 'min="1" max="99" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'semicircle.start','COM_NGECHARTS_STARTANGLE','COM_NGE_DESCRIPTION_LINE_WIDTH','-90', 'min="-180" max="180" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'semicircle.end','COM_NGECHARTS_ENDANGLE','COM_NGE_DESCRIPTION_LINE_WIDTH','90', 'min="-180" max="180" step="1"');            
    $form[] = NgeFields::radio($objectPrefix . 'animation', 'COM_NGE_ANIMATION', '', '1');      
    
    
        $form[] = NgeFields::radio($objectPrefix .'width.mode', 'COM_NGE_WIDTH', 'COM_NGE_DESCRIPTION_TYPE', 'auto', array(
	    array('auto', 'COM_NGE_AUTO'),
	    array('relative', 'COM_NGE_DISPLAY_WIDTH_FLEXIBLE', 'data-target="field:chart[series][default][width][relative][value]"'),
	    array('fixed', 'COM_NGE_DISPLAY_WIDTH_FIXED', 'data-target="field:chart[series][default][width][fixed][value]"')	    
	    ));
    $form[] = NgeFields::slider($objectPrefix . 'width.relative.value','COM_NGE_WIDTH','COM_NGE_DISPLAY_WIDTH_FLEXIBLE_DESC','75', 'min="1" max="100" step="1"  suffix="%"');	
    // fixed mode value    
    $form[] = NgeFields::text($objectPrefix . 'width.fixed.value', 'COM_NGE_WIDTH', 'COM_NGE_DISPLAY_WIDTH_FIXED_DESC', '200', array('attributes' => 'class="span3"', 'suffix' => 'px'));

	    
    return implode($form);    
}


/*
 * Border of pie slices
 */
function chartSeriesDefaultPieBorder($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();
    $form[] = NgeFields::radio($objectPrefix . 'display', 'COM_NGE_DISPLAY', '', '1',array(
    array('1', 'JYES','data-target="field:width field:color"'),
    array('0', 'JNO','data-success="false"')
    ));      

    $form[] = NgeFields::slider($objectPrefix . 'width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_LINE_WIDTH','1', 'min="1" max="50"step="1"');
    $form[] = NgeFields::color($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_COLOR','#FFFFFF');
    return implode($form);
    
}


function chartSeriesDefaultPieLabelsData($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::radio($objectPrefix .'formatter', 'COM_NGE_STYLE', 'COM_NGE_DESCRIPTION_TYPE', 'y', array(
	    array('y', 'COM_NGECHARTS_DATA_POINTVALUE'),
	    array('percentage', 'COM_NGECHARTS_DATA_POINTPERCENTAGE'),
	    array('point', 'COM_NGECHARTS_DATA_POINTLABEL'),
	    array('custom', 'COM_NGE_CUSTOM','data-target="field:format"')
	    ));
    
    $form[] = NgeFields::text($objectPrefix . 'format', 'COM_NGE_TEXT_FORMAT', 'COM_NGE_DESCRIPTION_FORMAT', '{y}');
    
    return implode($form);    
}

function chartSeriesDefaultPieLabelsDisplay($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::radio($objectPrefix . 'position.mode', 'COM_NGE_POSITION', 'COM_NGE_DESCRIPTION_TEXT_ALIGN', 'outside',  array(
	array('outside', 'COM_NGE_OUTSIDE','data-target="#seriesdefaultlabelsconnectortab"'),
    	array('inside', 'COM_NGE_INSIDE')    	
    	));
    $form[] = NgeFields::slider($objectPrefix . 'distance','COM_NGE_DISTANCE','COM_NGE_DESCRIPTION_OFFSET','30', 'min="0" max="100" step="1"');
        
    $form[] = NgeFields::slider($objectPrefix . 'x','COM_NGE_XOFFSET','COM_NGE_DESCRIPTION_OFFSET','0', 'min="-100" max="100" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'y','COM_NGE_YOFFSET','COM_NGE_DESCRIPTION_OFFSET','-6', 'min="-100" max="100" step="1"');

    
    $form[] = NgeFields::radio($objectPrefix .'shape', 'COM_NGE_STYLE', 'COM_NGE_DESCRIPTION_TYPE', 'square', array(
	    array('square', 'COM_NGE_SQUARE'),
	    array('callout', 'COM_NGE_CALLOUT'),
	    array('circle', 'COM_NGE_CIRCLE'),
	    array('diamond', 'COM_NGE_DIAMOND'),	    	    
	    array('triangle', 'COM_NGE_TRIANGLE'),
	    array('triangle-down', 'COM_NGE_TRIANGLEDOWN')
	    ));
        
    $form[] = NgeFields::slider($objectPrefix . 'padding','COM_NGE_PADDING','COM_NGE_DESCRIPTION_MARGIN','5', 'min="0" max="100" step="1"');    
    $form[] = NgeFields::slider($objectPrefix . 'rotation','COM_NGE_ROTATION','COM_NGE_DESCRIPTION_OFFSET','0', 'min="0" max="360" step="1"');
    
    return implode($form);    
}

 function chartSeriesDefaultPieLabelsConnector($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();
    
    $form[] = NgeFields::radio($objectPrefix .'display', 'COM_NGE_DISPLAY', 'COM_NGE_DESCRIPTION_COLOR', '1', array(
	    array('1', 'JYES','data-target="field:width field:style field:value field:padding"'),
	    array('0', 'JNO','data-success="false"')
	    ));
    $form[] = NgeFields::radio($objectPrefix . 'style','COM_NGE_STYLE','COM_NGE_DESCRIPTION_BACKGROUND_STYLE','soft', array(
        array('soft','COM_NGECHARTS_SOFT'),
        array('hard','COM_NGECHARTS_HARD')
    ));    
    $form[] = NgeFields::slider($objectPrefix . 'width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_BORDER_WIDTH','1', 'min="1" max="50"step="1"');
    $form[] = NgeFields::radio($objectPrefix .'color.style', 'COM_NGE_COLOR', 'COM_NGE_DESCRIPTION_COLOR', 'point', array(
	    array('point', 'COM_NGECHARTS_PIEPART'),
	    array('custom', 'COM_NGE_CUSTOM','data-target="field:value"')
	    ));
    $form[] = NgeFields::color($objectPrefix .'color.value', 'COM_NGE_COLOR', 'COM_NGE_DESCRIPTION_FONT_COLOR', '#666666');

    $form[] = NgeFields::slider($objectPrefix . 'padding','COM_NGE_PADDING','COM_NGE_DESCRIPTION_MARGIN','5', 'min="0" max="100" step="1"');    
    
    return implode($form);    
}
