<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */

defined('_JEXEC') or die;


function chartSeriesDefaultPolar($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::hidden($objectPrefix .'type', 'polar');
    $form[] = NgeFields::radio($objectPrefix .'style', 'COM_NGECHARTS_TYPE', 'COM_NGE_DESCRIPTION_TYPE', 'line', array(
	    array('line', 'COM_NGECHARTS_TYPE_LINE', 'data-target="field:chart[series][default][pie][start]"'),
	    array('area', 'COM_NGECHARTS_TYPE_AREA', 'data-target="field:chart[series][default][pie][start] field:width"'),
	    array('pie', 'COM_NGECHARTS_PIEPART', 'data-target="field:chart[series][default][semicircle][start] field:chart[series][default][semicircle][end]"')
	    ));
    $form[] = NgeFields::slider($objectPrefix . 'pie.start','COM_NGECHARTS_STARTANGLE','COM_NGE_DESCRIPTION_LINE_WIDTH','0', 'min="-180" max="180" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'donut.width','COM_NGECHARTS_HOLE','COM_NGE_DESCRIPTION_LINE_WIDTH','50', 'min="1" max="99" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'semicircle.start','COM_NGECHARTS_STARTANGLE','COM_NGE_DESCRIPTION_LINE_WIDTH','-90', 'min="-180" max="180" step="1"');
    $form[] = NgeFields::slider($objectPrefix . 'semicircle.end','COM_NGECHARTS_ENDANGLE','COM_NGE_DESCRIPTION_LINE_WIDTH','90', 'min="-180" max="180" step="1"');            
    $form[] = NgeFields::radio($objectPrefix . 'animation', 'COM_NGE_ANIMATION', '', '1');      
    
    
        $form[] = NgeFields::radio($objectPrefix .'width.mode', 'COM_NGE_WIDTH', 'COM_NGE_DESCRIPTION_TYPE', 'auto', array(
	    array('auto', 'COM_NGE_AUTO'),
	    array('relative', 'COM_NGE_DISPLAY_WIDTH_FLEXIBLE', 'data-target="field:chart[series][default][width][relative][value]"'),
	    array('fixed', 'COM_NGE_DISPLAY_WIDTH_FIXED', 'data-target="field:chart[series][default][width][fixed][value]"')	    
	    ));
    $form[] = NgeFields::slider($objectPrefix . 'width.relative.value','COM_NGE_WIDTH','COM_NGE_DISPLAY_WIDTH_FLEXIBLE_DESC','75', 'min="1" max="100" step="1"  suffix="%"');	
    // fixed mode value    
    $form[] = NgeFields::text($objectPrefix . 'width.fixed.value', 'COM_NGE_WIDTH', 'COM_NGE_DISPLAY_WIDTH_FIXED_DESC', '200', array('attributes' => 'class="span3"', 'suffix' => 'px'));
	    
    return implode($form);    
}