<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */

defined('_JEXEC') or die;


function chartPrintSeriesDefaultColors($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::radio($objectPrefix . 'colors.style','Couleurs des séries','Créer vos propres thèmes de couleur pour les séries ou utiliser un modèle enregistré','custom', array(        
        array('custom','COM_NGE_CUSTOM','data-target="field:values"'),
        array('pattern','COM_NGE_PATTERN','data-target="#chart_series_colors_pattern"')
    ));

    $form[] = NgeFields::colors($objectPrefix . 'colors.values','Couleurs','Default colors for the data series, or for individual points in a pie series or a column series with individual colors. Colors will be picked in succession. If a color is explicitly set for each series in the <em>Data series</em> view, that color will take precedence.',  
            9, 
            array('#7cb5ec', '#434348', '#90ed7d', '#f7a35c', '#8085e9', '#f15c80', '#e4d354', '#2b908f', '#f45b5b', '#91e8e1'), 
            array()
    );

    $form[] = '<div id="chart_series_colors_pattern">';
    $form[] = NGEFields::pattern($objectPrefix . 'colors.pattern', 'Modèle', "Modèle général d'affichage des lignes.", 'part.option', 'chart.series.theme');
    $form[] = '</div>';
    
    return implode($form);
    
}

function chartPrintSeriesDefaultLineOptions($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::slider($objectPrefix . 'width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_LINE_WIDTH','0.5', 'min="0.1" max="5" step="0.1" suffix="pt"');
    
    $form[] = NgeFields::select($objectPrefix .'style', 'COM_NGE_STYLE', 'COM_NGE_DESCRIPTION_TYPE', 'solid', $multiple, $multipleIndex, 
    array(
	    "options" => array(
	array('solid', 'COM_NGECHARTS_LINE_SOLID'),
	array('shortdot', 'COM_NGECHARTS_LINE_SHORTDOT'),
	array('dot', 'COM_NGECHARTS_LINE_DOT'),
	array('shortdash', 'COM_NGECHARTS_LINE_SHORTDASH'),
	array('dash', 'COM_NGECHARTS_LINE_DASH'),
	array('longdash', 'COM_NGECHARTS_LINE_LONGDASH')
	)
	)
    );        
    
    $form[] = NgeFields::radio($objectPrefix .'cap', 'COM_NGECHARTS_LINECAP', 'COM_NGE_DESCRIPTION_CAP', 'round', array(
	    array('round', 'COM_NGECHARTS_LINECAP_ROUND'),
	    array('square', 'COM_NGECHARTS_LINECAP_SQUARE')
	    ));
    return implode($form);
    
}

function chartPrintSeriesDefaultMarkersDisplay($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::radio($objectPrefix .'shape', 'COM_NGE_STYLE', 'COM_NGE_DESCRIPTION_TYPE', 'auto', array(
	    array('auto', 'COM_NGE_AUTO', 'data-target="field:radius"'),
	    array('circle', 'COM_NGE_CIRCLE', 'data-target="field:radius"'),
	    array('square', 'COM_NGE_SQUARE', 'data-target="field:radius"'),
	    array('diamond', 'COM_NGECHARTS_DIAMOND', 'data-target="field:radius"'),	    	    
	    array('triangle', 'COM_NGE_TRIANGLE', 'data-target="field:radius"'),
	    array('triangle-down', 'COM_NGECHARTS_TRIANGLEDOWN', 'data-target="field:radius"'),
	    /*array('cross', 'COM_NGE_CROSS', 'data-target="field:radius"'),*/
	/*See http://jsfiddle.net/gh/get/library/pure/highcharts/highcharts/tree/master/samples/highcharts/plotoptions/series-marker-symbol/*/	
	    array('image', 'COM_NGE_IMAGE', 'data-target="field:url field:width field:height"')
	    ));
        
    $form[] = NgeFields::slider($objectPrefix . 'size','COM_NGE_SIZE','COM_NGE_DESCRIPTION_SIZE','2', 'min="0.1" max="10" step="0.1" suffix="mm"');
    $form[] = NgeFields::url($objectPrefix . 'image.url','COM_NGE_IMAGE','COM_NGE_DESCRIPTION_IMAGE','');
    $form[] = NgeFields::slider($objectPrefix . 'image.width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_RADIUS','4', 'min="1" max="20" step="0.1" suffix="mm"');
    $form[] = NgeFields::slider($objectPrefix . 'image.height','COM_NGE_HEIGHT','COM_NGE_DESCRIPTION_RADIUS','4', 'min="1" max="20" step="0.1" suffix="mm"');
    
    return implode($form);    
}

function chartPrintSeriesDefaultMarkersBorder($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

            $form[] = NgeFields::radio($objectPrefix . 'display', 'COM_NGE_DISPLAY', '', '0',array(
    	array('1', 'JYES','data-target="#chart_marker_border_options"'),
    	array('0', 'JNO','data-success="false"')
    	));      
    $form[] = '<div id="chart_marker_border_options">';
    $form[] = NgeFields::slider($objectPrefix . 'width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_BORDER_WIDTH','0.2', 'min="0.1" max="5" step="0.1" suffix="pt"');
        $form[] = NgeFields::radio($objectPrefix . 'color.style','COM_NGE_COLOR','COM_NGE_DESCRIPTION_BACKGROUND_STYLE','default', array(
        array('default','COM_NGE_DEFAULT'),
        array('custom','COM_NGE_CUSTOM','data-target="field:value"')
    ));

    $form[] = NgeFields::colorcmyk($objectPrefix . 'color.value','COM_NGE_COLOR','COM_NGE_DESCRIPTION_BORDER_COLOR','#000000');
    $form[] = '</div>';
    return implode($form);    
}

function chartPrintSeriesDefaultMarkersBackground($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::radio($objectPrefix . 'style','COM_NGE_STYLE','COM_NGE_DESCRIPTION_BACKGROUND_STYLE','default', array(
        array('default','COM_NGE_DEFAULT'),
        array('solid','COM_NGE_BACKGROUND_SOLID','data-target="field:color field:color_hover field:opacity field:background[overflow][direction] #'.str_replace('.', '_', $objectPrefix).'_effects"'),
        array('gradient','COM_NGE_BACKGROUND_GRADIENT','data-target="#'.str_replace('.', '_', $objectPrefix).'_direction field:color field:color2 field:color_hover field:color_hover2 field:opacity field:background[overflow][direction] #'.str_replace('.', '_', $objectPrefix).'_effects"')
    ));

    // background direction    
    $form[] = '<div id="'.str_replace('.', '_', $objectPrefix).'_direction">'; 
    $form[] = NgeFields::radio($objectPrefix . 'direction','COM_NGE_BACKGROUND_GRADIENT_DIRECTION','COM_NGE_DESCRIPTION_BACKGROUND_DIRECTION','vertical', array(
        array('vertical','COM_NGE_VERTICAL'), 
        array('horizontal','COM_NGE_HORIZONTAL')
    ));
    $form[] = '</div>'; 

    $form[] = NgeFields::colorcmyk($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_COLOR','#FFFFFF');
    $form[] = NgeFields::colorcmyk($objectPrefix . 'color2','COM_NGE_COLOR_LAST','COM_NGE_DESCRIPTION_COLOR_LAST','#ffffff');
    $form[] = NgeFields::slider($objectPrefix . 'opacity','COM_NGE_OPACITY','COM_NGE_DESCRIPTION_BACKGROUND_OPACITY','100', 'min="0" max="100"step="1"');
                
    return implode($form);    
}

function chartPrintSeriesDefaultLabelsDisplay($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

        // horizontal align
    $form[] = NgeFields::radio($objectPrefix . 'align', 'COM_NGE_TEXT_ALIGN', 'COM_NGE_DESCRIPTION_TEXT_ALIGN', 'center',  array(
    	array('left', 'COM_NGE_TEXT_ALIGN_LEFT'), 
    	array('center', 'COM_NGE_TEXT_ALIGN_CENTER'), 
    	array('right', 'COM_NGE_TEXT_ALIGN_RIGHT')
    	));
    $form[] = NgeFields::radio($objectPrefix . 'verticalalign', 'COM_NGE_TEXT_ALIGN', 'COM_NGE_DESCRIPTION_TEXT_ALIGN', 'bottom',  array(
	array('top', 'COM_NGE_POSITION_TOP'), 
    	array('middle', 'COM_NGE_POSITION_MIDDLE'), 
    	array('bottom', 'COM_NGE_POSITION_BOTTOM')
    	)); 
    $form[] = NgeFields::slider($objectPrefix . 'x','COM_NGECHARTS_OFFSETX','COM_NGE_DESCRIPTION_OFFSET','0', 'min="-20" max="20" step="0.1" suffix="mm"');
    $form[] = NgeFields::slider($objectPrefix . 'y','COM_NGECHARTS_OFFSETY','COM_NGE_DESCRIPTION_OFFSET','-1.5', 'min="-20" max="20" step="0.1" suffix="mm"');
    
    $form[] = NgeFields::radio($objectPrefix .'shape', 'COM_NGE_STYLE', 'COM_NGE_DESCRIPTION_TYPE', 'square', array(
	    array('square', 'COM_NGE_SQUARE'),
	    array('callout', 'COM_NGECHARTS_CALLOUT'),
	    array('circle', 'COM_NGE_CIRCLE'),
	    array('diamond', 'COM_NGECHARTS_DIAMOND'),	    	    
	    array('triangle', 'COM_NGE_TRIANGLE'),
	    array('triangle-down', 'COM_NGECHARTS_TRIANGLEDOWN')
	    ));
        
    $form[] = NgeFields::slider($objectPrefix . 'padding','COM_NGE_PADDING','COM_NGE_DESCRIPTION_MARGIN','1.5', 'min="0" max="10" step="0.1" suffix="mm"');    
    $form[] = NgeFields::slider($objectPrefix . 'rotation','COM_NGECHARTS_ROTATION','COM_NGE_DESCRIPTION_OFFSET','0', 'min="0" max="360" step="1"');
    
    return implode($form);    
}

function chartPrintSeriesDefaultLabelsFont($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::font($objectPrefix .'name', 'COM_NGE_FONT_NAME', 'COM_NGE_DESCRIPTION_FONT_NAME');
    $form[] = NgeFields::slider($objectPrefix .'size', 'COM_NGE_FONT_SIZE', 'COM_NGE_DESCRIPTION_FONT_SIZE_PT', '5', 'min="0" max="36" step="0.5" suffix="pt"');
	$form[] = NgeFields::radio($objectPrefix .'weight', 'COM_NGE_FONT_WEIGHT', 'COM_NGE_DESCRIPTION_FONT_WEIGHT', 'bold', array(
	    array('lighter', 'COM_NGE_FONT_WEIGHT_LIGHTER'),
	    array('normal', 'COM_NGE_FONT_WEIGHT_NORMAL'),
	    array('bold', 'COM_NGE_FONT_WEIGHT_BOLD'),
	    array('bolder', 'COM_NGE_FONT_WEIGHT_BOLDER')
	    ));
    
    $form[] = NgeFields::radio($objectPrefix .'color.style', 'COM_NGE_COLOR', 'COM_NGE_DESCRIPTION_COLOR', 'contrast', array(
	    array('contrast', 'COM_NGECHARTS_CONTRAST'),
	    array('custom', 'COM_NGE_CUSTOM','data-target="field:value"')
	    ));
    $form[] = NgeFields::colorcmyk($objectPrefix .'color.value', 'COM_NGE_FONT_COLOR', 'COM_NGE_DESCRIPTION_FONT_COLOR', '#666666');
    $form[] = NgeFields::radio($objectPrefix .'outline.display', 'COM_NGECHARTS_OUTLINE', 'COM_NGE_DESCRIPTION_COLOR', '1', array(
	    array('1', 'JYES','data-target="#chart_series_default_labels_font_outline"'),
	    array('0', 'JNO','data-success="false"')
	    ));
    $form[] = '<div id="chart_series_default_labels_font_outline">';
    $form[] = NgeFields::slider($objectPrefix . 'outline.width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_BORDER_WIDTH','0.2', 'min="0.1" max="5" step="0.1" suffix="pt"');
    $form[] = NgeFields::radio($objectPrefix .'outline.color.style', 'COM_NGE_COLOR', 'COM_NGE_DESCRIPTION_COLOR', 'contrast', array(
	    array('contrast', 'COM_NGECHARTS_CONTRAST'),
	    array('custom', 'COM_NGE_CUSTOM','data-target="field:value"')
	    ));
    $form[] = NgeFields::colorcmyk($objectPrefix .'outline.color.value', 'COM_NGE_FONT_COLOR', 'COM_NGE_DESCRIPTION_FONT_COLOR', '#666666');    
    $form[] = '</div>';    
    return implode($form);    
}
function chartPrintSeriesDefaultLabelsBorder($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

            $form[] = NgeFields::radio($objectPrefix . 'display', 'COM_NGE_DISPLAY', '', '0',array(
    	array('1', 'JYES','data-target="field:width field:color field:radius_width"'),
    	array('0', 'JNO','data-success="false"')
    	));      

    $form[] = NgeFields::slider($objectPrefix . 'width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_BORDER_WIDTH','0.2', 'min="0.1" max="5" step="0.1" suffix="pt"');
    $form[] = NgeFields::colorcmyk($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_BORDER_COLOR','#000000');
    $form[] = NgeFields::slider($objectPrefix . 'radius_width','COM_NGE_RADIUS','COM_NGE_DESCRIPTION_RADIUS','0', 'min="0" max="20" step="0.1" suffix="mm"');    
        

    return implode($form);    
}
function chartPrintSeriesDefaultLabelsBackground($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::radio($objectPrefix . 'style','COM_NGE_STYLE','COM_NGE_DESCRIPTION_BACKGROUND_STYLE','none', array(
        array('none','COM_NGE_NONE', 'data-success="false"'),
        array('solid','COM_NGE_BACKGROUND_SOLID','data-target="field:color field:color_hover field:opacity field:background[overflow][direction] #'.str_replace('.', '_', $objectPrefix).'_effects"'),
        array('gradient','COM_NGE_BACKGROUND_GRADIENT','data-target="#'.str_replace('.', '_', $objectPrefix).'_direction field:color field:color2 field:color_hover field:color_hover2 field:opacity field:background[overflow][direction] #'.str_replace('.', '_', $objectPrefix).'_effects"')
    ));

    // background direction    
    $form[] = '<div id="'.str_replace('.', '_', $objectPrefix).'_direction">'; 
    $form[] = NgeFields::radio($objectPrefix . 'direction','COM_NGE_BACKGROUND_GRADIENT_DIRECTION','COM_NGE_DESCRIPTION_BACKGROUND_DIRECTION','vertical', array(
        array('vertical','COM_NGE_VERTICAL'), 
        array('horizontal','COM_NGE_HORIZONTAL')
    ));
    $form[] = '</div>'; 

    $form[] = NgeFields::colorcmyk($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_COLOR','#FFFFFF');
    $form[] = NgeFields::colorcmyk($objectPrefix . 'color2','COM_NGE_COLOR_LAST','COM_NGE_DESCRIPTION_COLOR_LAST','#ffffff');
    $form[] = NgeFields::slider($objectPrefix . 'opacity','COM_NGE_OPACITY','COM_NGE_DESCRIPTION_BACKGROUND_OPACITY','100', 'min="0" max="100"step="1"');
                
    return implode($form);    
}

function chartPrintSeriesDefaultLabelsShadow($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::radio($objectPrefix . 'style','COM_NGE_STYLE','COM_NGE_DESCRIPTION_BACKGROUND_STYLE','none', array(
        array('none','COM_NGE_NONE', 'data-success="false"'),
        array('custom','COM_NGE_CUSTOM','data-target="#'.str_replace('.', '_', $objectPrefix).'_shadow"')
    ));        

    $form[] = '<div id="'.str_replace('.', '_', $objectPrefix).'_shadow">';     
    $form[] = NgeFields::slider($objectPrefix . 'offset_x','COM_NGECHARTS_OFFSETX','COM_NGE_DESCRIPTION_SHADOW_OFFSETX','0', 'min="-50" max="50" step="0.5" suffix="mm"');
    $form[] = NgeFields::slider($objectPrefix . 'offset_y','COM_NGECHARTS_OFFSETY','COM_NGE_DESCRIPTION_SHADOW_OFFSETY','0', 'min="-50" max="50" step="0.5" suffix="mm"');
    $form[] = NgeFields::colorcmyk($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_COLOR','#000000');
    $form[] = NgeFields::slider($objectPrefix . 'opacity','COM_NGE_OPACITY','COM_NGE_DESCRIPTION_BACKGROUND_OPACITY','15', 'min="0" max="100"step="1"');    
    $form[] = '</div>'; 

    return implode($form);    
}

function chartPrintSeriesDefaultTooltipsDisplay($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

        // horizontal align
    $form[] = NgeFields::radio($objectPrefix . 'animation', 'COM_NGE_TEXT_ANIMATION', 'COM_NGE_DESCRIPTION_TEXT_ALIGN', '1');
    
    $form[] = NgeFields::radio($objectPrefix .'shape', 'COM_NGE_SHAPE', 'COM_NGE_DESCRIPTION_TYPE', 'callout', array(
	    array('callout', 'COM_NGECHARTS_CALLOUT'),
	    array('square', 'COM_NGE_SQUARE'),	    
	    array('circle', 'COM_NGE_CIRCLE')
	    ));
        
    $form[] = NgeFields::slider($objectPrefix . 'padding','COM_NGE_PADDING','COM_NGE_DESCRIPTION_MARGIN','2', 'min="0" max="5" step="0.1" suffix="mm"');
    
    return implode($form);    
}

function chartPrintSeriesDefaultTooltipsFont($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::font($objectPrefix .'name', 'COM_NGE_FONT_NAME', 'COM_NGE_DESCRIPTION_FONT_NAME');
    $form[] = NgeFields::slider($objectPrefix .'size', 'COM_NGE_FONT_SIZE', 'COM_NGE_DESCRIPTION_FONT_SIZE_PT', '6', 'min="0" max="36" step="0.5" suffix="pt"');
	$form[] = NgeFields::radio($objectPrefix .'weight', 'COM_NGE_FONT_WEIGHT', 'COM_NGE_DESCRIPTION_FONT_WEIGHT', 'bold', array(
	    array('lighter', 'COM_NGE_FONT_WEIGHT_LIGHTER'),
	    array('normal', 'COM_NGE_FONT_WEIGHT_NORMAL'),
	    array('bold', 'COM_NGE_FONT_WEIGHT_BOLD'),
	    array('bolder', 'COM_NGE_FONT_WEIGHT_BOLDER')
	    ));
    $form[] = NgeFields::colorcmyk($objectPrefix .'color', 'COM_NGE_FONT_COLOR', 'COM_NGE_DESCRIPTION_FONT_COLOR', '#333333');
    return implode($form);    
}
function chartPrintSeriesDefaultTooltipsBorder($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();
    
    $form[] = NgeFields::radio($objectPrefix . 'display', 'COM_NGE_DISPLAY', '', '1',array(
    	array('1', 'JYES','data-target="#chart_tooltips_border_options"'),
    	array('0', 'JNO','data-success="false"')
    	));      
    $form[] = '<div id="chart_tooltips_border_options">';
    $form[] = NgeFields::slider($objectPrefix . 'width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_BORDER_WIDTH','0.2', 'min="0.1" max="5" step="0.1" suffix="pt"');
        $form[] = NgeFields::radio($objectPrefix . 'color.style','COM_NGE_COLOR','COM_NGE_DESCRIPTION_BACKGROUND_STYLE','default', array(
        array('default','COM_NGE_SERIE'),
        array('custom','COM_NGE_CUSTOM','data-target="field:value"')
    ));

    $form[] = NgeFields::colorcmyk($objectPrefix . 'color.value','COM_NGE_COLOR','COM_NGE_DESCRIPTION_BORDER_COLOR','#CCCCCC');
    $form[] = NgeFields::slider($objectPrefix . 'radius','COM_NGE_RADIUS','COM_NGE_DESCRIPTION_RADIUS','1', 'min="0" max="20" step="0.1" suffix="mm"');    

    $form[] = '</div>';
        
    return implode($form);    
}
function chartPrintSeriesDefaultTooltipsBackground($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::radio($objectPrefix . 'style','COM_NGE_STYLE','COM_NGE_DESCRIPTION_BACKGROUND_STYLE','solid', array(
        array('none','COM_NGE_NONE', 'data-success="false"'),
        array('solid','COM_NGE_BACKGROUND_SOLID','data-target="field:color field:color_hover field:opacity field:background[overflow][direction] #'.str_replace('.', '_', $objectPrefix).'_effects"'),
        array('gradient','COM_NGE_BACKGROUND_GRADIENT','data-target="#'.str_replace('.', '_', $objectPrefix).'_direction field:color field:color2 field:color_hover field:color_hover2 field:opacity field:background[overflow][direction] #'.str_replace('.', '_', $objectPrefix).'_effects"')
    ));

    // background direction    
    $form[] = '<div id="'.str_replace('.', '_', $objectPrefix).'_direction">'; 
    $form[] = NgeFields::radio($objectPrefix . 'direction','COM_NGE_BACKGROUND_GRADIENT_DIRECTION','COM_NGE_DESCRIPTION_BACKGROUND_DIRECTION','vertical', array(
        array('vertical','COM_NGE_VERTICAL'), 
        array('horizontal','COM_NGE_HORIZONTAL')
    ));
    $form[] = '</div>'; 

    $form[] = NgeFields::colorcmyk($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_COLOR','#F9F9F9');
    $form[] = NgeFields::colorcmyk($objectPrefix . 'color2','COM_NGE_COLOR_LAST','COM_NGE_DESCRIPTION_COLOR_LAST','#ffffff');
    $form[] = NgeFields::slider($objectPrefix . 'opacity','COM_NGE_OPACITY','COM_NGE_DESCRIPTION_BACKGROUND_OPACITY','85', 'min="0" max="100"step="1"');
                
    return implode($form);    
}

function chartPrintSeriesDefaultTooltipsShadow($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::radio($objectPrefix . 'style','COM_NGE_STYLE','COM_NGE_DESCRIPTION_BACKGROUND_STYLE','default', array(
        array('none','COM_NGE_NONE', 'data-success="false"'),
        array('custom','COM_NGE_CUSTOM','data-target="#'.str_replace('.', '_', $objectPrefix).'_shadow"')
    ));        

    $form[] = '<div id="'.str_replace('.', '_', $objectPrefix).'_shadow">';     
    $form[] = NgeFields::slider($objectPrefix . 'offset_x','COM_NGECHARTS_OFFSETX','COM_NGE_DESCRIPTION_SHADOW_OFFSETX','0', 'min="-50" max="50" step="0.5" suffix="mm"');
    $form[] = NgeFields::slider($objectPrefix . 'offset_y','COM_NGECHARTS_OFFSETY','COM_NGE_DESCRIPTION_SHADOW_OFFSETY','0', 'min="-50" max="50" step="0.5" suffix="mm"');    
    $form[] = NgeFields::colorcmyk($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_COLOR','#000000');
    $form[] = NgeFields::slider($objectPrefix . 'opacity','COM_NGE_OPACITY','COM_NGE_DESCRIPTION_BACKGROUND_OPACITY','15', 'min="0" max="100"step="1"');    
    $form[] = '</div>'; 

    return implode($form);    
}

function chartPrintSeriesDefaultShadow($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();
    
    $form[] = NgeFields::radio($objectPrefix . 'style','COM_NGE_STYLE','COM_NGE_DESCRIPTION_BACKGROUND_STYLE','none', array(
        array('none','COM_NGE_NONE', 'data-success="false"'),
        array('custom','COM_NGE_CUSTOM','data-target="#'.str_replace('.', '_', $objectPrefix).'_shadow"')
    ));        

    $form[] = '<div id="'.str_replace('.', '_', $objectPrefix).'_shadow">';     
    $form[] = NgeFields::slider($objectPrefix . 'offset_x','COM_NGECHARTS_OFFSETX','COM_NGE_DESCRIPTION_SHADOW_OFFSETX','0', 'min="-50" max="50" step="0.5" suffix="mm"');
    $form[] = NgeFields::slider($objectPrefix . 'offset_y','COM_NGECHARTS_OFFSETY','COM_NGE_DESCRIPTION_SHADOW_OFFSETY','0', 'min="-50" max="50" step="0.5" suffix="mm"');    
    $form[] = NgeFields::slider($objectPrefix . 'width','COM_NGE_WIDTH','COM_NGE_DESCRIPTION_BORDER_WIDTH','3', 'min="0.1" max="20  "step="0.1" suffix="mm"');
    $form[] = NgeFields::colorcmyk($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_COLOR','#000000');
    $form[] = NgeFields::slider($objectPrefix . 'opacity','COM_NGE_OPACITY','COM_NGE_DESCRIPTION_BACKGROUND_OPACITY','15', 'min="0" max="100" step="1"');    
    $form[] = '</div>'; 
                
    return implode($form);
    
}


function chartPrintSeriesSeries($objectPrefix, $multiple=false, $multipleIndex=0) {
    $objectPrefix = (isset($objectPrefix) && $objectPrefix != "") ? $objectPrefix . '.' : "";
    $form=array();

    $form[] = NgeFields::radio($objectPrefix .'type', 'COM_NGE_TYPE', 'COM_NGE_DESCRIPTION_TYPE', 'line', array(
	    array('area', 'COM_NGE_CHART_TYPE_AREA'),
	    array('areaspline', 'COM_NGE_CHART_TYPE_AREASPLINE'),
	    array('bar', 'COM_NGE_CHART_TYPE_BAR'),
	    array('bubble', 'COM_NGE_CHART_TYPE_BUBBLE'),
	    array('column', 'COM_NGE_CHART_TYPE_COLUMN'),
	    array('errorbar', 'COM_NGE_CHART_TYPE_ERRORBAR'),
	    array('funnel', 'COM_NGE_CHART_TYPE_FUNNEL'),
	    array('gauge', 'COM_NGE_CHART_TYPE_GAUGE'),
	    array('heatmap', 'COM_NGE_CHART_TYPE_HEATMAP'),
	    array('line', 'COM_NGE_CHART_TYPE_LINE'),
	    array('pie', 'COM_NGE_CHART_TYPE_PIE'),
	    array('polygon', 'COM_NGE_CHART_TYPE_POLYGON'),
	    array('pyramid', 'COM_NGE_CHART_TYPE_PYRAMID'),
	    array('scatter', 'COM_NGE_CHART_TYPE_SCATTER'),
	    array('solidgauge', 'COM_NGE_CHART_TYPE_SOLIDGAUGE'),
	    array('spline', 'COM_NGE_CHART_TYPE_SPLINE'),
	    array('treemap', 'COM_NGE_CHART_TYPE_TREEMAP'),
	    array('waterfall', 'COM_NGE_FONT_WEIGHT_WATERFALL')
	    ));

    $form[] = NgeFields::colorcmyk($objectPrefix . 'color','COM_NGE_COLOR','COM_NGE_DESCRIPTION_BORDER_COLOR','#cccccc');
    
    return implode($form);
    
}

