<?php

/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */
defined('_JEXEC') or die;

define('NGEPATH_NGE', JPATH_SITE . '/components/com_nge');
define('NGEPATH_HELPERS', JPATH_SITE . '/components/com_nge/helpers');
define('NGEPATH_CLASSES', JPATH_SITE . '/components/com_nge/classes');
define('NGEPATH_PARTS', JPATH_SITE . '/components/com_nge/parts');
define('NGEPATH_ITEMS', JPATH_SITE . '/components/com_nge/items');
define('NGEPATH_CONTENTS', JPATH_SITE . '/components/com_nge/contents');
define('NGEPATH_LAYOUTS', JPATH_SITE . '/layouts/nge');
define('NGEPATH_MEDIA', JPATH_SITE . '/media/com_nge');
define('NGEPATH_LIBRARIES', JPATH_SITE . '/media/com_nge');
define('NGEPATH_ASSETS', JPATH_SITE . '/components/com_nge/assets');

define ('NGEURL_ROOT', JUri::root()); //Absolute root url
define ('NGEURL_BASE', JUri::base()); //Relative root url, for front or backoffice
define ('NGEURL_TASKS', NGEURL_ROOT . 'index.php?option=com_nge');
define ('NGEURL_VIEWS', NGEURL_ROOT . 'index.php?option=com_nge');
define ('NGEURL_ASSETS', NGEURL_ROOT . 'components/com_nge/assets/');
define ('NGEURL_MEDIA', NGEURL_ROOT . 'media/com_nge/');
define('NGEURL_HELPERS', NGEURL_ROOT . 'components/com_nge/helpers/');

define('NGECOLORS_NGE_HEADER', "#555D83");
define('NGECOLORS_NGE_BAR', "#646D9C");
define('NGECOLORS_NGE_ACTIVE', "#8B92B3");

define('NGECOLORS_MEDIA_HEADER', "#C2185B");
define('NGECOLORS_MEDIA_BAR', "#E91E63");

define('NGECOLORS_MODULE_HEADER', "#F77");
define('NGECOLORS_MODULE_BAR', "#FF9191");

require_once NGEPATH_CLASSES . '/ngecontent.php';


//todo NGEPATH_MEDIA to change towards NGEPATH_LIBRARIES


/**
 * class Nge
 * @author Alexandre Froger
 *
 */
class NGE {

    private static $_user = null;
    private static $_params = null;
    private static $_document = null;
    private static $_version = null;
    private static $_versionAlpha = null;
    private static $_versionBeta = null;
    private static $_cache = null;
	
    private static $_urls = null;    

    private static $_time_elapsed_last = null;
    private static $_time_elapsed_start = null;
    

	/**
	 * 
	 * @param string $name
	 * @return \className
	 * Used to display part in API mode
	 * $partTable = NGE::part('tables.table');
	//$partTable->loadPart($part);
	$partTable->content->source = "data";
	$partTable->content->data = $articles;
	$partTable->navigation->paging->display = "0";
	$partTable->navigation->searching = "1";
	$partTable->navigation->ordering = "1";
	$partTable->navigation->resizing = "1";
	$partTable->navigation->info = "1";
	$result .= $partTable->render();
	 */
	public static function part($name) {
		
		$partpath = explode('.', $name);
		$directories = '';
		$className = 'NgePart';
		$name = "";
		for ($i=0; $i<count($partpath); $i++) {
			$directories .= $partpath[$i].'/';
			$className .= ucfirst($partpath[$i]);
		}

		$filename = NGEPATH_HELPERS . '/api/part/'.$directories.$partpath[count($partpath)-1].'.php';
		
		try{
			require_once($filename);
			return new $className();
		}
		catch (Exception $e)
		{
			JError::raiseError(500, 'Class '.$className. ' not found in '. filename);
		}
			
	}

	public static function item($name) {

		$partpath = explode('.', $name);
		$directories = '';
		$className = 'NgeItem';
		$name = "";
		for ($i=0; $i<count($partpath); $i++) {
			$directories .= $partpath[$i].'/';
			$className .= ucfirst($partpath[$i]);
		}

		$filename = NGEPATH_HELPERS . '/api/item/'.$directories.$partpath[count($partpath)-1].'.php';

		try{
			require_once($filename);
			return new $className();
		}
		catch (Exception $e)
		{
			JError::raiseError(500, 'Class '.$className. ' not found in '. filename);
		}
			
	}

	/**
	 * 
	 * @param type $id
	 * @return type
	 * Direct rendering for an existing part id
	 */	
	public static function renderPart($id) {
		
		try{
		    require_once NGEPATH_HELPERS . '/ngeparts.php';
		    return NGEParts::render($id);
		}
		catch (Exception $e)
		{
			JError::raiseError(500, 'Part '.$id. ' not found');
		}			
	}
	
	/**
	 * 
	 * @param type $name
	 * @return type
	 * wether feature by name is allowed
	 */	
	public static function features($name) {
		
		try{
		    require_once NGEPATH_HELPERS . '/ngefeatures.php';
		    return NgeFeatures::enabled($name);
		}
		catch (Exception $e)
		{
			JError::raiseError(500, 'Feature  '.$name. ' not found');
		}			
	}
	
/**
	 * 
	 * @param type $name
	 * @return type
	 * wether feature by name is allowed
	 */	
	public static function package() {
		
		try{
		    require_once NGEPATH_HELPERS . '/ngefeatures.php';
		    return NgeFeatures::package();
		}
		catch (Exception $e)
		{
			JError::raiseError(500, 'Package not found');
		}			
	}
	
	
	/* Calling main editor class for displaying html, css and scripts to do front editing */
	public static function editor(){
	    require_once JPATH_SITE . '/plugins/content/nge_content/nge/editor.php';
	    return new NgeEditor();
	}
	
	
	public static function layout($name, $data) {
	    return JLayoutHelper::render($name, $data);
	    /*$displayData = $data;
	    $path = str_replace('.', '/', $name);
	    ob_start();
	    include (NGEPATH_LAYOUTSROOT . '/' . $path . '.php');
	    $result = ob_get_contents();
	    ob_clean();
	    return $result;*/
	}
	
	public static function translate($text){
	    return JText::_($text);
	}
	
/*	public static function url($name){
	    self::$_urls = array();
	    self::$_urls['root'] = '/'; //JUri::root();
	    return self::$_urls[$name];
	}*/
	public static function url($name){
	    self::$_urls = array();
	    self::$_urls['root'] = JUri::root();
	    return self::$_urls[$name];
	}
	
	
	public static function path($name){
	    self::$_paths = array();
	    self::$_parts['root'] = '';
	    return self::$_paths[$name];
	}
	
	
    public static function document() {
	if (self::$_document == null) {
	    self::$_document = JFactory::getDocument();
	}

	return self::$_document;
    }

    public static function user() {
	if (self::$_user == null) {
	    self::$_user = JFactory::getUser();
	    self::$_user->canManageModules = (self::$_user->authorise('core.create', 'com_modules') || self::$_user->authorise('core.edit', 'com_modules') || self::$_user->authorise('core.delete', 'com_modules'));
	    self::$_user->canManageMenus = (self::$_user->authorise('core.create', 'com_menus') || self::$_user->authorise('core.edit', 'com_menus') || self::$_user->authorise('core.delete', 'com_menus'));
	    self::$_user->canManageContent = (self::$_user->authorise('core.create', 'com_content') || self::$_user->authorise('core.edit', 'com_content') || self::$_user->authorise('core.delete', 'com_content'));
	}
	return self::$_user;
    }

    /*
    public static function params() {
		if (self::$_params == null) {
		    $_params = new Stdclass();
		    $_params->isPartExist = false;
		    $_params->frontEditing = JComponentHelper::getParams('com_nge')->get('front-editing', true);
		    $_params->minifyOutput = JComponentHelper::getParams('com_nge')->get('output_minify', true);
		    
		    self::$_params = $_params;
		}

		return self::$_params;
    }     
     */
    
    public static function params($name, $default){
	if (self::$_params == null)
		    self::$_params = array();
	//Caching params
	if (!isset(self::$_params[$name])) {
	    $paramsNextGenEditor= JComponentHelper::getParams('com_nge');
	    self::$_params[$name] = $paramsNextGenEditor->get($name, $default);	    
	}
	return self::$_params[$name];
    }
    
    

        public static function version() {

            if (self::$_version == null) {
                $db = JFactory::getDbo();
                $query = $db->getQuery(true)
                ->select('sc.version_id')
                ->from($db->quoteName('#__extensions', 'ex'))
                ->join('LEFT', $db->quoteName('#__schemas', 'sc') . ' ON (' . $db->quoteName('ex.extension_id') . ' = ' . $db->quoteName('sc.extension_id') . ')')
                ->where($db->quoteName('ex.name') . ' LIKE \'com_nge\'');
                $db->setQuery($query);
                $result = $db->loadResult();

                self::$_version = $result;
            }

            return self::$_version;
        }

    public static function isVersionAlpha() {
    	if (self::$_versionAlpha == null) {
    	    $db = JFactory::getDbo();
    
    		// Set the query and get the result list.
    		//$db->setQuery('SELECT id, title, params FROM #__nge_parts_patterns WHERE part = "'.$this->getAttribute("part").'"');
    		$query = $db->getQuery(true)
    		//->select('l.part, l.default_params as params')
    		->select('name')
    		->from('#__nge_plugins')
    		->where('name = "alpha"')
    		->where('type = "core"');
    		$db->setQuery($query);
    		$data = $db->loadObject();
    		self::$_versionAlpha = isset($data);
    	    //self::$_versionBeta = false;
    	}
    
    	return self::$_versionAlpha;
    }


        public static function isVersionBeta() {
	if (self::$_versionBeta == null) {
	    $db = JFactory::getDbo();

		// Set the query and get the result list.
		//$db->setQuery('SELECT id, title, params FROM #__nge_parts_patterns WHERE part = "'.$this->getAttribute("part").'"');
		$query = $db->getQuery(true)
		//->select('l.part, l.default_params as params')
		->select('name')
		->from('#__nge_plugins')
		->where('name = "beta"')
		->where('type = "core"');
		$db->setQuery($query);
		$data = $db->loadObject();
		self::$_versionBeta = isset($data);
	    //self::$_versionBeta = false;
	}

	return self::$_versionBeta;
    }

    /*
     * get a session token for ajax security
     */
    public static function token() {
	$session = JFactory::getSession();
	return $session->getFormToken();
    }
    
    /*
     * get a hidden input with session token for ajax security
     */
    public static function tokenInput() {
	$session = JFactory::getSession();
	$token = $session->getFormToken();
	return JHtml::_('form.token');
    }
    
    /*
     * Merge arrays properties
     */

    static function array_merge_recursive_replace() {

	$arrays = func_get_args();
	$base = array_shift($arrays);
	if (isset($base)) {
	    foreach ($arrays as $array) {
		reset($base);
		while (list($key, $value) = @each($array)) {
		    if (is_array($value) && @is_array($base[$key])) {
			//If sequential array => reset, for example border placements are sequential array, if not all default values are keeped
			if (!(array_values($base[$key]) !== $base[$key])) //Sequential
			    $base[$key] = array();
			$base[$key] = self::array_merge_recursive_replace($base[$key], $value);
		    } else {
			$base[$key] = $value;
		    }
		}
	    }
	}
	return $base;
    }

    /*
     * recursive_array_search()
     * Used to find all key who contains specific value.
     * @params String $needle, String to find in the array
     * @params Array $haystack, Array where the values are
     * @params Array $keyArrayJson, return value if key exist 
     * @return $keyArrayJson array of key or false is no key exist
     */
    static function recursive_array_search($needle,$haystack,$keyArrayJson=array()) {
        $ret = false;

        foreach($haystack as $key=>$value) {
            $current_key = $key;

            if((is_array($value) && self::recursive_array_search($needle,$value) !== false) || (!is_array($value) && strpos($value, $needle) !== false)) {
                $keyArrayJson[] = $current_key;
                $ret = true;
            }
        }

        if($ret === false){
            return false;
        }else{
            return $keyArrayJson;   
        }
    }
    
    /*
     * recursive_array_load_preset()
     * If preset key exist load pattern with presetId and set preset to '' when return pattern properties
     * @params Array $array Array where the values are
     * @return Array $array_modified
     */
    static function array_load_preset($array) {
        require_once NGEPATH_HELPERS . '/data/nge/patterndriver.php';
        $ret = false;

        if(isset($array['options'])){
            if(isset($array['options']['preset']) && $array['options']['preset'] !== ""){ // Specific for general options
                $pattern = NgePatternDriver::load($array['options']['preset']);
                //Main data : params of the part 
                if(isset($pattern->params)){
                    $paramsObject = json_decode($pattern->params, true);
                    $paramsArray = NGE::array_merge_recursive_replace($paramsObject, $array);

                    $array = $paramsArray;
                    $array['options']['preset'] = "";
                    $ret = true;
                }
            }

            //Remove current options temporary
            $tmp_options = $array['options'];
            $tmp_array = $array;
            unset($array['options']);
        }

        $array_preset = self::recursive_array_load_preset($array);
        
        if($array_preset !== false){
            if(isset($tmp_options)){
                $array_preset["options"] = $tmp_options;
            }
            $ret = true;
        }else{
            if(isset($tmp_array) && $ret === true){
                $array_preset = $tmp_array;
            }
        }
        
        if($ret === false){
            return false;
        }else{
            return $array_preset;
        }
    }
    
    static function recursive_array_load_preset($array) {
        require_once NGEPATH_HELPERS . '/data/nge/patterndriver.php';
        $ret = false;
        
        foreach($array as $key => $value) {
            $current_key = $key;
            
            if($current_key === "preset" && $array[$current_key] !== ""){ 
                $pattern = NgePatternDriver::load($array[$current_key]);
                
                if(isset($pattern->params)){
                    //Main data : params of the part 
                    $paramsObject = json_decode($pattern->params, true);

                    $paramsArray = NGE::array_merge_recursive_replace($paramsObject, $array);
                    $array = $paramsArray;
                    $array[$current_key] = "";
                    $ret = true;
                }
            }else{
                if(is_array($value)){
                    $recursive_array = self::recursive_array_load_preset($value,$current_key);
                    if($recursive_array !== false){
                      $array[$current_key] = $recursive_array;
                      $ret = true;
                    }
                }
            }
        }

        if($ret === false){
            return false;
        }else{
            return $array;
        }
    }
	//From Joomla. Moved in 3.8    
	/**
	 * Method to extract key/value pairs out of a string with XML style attributes
	 *
	 * @param   string  $string  String containing XML style attributes
	 *
	 * @return  array  Key/Value pairs for the attributes
	 *
	 * @since   11.1
	 */
	public static function parseAttributes($string)
	{
		$attr = array();
		$retarray = array();

		// Let's grab all the key/value pairs using a regular expression
		preg_match_all('/([\w:-]+)[\s]?=[\s]?"([^"]*)"/i', $string, $attr);

		if (is_array($attr))
		{
			$numPairs = count($attr[1]);

			for ($i = 0; $i < $numPairs; $i++)
			{
				$retarray[$attr[1][$i]] = $attr[2][$i];
			}
		}

		return $retarray;
	}    
    
    /*
     * decode_json_string()
     * Used to decode all json string in the current object.
     * @params String $object
     * @return $object with decode json string
     */
    static function decode_json_string($object, $keyArrayJson) {    
        foreach($keyArrayJson as $key) {
            if (isset($object[$key])){
                if(is_array($object[$key])){
                    $keyArrayJsonRecursive = NGE::recursive_array_search('ngejson::',$object[$key]);
                }else{
                    $keyArrayJsonRecursive = false;
                }
                
                if($keyArrayJsonRecursive !== false){/*If value with json object string exist*/
                    $object[$key] = NGE::decode_json_string($object[$key], $keyArrayJsonRecursive);
                }else{
                    $value_without_json = str_replace("ngejson::", "", $object[$key]);
                    $object[$key] = json_decode($value_without_json);
                }
            }
        }
        
        return $object;
    }

 /**
 * Create script tag in the document for loading js resource in the media directory
 * @param type $path
 * @param type $async
 */
    public static function loadMediaScript($path, $async = false) {
	self::document()->addScript(Juri::root() . 'media/com_nge/'.$path, 'text/javascript', false, $async);
    }
    /**
 * Create script tag in the document for loading js resource in the helpers directory
 * @param type $path
 * @param type $async
 */
    public static function loadHelpersScript($path, $async = false) {
	self::document()->addScript(Juri::root() . 'components/com_nge/helpers/'.$path, 'text/javascript', false, $async);
    }
    public static function loadMediaCss($path, $async = true) {
	self::document()->addScript(Juri::root() . 'media/com_nge/'.$path, 'text/javascript', false, $async);
    }

    public static function loadHelpersCss($path, $async = true) {
	self::document()->addScript(Juri::root() . 'components/com_nge/helpers/'.$path, 'text/javascript', false, $async);
    }

	public static function minify($content) {
  		/*$content = preg_replace('!/\*[^*]*\*+([^/][^*]*     \       *+)*                    /!', '', $content); //Comments 
                             $content = preg_replace("/\t/", " ", $content); //tabs
  		$content = strtr($content, ': ', ':'); //spaces in css
  		$content = str_replace(array("\r\n", "\r", "\n", "\t"), '', $content); //End of lines
  		$content = str_replace(array('  ', '    ', '    '), ' ', $content); //more than one space
		*/		
				/* require_once NGEPATH_MEDIA . '/jshrink/minifier.php';
				$content = \JShrink\Minifier::minify($content);*/
		return $content;		
	}	
	
	public static function message($msg, $type){
	JFactory::getApplication()->enqueueMessage($msg, $type);  //'message', 'notice', 'warning', 'error'  default ='message'
	}
	
	public static function loadCache($cacheId){
		if (self::$_cache == null){
			self::$_cache = JFactory::getCache('com_nge', '');
			self::$_cache->setCaching(true);
			self::$_cache->setLifeTime(8640000); //100 days
		}	
		return self::$_cache->get($cacheId);
	}
	
	public static function storeCache($content, $cacheId, $minify=true){
		if (self::$_cache == null){
			self::$_cache = JFactory::getCache('com_nge', '');
			self::$_cache->setCaching(true);
			self::$_cache->setLifeTime(8640000); //100 days
		}	
		
		return self::$_cache->store($minify ? self::minify($content) : $content, $cacheId);
	}
	
	public static function time_elapsed($comment) 
	    {

	    // $unit="s"; $scale=1000000; // output in seconds
	    // $unit="ms"; $scale=1000; // output in milliseconds
	    $unit="s"; $scale=1000000; // output in microseconds

	    $now = microtime(true);

	    if (self::$_time_elapsed_last != null) {
		echo "\n";
//		echo '<!-- ';
		echo "$comment: Time elapsed: ";
		echo round(($now - self::$_time_elapsed_last)*1000000)/$scale;
		echo " $unit, total time: ";
		echo round(($now - self::$_time_elapsed_start)*1000000)/$scale;
//		echo " $unit -->";
		echo "\n";
	    } else {
		self::$_time_elapsed_start=$now;
	    }

	    self::$_time_elapsed_last = $now;
	}         
	
}
