<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */
 
// no direct access
defined('_JEXEC') or die;
	
?>
<?php 
$data = $displayData;
$html = array();
$style = array();
$script = array();

require_once (NGEPATH_HELPERS . '/data/joomla/menudriver.php');
$menu = NgeJoomlaMenuDriver::load($data->content->menutype, (int)$data->content->showallchildren);

$buttonLabel = $data->content->label;
//Attributes
$class = array();
$class[] = 'btn-group';
$class[] = $data->position == 'dropup' ? 	'dropup' : '';

        //Part display options
            $style[] = NGE::layout('nge.parts.parts.display_style', $data);
            $class[] = NGE::layout('nge.parts.parts.display_class', $data);

$attributes = array();
$attributes[] = ' id="part-'.$data->id.'"';
$attributes[] = ' class="'.implode(' ', $class).'"';

$class_a = array();
$class_a[] = "btn dropdown-toggle";
$class_a[] = $data->button->theme == 'default' ? "" : ' btn-'.$data->button->theme;
$class_a[] = $data->button->size != '' ? ' '.$data->button->size : '';


//Button CSS
$dataCss = $data->button;
$dataCss->selector = '#part-'.$data->id.' >a';
$style[] = NGE::layout('nge.parts.navigation.button_css', $dataCss);

//Font CSS
if($data->button->font->style == 'custom'){
	$dataFont = $data->font;
	$dataFont->selector = '#part-'.$data->id.' >a';
	$style[] = NGE::layout('nge.parts.text.css.font_css', $dataFont);
}

///***** DROPDOWN CSS & JS *****/
//Dropdown panel background
$dataPanelBackground = $data->dropdown->background;
$dataPanelBackground->selector = '#part-'.$data->id.' ul.dropdown-menu';
$style[] = NGE::layout('nge.parts.panels.css.background_css', $dataPanelBackground);
$style[] = "#part-".$data->id." ul.dropdown-menu {overflow: hidden;}";

//Dropdown panel background link hover
if(isset($data->dropdown->background)){
	if(($data->dropdown->background->style != "") && ($data->dropdown->background->style != "none")){
		$style[] = "#part-".$data->id." ul.dropdown-menu li a:hover,  #part-".$data->id." ul.dropdown-menu li a:focus{
				background-color: ".$data->dropdown->background->color_hover.";
				background-image:none;
		}";
	}
}
//Dropdown panel Shadow
if(isset($data->dropdown->shadow)){
	$dataPanelShadow = $data->dropdown->shadow;
	$dataPanelShadow->selector = '#part-'.$data->id.' ul.dropdown-menu';
	$style[] = NGE::layout('nge.parts.panels.css.shadow_css', $dataPanelShadow);
}

//Dropdown panel Border
if(isset($data->dropdown->border)){
	$dataPanelBorder = $data->dropdown->border;
	$dataPanelBorder->selector = '#part-'.$data->id.' ul.dropdown-menu';
	$style[] = NGE::layout('nge.parts.panels.css.border_css', $dataPanelBorder);
}

//Dropdown panel font CSS
if(isset($data->dropdown->font) && ($data->dropdown->font->style == 'custom')){
	$dataPanelFont = $data->dropdown->font;
	$dataPanelFont->selector = '#part-'.$data->id.' ul.dropdown-menu li a';
	$style[] = NGE::layout('nge.parts.text.css.font_css', $dataPanelFont);
}


$html[] = '<div '.implode($attributes).'>';
$html[] = '<a class="'.implode($class_a).'" data-toggle="dropdown" href="#">';
$html[] =  $buttonLabel;
$html[] = '<span class="caret"></span>';
$html[] = '</a>';
$html[] = '<ul class="dropdown-menu">';

foreach ($menu->items as $i => &$item)
{
            $classItem = '';
	//Link target JS
	$data->selector = '#item-'.$item->id.' > a';
	$data->url = "href";
	$data->type = "url";
	$script[] = NGE::layout('nge.parts.panels.js.button_js', $data);
		
	//TODOif ($item->id == $active_id)
	//	$class .= ' current';

	if (in_array($item->id, $menu->path))
		$classItem .= ' active';
	elseif ($item->type == 'alias')
	{
		$aliasToId = $item->params->get('aliasoptions');

		if (count($path) > 0 && $aliasToId == $path[count($path) - 1])
		{
			$classItem .= ' active';
		}
		elseif (in_array($aliasToId, $menu->path))
		{
			$classItem .= ' alias-parent-active';
		}
	}

	if ($item->type == 'separator')
		$classItem .= ' divider';

	if ($item->deeper)
		$classItem .= ' dropdown-submenu';

	if ($item->parent)
		$classItem .= ' parent';

	if (!empty($classItem))
		$classItem = ' class="' . trim($classItem) . '"';

	$html[] = '<li id="item-' . $item->id .'" ' . $classItem . '>';
	// Render the menu item.
	switch ($item->type) :
		case 'separator':
		case 'url':
		case 'component':
		case 'heading':
			ob_start();
			require JModuleHelper::getLayoutPath('mod_menu', 'default_' . $item->type);
			$html[] = ob_get_clean();			
			break;
		default:
			ob_start();			
			require JModuleHelper::getLayoutPath('mod_menu', 'default_url');
			$html[] = ob_get_clean();			
			break;
	endswitch;

	// The next item is deeper.
	if ($item->deeper)
		$html[] = '<ul class="dropdown-menu">';
	elseif ($item->shallower)
	{
		// The next item is shallower.
		$html[] = '</li>';
		$html[] = str_repeat('</ul></li>', $item->level_diff);
	}
	else
	{
		// The next item is on the same level.
		$html[] = '</li>';
	}
}

$html[] = '</ul>';
$html[] = '</div>';

//Rendering
if (count($style) != 0)
	echo '<style>'.implode($style).'</style>';

echo implode($html);

if (count($script) != 0)
	echo '<script>'.implode($script).'</script>';
