<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */
 
// no direct access
defined('_JEXEC') or die;
	
?>
<?php 
$data = $displayData;

require_once (NGEPATH_HELPERS . '/data/joomla/menudriver.php');
$menu = NgeJoomlaMenuDriver::load($data->menutype, $data->showallchilds);

$buttonLabel = 'Menu';

//Attributes
$class = array();
$class[] = 'btn-group';
$class[] = $data->position == 'dropup' ? 	' dropup' : '';
$class[] = $data->size->type == 'bootstrap' ? 	' '.NgeBootstrapTag::_( 'col-md-'. $data->part_size_bootstrap).' '.NgeBootstrapTag::_( 'col-md-offset-'. $data->part_offset_bootstrap) : '';
$class[] = isset($displayData->display_phone) && ($displayData->display_phone == 0) ? 				' '.NgeBootstrapTag::_( 'hidden-xs' ) : '';
$class[] = isset($displayData->display_tablet) && ($displayData->display_tablet == 0) ? 			' '.NgeBootstrapTag::_( 'hidden-sm' ) : '';
$class[] = isset($displayData->display_desktop) && ($displayData->display_desktop == 0) ? 			' '.NgeBootstrapTag::_( 'hidden-md' ) : '';
$class[] = isset($displayData->display_largedesktop) && ($displayData->display_largedesktop == 0) ?	' '.NgeBootstrapTag::_( 'hidden-lg' ) : '';
$class[] = isset($displayData->display_printer) && ($displayData->display_printer == 0) ? 			' hidden-print' : '';

$attributes = array();
$attributes[] = ' id="part-'.$data->id.'"';
$attributes[] = ' class="'.implode($class).'"';
$attributes[] =  $data->size->type == 'css' ? ' style="width:'.$data->size->css.';"' : '';

$class_a = array();
$class_a[] = "btn dropdown-toggle";
$class_a[] = $data->theme == 'btn-default' ? "" : ' '.$data->theme;
$class_a[] = $data->size != '' ? ' '.$data->size : '';
?>

<div <?php echo implode($attributes); ?>>
  <a class="<?php echo implode($class_a); ?>" data-toggle="dropdown" href="#">
    <?php echo $buttonLabel; ?>
    <span class="caret"></span>
  </a>
<ul class="dropdown-menu">
<?php
foreach ($menu->items as $i => &$item)
{
	$class = 'item-' . $item->id;

	if ($item->id == $active_id)
	{
		$class .= ' current';
	}

	if (in_array($item->id, $menu->path))
	{
		$class .= ' active';
	}
	elseif ($item->type == 'alias')
	{
		$aliasToId = $item->params->get('aliasoptions');

		if (count($path) > 0 && $aliasToId == $path[count($path) - 1])
		{
			$class .= ' active';
		}
		elseif (in_array($aliasToId, $menu->path))
		{
			$class .= ' alias-parent-active';
		}
	}

	if ($item->type == 'separator')
	{
		$class .= ' divider';
	}

	if ($item->deeper)
	{
		$class .= ' dropdown-submenu';
	}

	if ($item->parent)
	{
		$class .= ' parent';
	}

	if (!empty($class))
	{
		$class = ' class="' . trim($class) . '"';
	}

	echo '<li' . $class . '>';

	// Render the menu item.
	switch ($item->type) :
		case 'separator':
		case 'url':
		case 'component':
		case 'heading':
			require JModuleHelper::getLayoutPath('mod_menu', 'default_' . $item->type);
			break;

		default:
			require JModuleHelper::getLayoutPath('mod_menu', 'default_url');
			break;
	endswitch;

	// The next item is deeper.
	if ($item->deeper)
	{
		echo '<ul class="dropdown-menu">';
	}
	elseif ($item->shallower)
	{
		// The next item is shallower.
		echo '</li>';
		echo str_repeat('</ul></li>', $item->level_diff);
	}
	else
	{
		// The next item is on the same level.
		echo '</li>';
	}
}
?></ul>
</div>