<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 * 
 * Warning : can be used both from Frontend or Backend.
 * All the files from libraygalleryview are copied once in the /components/com_nge/views directory 
 * and once in the /administrator/components/com_nge/views directory
 * Due to internal login limitations :
 * When Front editing : the current user is logged only front
 * When Back editing : the current user is logged only back
 * So the view is duplicated, but then calls common front helpers and font parts
 
 * 
 */

// No direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.view');

/**
 * View to edit
 */
class NgeViewConfig extends JViewLegacy
{
	protected $state;
	protected $item;
	protected $form;

	/**
	 * Display the view
	 */
	public function display($tpl = null)
	{		
		// if in admin, load front component lang file
		$app = JFactory::getApplication();
		
		if($app->isAdmin()) {
			$lang = JFactory::getLanguage();
			$lang->load('com_nge',JPATH_SITE);
		}
		/* Loading language preview (for timeout message) */
			$lang = JFactory::getLanguage();
			$lang->load('com_nge_preview', JPATH_SITE);

	    //Editing params 
		$user	= JFactory::getUser();
		//$params = JComponentHelper::getParams('com_nge');
		$this->editParams = new stdClass();
		//Searching jEasyStudio params for demo mode
		/*$db = JFactory::getDbo();
		$db->setQuery("SELECT enabled FROM #__extensions WHERE name = 'com_jeasystudio'");
		$jEasystudioEnabled = $db->loadResult();
		if ($jEasystudioEnabled) {
			$paramsJeasyStudio = JComponentHelper::getParams('com_jeasystudio');
			$this->editParams->demoMode = $paramsJeasyStudio->get('demo-mode',0);
		}
		else*/
			$this->editParams->demoMode = false;		
		
	            //$this->editParams->showPreview = $params->get('show-preview',1);
			$this->editParams->showPreview = true;
			if (isset($this->pk) && $this->pk != ''){ //Existing part
			$this->editParams->editContent = $user->authorise('core.edit.content','com_nge.part.'.$this->pk);
			$this->editParams->editOptions = $user->authorise('core.edit.options','com_nge.part.'.$this->pk);
			$this->editParams->editDisplay = $this->user->authorise('core.edit.display','com_nge.part.'.$this->pk);
			$this->editParams->editAccess = NGE::features('parts.access') && $this->user->authorise('core.edit.access','com_nge.part.'.$this->pk);
		}
		else { //New part
			$this->editParams->editContent = 1;
			$this->editParams->editOptions = 1;
			$this->editParams->editDisplay = 1;
			$this->editParams->editAccess = NGE::features('parts.access');
		}	
		$jinput = JFactory::getApplication()->input;
		$this->caller = 		$jinput->get('caller', '','string'); //Type of screen caller : for example tinymce for calling for tinymce screen
		$this->return = 		$jinput->get('return', '','string'); //Type of return format of the part preview
		$this->mode = 		$jinput->get('mode', '','string'); //Mode of the calling form : create (new part), edit (existing part), duplicate(part)		
		$this->plname = 		$jinput->get('plname', '','string'); //Creating new part with the library id
		$this->pk = 		$jinput->get('pk', '','int'); //Modifying existant part <ith the part id
		$this->medium = 		$jinput->get('medium', '','string'); //Destination of the new part : article, page, report, publication...
		$this->mediumId = 		$jinput->get('medium_id', '','int');
				
		// Get config screen
		require_once NGEPATH_HELPERS . '/ngepartshelper.php'; //Used in each config file to load the part form
		require_once NGEPATH_HELPERS . '/ngeparthelper.php'; //Used in each config file to load the part form
		require_once NGEPATH_HELPERS . '/ngecontenthelper.php'; //Used in each config file to load the part form		
		require_once NGEPATH_HELPERS . '/ngeconfighelper.php'; //Used in each config file to load the part form		

		//Get Current config param info if pk exist else it's a new one
		if(isset($this->pk) && $this->pk != ""){
			$this->part = NgePartsHelper::getPart('['.$this->pk.']');
		}else{
			$partLibrary = NgePartsHelper::getLibraryGallery($this->plname);
			$this->part = new stdClass();
			$this->part->title_library = $partLibrary->title;
			$this->part->version = $partLibrary->version;
		}

		//load general language files (part title)
//		$lang = JFactory::getLanguage();
//		$lang->load('com_nge',JPATH_SITE);

		//Load language file for this part
		if ($this->plname != '')
			NgePartsHelper::loadPackConfigLanguage($this->plname);
		else
			NgePartHelper::loadPartConfigLanguage($this->pk);
		
//$start = microtime(true); 
/*
		if ($this->getLayout() == 'display') //Only display part of the config form
			$this->configForm = NgeConfigHelper::getForm($_REQUEST, true, 'display');
		else //All config form	
			$this->configForm = NgeConfigHelper::getForm($_REQUEST);
*/

//$end = (microtime(true) - $start);
//echo "elapsed time: $end";
		//List of parent categories to display breadcrumb
		if ($this->plname != '')
			$this->categoriesPath = NgePartsHelper::getCategories($this->plname);
		else
			$this->categoriesPath = array();

		 // position if set in $_REQUEST when dropping a part in a module
		$this->position = $jinput->get('end_position','');
		$this->m_before_id = $jinput->get('m_before_id',0);
		parent::display($tpl);
	}

	

}
