<?php

/**
 * @version     1.0.0
 * @package     com_nge
 * @copyright   Copyright (C) 2014. Tous droits réservés.
 * @license     GNU General Public License version 2 ou version ultérieure ; Voir LICENSE.txt
 * @author      Bouillé <contact@nextgeneditor.com> - http://www.nextgeneditor.com
 *
 * * Warning : can be used both from Frontend or Backend.
 * All the files from libraygalleryview are copied once in the /components/com_nge/views directory 
 * and once in the /administrator/components/com_nge/views directory
 * Due to internal login limitations :
 * When Front editing : the current user is logged only front
 * When Back editing : the current user is logged only back
 * So the view is duplicated, but then calls common front helpers and font parts

 * 
 */
// No direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.view');

/**
 * View to edit
 */
class NgeViewEditor extends JViewLegacy {

    /**
     * Display the view
     */
    public function display($tpl = null) {
	//Editing params 
	$user = JFactory::getUser();
	$params = JComponentHelper::getParams('com_nge');

	$jinput = JFactory::getApplication()->input;
	$id = $jinput->get('id', '', 'int'); //Modifying existant part <ith the part id
	$this->source = $jinput->get('source', 'article', 'string');
	//$this->editor = $jinput->get('editor', '', 'string'); //Modifying existant part <ith the part id

	switch ($this->source){
	    case 'k2item' :
		include_once(JPATH_COMPONENT . '/classes/ngek2itemhelper.php');
		break;
	    default : //article
		include_once(JPATH_COMPONENT . '/classes/ngearticlehelper.php');
		break;
	}
		
	

	//Saving content
	if ($this->_layout == 'save'){
		//TODO checktoken
		$id = $_POST['a_id'];
		$content = $_POST['articletext'];
		if (isset($id) && $id != '')
		$result = NgeArticleHelper::saveContent($id, $content);
		//TODO return result
		/*
	    require_once('administrator/components/com_content/models/article.php');
	    $modelArticle = new ContentModelArticle();
	    $data = $_POST;
	    if ($modelArticle->save($data)){
	    
	    }*/
	}    

	//Saving SEO
	if ($this->_layout == 'saveseo'){
		//TODO checktoken
		$article_seo = $jinput->get('article',array() ,'array' );
        $result = false;
		if (isset($id) && $id != '')
			$result = NgeArticleHelper::saveSeo($id, $article_seo);
        
        if($result) {
            header('HTTP/1.1 200 OK');
        }   
        else {
            header('HTTP/1.1 500 Internal Server Error');
        } 
        exit();
		//TODO return result
		/*
	    require_once('administrator/components/com_content/models/article.php');
	    $modelArticle = new ContentModelArticle();
	    $data = $_POST;
	    if ($modelArticle->save($data)){
	    
	    }*/
	}    

	/*
	$db = JFactory::getDbo();

	// Build the query.
	$query = $db->getQuery(true)
		->select('introtext')
		->from('#__content')
		->where('id= ' . $id)
		->where('state = 1');

	$db->setQuery($query, 0, 1);
	
	$this->id = $id;
	$this->content = $db->loadResult();
	*/
	
	switch ($this->source){
	    case 'k2item':
		require_once(JPATH_ROOT.'/components/com_nge/helpers/data/k2/k2itemdriver.php');
		$item = NgeK2itemDriver::load($id);
		$this->content = $item->text;
		break;
	    default : //article
		require_once(JPATH_ROOT.'/components/com_nge/helpers/data/joomla/articledriver.php');
		$article = NgeJoomlaArticleDriver::load($id);
		$this->content = $article->text;
		break;
	}
	
	$this->id = $id;
	if ($this->_layout == 'display') {
		$params = new JObject();
		$params->set('mainbar', false);
		$this->content = JHtml::_('content.prepare', $this->content, $params);
	}	
	else { //Edit
		//It is our editing, we can render the parts. They will be editable in wyziwyg.
		require_once NGEPATH_HELPERS . '/ngecontenthelper.php';
		$this->content = NgeContentHelper::parse($this->content);
		
	}

	//$this->content = '';

	// if in admin, load front component lang file
	$app = JFactory::getApplication();
//print_r($this->_layout);
//	if ($this->editor == 'nge')
//	    parent::display($this->editor);
//	else
	    parent::display($tpl);
    }

}
